#ifndef __NM6408_IOCTL_H__
#define __NM6408_IOCTL_H__

#define NM6408_IOCTL_MAGIC	'N'

#define NM6408_DO_ACCESS	_IOWR(NM6408_IOCTL_MAGIC, 0, unsigned long)
#define NM6408_CFG_WIND		_IOWR(NM6408_IOCTL_MAGIC, 1, unsigned long)
#define NM6408_DO_INIT		_IOR(NM6408_IOCTL_MAGIC, 2, unsigned long)
#define NM6408_DO_RESET		_IO(NM6408_IOCTL_MAGIC, 3)

enum _nm6408_cmd {
	NM6408_READ	= 0,
	NM6408_WRITE	= 1
};

enum _nm6408_width {
	NM6408_WIDTH8	= 1,
	NM6408_WIDTH16	= 2,
	NM6408_WIDTH32	= 4
};

struct nm6408_access {
	__u32			offset;

	union {
		__u8		b8;
		__u16		b16;
		__u32		b32;
	} data;

	enum _nm6408_width	width;
	enum _nm6408_cmd	cmd;
};

enum _nm6408_cluster {
	NM6408_PC0	= 0,
	NM6408_PC1	= 1,
	NM6408_PC2	= 2,
	NM6408_PC3	= 3,
	NM6408_CCPU	= 4
};

struct nm6408_wind {
	__u32			addr;
	__u32			size;

	enum _nm6408_cluster	cluster;
	enum _nm6408_cmd	cmd;
};

struct nm6408_init_code {
	size_t	size;
	__u32	crc32;
	__u8	*data;
};

struct nm6408_magic {
	__u32	magic_addr;
	__u32	magic_code;
	__u32   version[2];
	__u32	serial[2];
	__u32	load_begin;
	__u32	load_limit;
	__u32	is_rumboot;
	__u32	data_point;
	__u32	post_test;
	__u32	post_addr;
	__u32	post_size;
} __attribute__ ((packed, aligned(4)));

struct nm6408_desc {
	__u32	is_ready;
	__u32	command;
	__u32	image[2];
	__u32	flash[2];
	__u32	entry;
	__u32	crc;
} __attribute__ ((packed, aligned(4)));

#define SWI_BOARD_RESET		1
#define SWI_BOARD_SUSPEND	2
#define SWI_BOARD_RESUME	4

#endif // __NM6408_IOCTL_H__
