#ifndef __NM6408_MAP_H__
#define __NM6408_MAP_H__

#define NM6408_INBOUND_AXI_SIZE		0x20000000
#define NM6408_INBOUND_AXI_NMB		5

#define NM6408_OUTBOUND_AXI_SIZE	0x20000000
#define NM6408_OUTBOUND_AXI_NMB		1

#define PCIE_OUTBOUND_AXI_BASE		0x40000000
#define PCIE_OUTBOUND_AXI_LIMIT		0x5FFFFFFF

#define CCPU_INBOUND_AXI_BASE		0x60000000
#define CCPU_INBOUND_AXI_LIMIT		0x7FFFFFFF

#define CCPU_CCMB_AXI_ADDR		0x00000000
#define CCPU_CCMB0_OFFSET		0x00000000
#define CCPU_CCMB1_OFFSET		0x00020000
#define CCPU_CCMB2_OFFSET		0x00040000
#define CCPU_CCMB3_OFFSET		0x00060000
#define CCPU_CCMB_AXI_SIZE		0x00080000

#define CCPU_REG_AXI_ADDR		0x00080000
#define CCPU_REG_AXI_SIZE		0x00080000

#define CCPU_EMI_AXI_ADDR		0x00100000
#define CCPU_EMI_AXI_SIZE		0x1FF00000

#define PC0_INBOUND_AXI_BASE		0x80000000
#define PC0_INBOUND_AXI_LIMIT		0x9FFFFFFF

#define PC1_INBOUND_AXI_BASE		0xA0000000
#define PC1_INBOUND_AXI_LIMIT		0xBFFFFFFF

#define PC2_INBOUND_AXI_BASE		0xC0000000
#define PC2_INBOUND_AXI_LIMIT		0xDFFFFFFF

#define PC3_INBOUND_AXI_BASE		0xE0000000
#define PC3_INBOUND_AXI_LIMIT		0xFFFFFFFF

#define PC_CMB_AXI_ADDR			0x00000000
#define PC_CMB0_OFFSET			0x00000000
#define PC_CMB1_OFFSET			0x00010000
#define PC_CMB2_OFFSET			0x00020000
#define PC_CMB3_OFFSET			0x00030000
#define PC_CMB_AXI_SIZE			0x00040000

#define PC_RESERVE_AXI_ADDR		0x00040000
#define PC_RESERVE_AXI_SIZE		0x00040000

#define PC_REG_AXI_ADDR			0x00080000
#define PC_REG_AXI_SIZE			0x00080000

#define PC_NMPU_AXI_ADDR		0x00100000
#define PC_NMPU0_OFFSET			0x00000000
#define PC_NMPU1_OFFSET			0x00080000
#define PC_NMPU2_OFFSET			0x00100000
#define PC_NMPU3_OFFSET			0x00180000
#define PC_NMPU_AXI_SIZE		0x00200000

#define PC_EMI_AXI_ADDR			0x00300000
#define PC_EMI_AXI_SIZE			0x1FD00000

#define NMPU_NMMB_AXI_ADDR		0x00000000
#define NMPU_NMMB0_OFFSET		0x00000000
#define NMPU_NMMB1_OFFSET		0x00010000
#define NMPU_NMMB2_OFFSET		0x00020000
#define NMPU_NMMB3_OFFSET		0x00030000
#define NMPU_NMMB4_OFFSET		0x00040000
#define NMPU_NMMB5_OFFSET		0x00050000
#define NMPU_NMMB6_OFFSET		0x00060000
#define NMPU_NMMB7_OFFSET		0x00070000
#define NMPU_NMMB_AXI_SIZE		0x00080000

#define NMPU0_NMMB_TO_PC(addr)		(((addr) - NMPU_NMMB_AXI_ADDR) + \
					(PC_NMPU_AXI_ADDR + PC_NMPU0_OFFSET))
#define NMPU1_NMMB_TO_PC(addr)		(((addr) - NMPU_NMMB_AXI_ADDR) + \
					(PC_NMPU_AXI_ADDR + PC_NMPU1_OFFSET))
#define NMPU2_NMMB_TO_PC(addr)		(((addr) - NMPU_NMMB_AXI_ADDR) + \
					(PC_NMPU_AXI_ADDR + PC_NMPU2_OFFSET))
#define NMPU3_NMMB_TO_PC(addr)		(((addr) - NMPU_NMMB_AXI_ADDR) + \
					(PC_NMPU_AXI_ADDR + PC_NMPU3_OFFSET))

#define NMPU_REG_AXI_ADDR		0x00080000
#define NMPU_REG_AXI_SIZE		0x00080000

#define NMPU_NMPU_AXI_ADDR		0x00100000
#define NMPU_NMPU0_OFFSET		0x00000000
#define NMPU_NMPU1_OFFSET		0x00080000
#define NMPU_NMPU2_OFFSET		0x00100000
#define NMPU_NMPU3_OFFSET		0x00180000
#define NMPU_NMPU_AXI_SIZE		0x00200000

#define NMPU_NMPU_TO_PC(addr)		(((addr) - NMPU_NMPU_AXI_ADDR) + PC_NMPU_AXI_ADDR)

#define NMPU_CMB_AXI_ADDR		0x00300000
#define NMPU_CMB0_OFFSET		0x00000000
#define NMPU_CMB1_OFFSET		0x00010000
#define NMPU_CMB2_OFFSET		0x00020000
#define NMPU_CMB3_OFFSET		0x00030000
#define NMPU_CMB_AXI_SIZE		0x00040000

#define NMPU_CMB_TO_PC(addr)		(((addr) - NMPU_CMB_AXI_ADDR) + PC_CMB_AXI_ADDR)

#define NMPU_EMI_AXI_ADDR		0x00340000
#define NMPU_EMI_AXI_SIZE		0x1FCC0000

#define NMPU_EMI_TO_PC(addr)		(addr)

#define NM6408_INTERNEL_ADDR		(CCPU_CCMB_AXI_ADDR + CCPU_CCMB3_OFFSET)
#define NM6408_INTERNEL_SIZE		(CCPU_CCMB_AXI_SIZE - CCPU_CCMB3_OFFSET)

#endif // __NM6408_MAP_H__
