#include "ddr_reg.h"

#if 1
#include "ddr_settings_mt_8_11_800.h"
#else
#include "ddr_settings_mt_8_7_533.h"
#endif

void EMIC_init(unsigned int base)
{
    if (rgDENALI_CTL_00(base) & 0x1)
        return;

    rgDENALI_CTL_00(base) = DENALI_CTL_00_DATA   ; // VERSION:RD:16:16:=0x0000 DRAM_CLASS:RW:8:4:=0x06 START:RW:0:1:=0x00
    rgDENALI_CTL_01(base) = DENALI_CTL_01_DATA   ; // READ_DATA_FIFO_DEPTH:RD:24:8:=0x00 MAX_CS_REG:RD:16:1:=0x00 MAX_COL_REG:RD:8:4:=0x00 MAX_ROW_REG:RD:0:4:=0x00
    rgDENALI_CTL_02(base) = DENALI_CTL_02_DATA   ; // MEMCD_RMODW_FIFO_DEPTH:RD:24:8:=0x00 WRITE_DATA_FIFO_PTR_WIDTH:RD:16:8:=0x00 WRITE_DATA_FIFO_DEPTH:RD:8:8:=0x00 READ_DATA_FIFO_PTR_WIDTH:RD:0:8:=0x00
    rgDENALI_CTL_03(base) = DENALI_CTL_03_DATA   ; // AXI0_RDFIFO_LOG2_DEPTH:RD:24:8:=0x00 AXI0_CMDFIFO_LOG2_DEPTH:RD:16:8:=0x00 ASYNC_CDC_STAGES:RD:8:8:=0x00 MEMCD_RMODW_FIFO_PTR_WIDTH:RD:0:8:=0x00
    rgDENALI_CTL_04(base) = DENALI_CTL_04_DATA   ; // AXI0_WRCMD_PROC_FIFO_LOG2_DEPTH:RD:8:8:=0x00 AXI0_WRFIFO_LOG2_DEPTH:RD:0:8:=0x00
    rgDENALI_CTL_05(base) = DENALI_CTL_05_DATA   ; // TINIT:RW:0:24:=0x000008
    rgDENALI_CTL_06(base) = DENALI_CTL_06_DATA   ; // TRST_PWRON:RW:0:32:=0x000000a0
    rgDENALI_CTL_07(base) = DENALI_CTL_07_DATA   ; // CKE_INACTIVE:RW:0:32:=0x00000190
    rgDENALI_CTL_08(base) = DENALI_CTL_08_DATA   ; // TBST_INT_INTERVAL:RW:24:3:=0x04 ADDITIVE_LAT:RW:16:5:=0x00 WRLAT:RW:8:5:=0x08 CASLAT_LIN:RW:0:6:=0x10
    rgDENALI_CTL_09(base) = DENALI_CTL_09_DATA   ; // TRAS_MIN:RW:24:8:=0x1c TRC:RW:16:8:=0x24 TRRD:RW:8:8:=0x05 TCCD:RW:0:5:=0x04
    rgDENALI_CTL_10(base) = DENALI_CTL_10_DATA   ; // TRTP:RW:24:8:=0x06 TFAW:RW:16:8:=0x20 TRP:RW:8:8:=0x08 TWTR:RW:0:6:=0x06
    rgDENALI_CTL_11(base) = DENALI_CTL_11_DATA   ; // TMOD:RW:8:8:=0x0c TMRD:RW:0:8:=0x04
    rgDENALI_CTL_12(base) = DENALI_CTL_12_DATA   ; // TCKE:RW:24:3:=0x04 TRAS_MAX:RW:0:17:=0x00db60
    rgDENALI_CTL_13(base) = DENALI_CTL_13_DATA   ; // TWR:RW:24:6:=0x0c TRCD:RW:16:8:=0x08 WRITEINTERP:RW:8:1:=0x00 TCKESR:RW:0:8:=0x05
    rgDENALI_CTL_14(base) = DENALI_CTL_14_DATA   ; // TDAL:RW:24:8:=0x14 TRAS_LOCKOUT:RW:16:1:=0x01 CONCURRENTAP:RW:8:1:=0x01 AP:RW:0:1:=0x00
    rgDENALI_CTL_15(base) = DENALI_CTL_15_DATA   ; // OPTIMAL_RMODW_EN:RW:24:1:=0x00 REG_DIMM_ENABLE:RW:16:1:=0x00 TRP_AB:RW:8:8:=0x08 BSTLEN:RW_D:0:3:=0x03
    rgDENALI_CTL_16(base) = DENALI_CTL_16_DATA   ; // RESERVED:RW:24:1:=0x00 AREFRESH:WR:16:1:=0x00 RESERVED:RW:8:1:=0x00 RESERVED:RW:0:1:=0x01
    rgDENALI_CTL_17(base) = DENALI_CTL_17_DATA   ; // TRFC:RW:8:10:=0x00d0 TREF_ENABLE:RW:0:1:=0x01
    rgDENALI_CTL_18(base) = DENALI_CTL_18_DATA   ; // TREF:RW:0:14:=0x1858
    rgDENALI_CTL_19(base) = DENALI_CTL_19_DATA   ; // TXPDLL:RW:16:16:=0x0014 TPDEX:RW:0:16:=0x0005
    rgDENALI_CTL_20(base) = DENALI_CTL_20_DATA   ; // TXSNR:RW:16:16:=0x00d8 TXSR:RW:0:16:=0x0200
    rgDENALI_CTL_21(base) = DENALI_CTL_21_DATA   ; // CKE_DELAY:RW:24:3:=0x03 ENABLE_QUICK_SREFRESH:RW:16:1:=0x01 RESERVED:RW:8:1:=0x00 PWRUP_SREFRESH_EXIT:RW:0:1:=0x00
    rgDENALI_CTL_22(base) = DENALI_CTL_22_DATA   ; // LP_CMD:WR:24:8:=0x00 CKSRX:RW:16:8:=0x08 CKSRE:RW:8:8:=0x08 LOWPOWER_REFRESH_ENABLE:RW:0:1:=0x00
    rgDENALI_CTL_23(base) = DENALI_CTL_23_DATA   ; // LPI_TIMER_WAKEUP:RW:24:4:=0x07 LPI_SR_MCCLK_GATE_WAKEUP:RW:16:4:=0x03 LPI_SR_WAKEUP:RW:8:4:=0x02 LPI_PD_WAKEUP:RW:0:4:=0x00
    rgDENALI_CTL_24(base) = DENALI_CTL_24_DATA   ; // LPI_TIMER_COUNT:RW:8:12:=0x0003 LPI_WAKEUP_EN:RW:0:5:=0x1f
    rgDENALI_CTL_25(base) = DENALI_CTL_25_DATA   ; // LP_STATE:RD:24:6:=0x00 TDFI_LP_RESP:RW:16:3:=0x07 LPI_WAKEUP_TIMEOUT:RW:0:12:=0x0004
    rgDENALI_CTL_26(base) = DENALI_CTL_26_DATA   ; // LP_AUTO_MEM_GATE_EN:RW:24:2:=0x00 LP_AUTO_EXIT_EN:RW:16:3:=0x00 LP_AUTO_ENTRY_EN:RW:8:3:=0x00 LP_ARB_STATE:RD:0:4:=0x00
    rgDENALI_CTL_27(base) = DENALI_CTL_27_DATA   ; // LP_AUTO_SR_MC_GATE_IDLE:RW:24:8:=0x00 LP_AUTO_SR_IDLE:RW:16:8:=0x00 LP_AUTO_PD_IDLE:RW:0:12:=0x0000
    rgDENALI_CTL_28(base) = DENALI_CTL_28_DATA   ; // RESERVED:RW:0:7:=0x00
    rgDENALI_CTL_29(base) = DENALI_CTL_29_DATA   ; // WRITE_MODEREG:RW+:0:27:=0x00000000
    rgDENALI_CTL_30(base) = DENALI_CTL_30_DATA   ; // MR0_DATA_0:RW:8:15:=0x0c40 MRW_STATUS:RD:0:8:=0x00
    rgDENALI_CTL_31(base) = DENALI_CTL_31_DATA   ; // MR2_DATA_0:RW:16:15:=0x0018 MR1_DATA_0:RW:0:15:=0x0046
    rgDENALI_CTL_32(base) = DENALI_CTL_32_DATA   ; // MR3_DATA_0:RW:16:15:=0x0000 MRSINGLE_DATA_0:RW:0:15:=0x0000
    rgDENALI_CTL_33(base) = DENALI_CTL_33_DATA   ; // ZQINIT:RW_D:8:12:=0x0200 LONG_COUNT_MASK:RW:0:5:=0x00
    rgDENALI_CTL_34(base) = DENALI_CTL_34_DATA   ; // ZQCS:RW:16:12:=0x0040 ZQCL:RW:0:12:=0x0100
    rgDENALI_CTL_35(base) = DENALI_CTL_35_DATA   ; // ZQ_ON_SREF_EXIT:RW:8:2:=0x02 ZQ_REQ:WR:0:2:=0x00
    rgDENALI_CTL_36(base) = DENALI_CTL_36_DATA   ; // ZQ_INTERVAL:RW:0:32:=0x00000040
    rgDENALI_CTL_37(base) = DENALI_CTL_37_DATA   ; // COL_DIFF:RW:24:4:=0x00 ROW_DIFF:RW:16:3:=0x00 RESERVED:RW:8:2:=0x00 ZQ_IN_PROGRESS:RD:0:1:=0x00
    rgDENALI_CTL_38(base) = DENALI_CTL_38_DATA   ; // AGE_COUNT:RW:24:8:=0xff APREBIT:RW_D:16:4:=0x0a BANK_ADDR_INTLV_EN:RW:8:1:=0x00 BANK_START_BIT:RW:0:5:=0x00
    rgDENALI_CTL_39(base) = DENALI_CTL_39_DATA   ; // BANK_SPLIT_EN:RW:24:1:=0x01 RESERVED:RW:16:1:=0x01 ADDR_CMP_EN:RW:8:1:=0x01 COMMAND_AGE_COUNT:RW:0:8:=0xff
    rgDENALI_CTL_40(base) = DENALI_CTL_40_DATA   ; // RW_SAME_PAGE_EN:RW:24:1:=0x01 RW_SAME_EN:RW:16:1:=0x01 PRIORITY_EN:RW:8:1:=0x01 PLACEMENT_EN:RW:0:1:=0x01
    rgDENALI_CTL_41(base) = DENALI_CTL_41_DATA   ; // DISABLE_RD_INTERLEAVE:RW:24:1:=0x00 SWAP_EN:RW:16:1:=0x01 NUM_Q_ENTRIES_ACT_DISABLE:RW:8:3:=0x03 DISABLE_RW_GROUP_W_BNK_CONFLICT:RW:0:2:=0x01
    rgDENALI_CTL_42(base) = DENALI_CTL_42_DATA   ; // Q_FULLNESS:RW:24:3:=0x00 REDUC:RW:16:1:=0x00 BURST_ON_FLY_BIT:RW:8:4:=0x0c INHIBIT_DRAM_CMD:RW:0:1:=0x00
    rgDENALI_CTL_43(base) = DENALI_CTL_43_DATA   ; // CTRLUPD_REQ_PER_AREF_EN:RW:24:1:=0x01 CTRLUPD_REQ:WR:16:1:=0x00 CONTROLLER_BUSY:RD:8:1:=0x00 IN_ORDER_ACCEPT:RW:0:1:=0x00
    rgDENALI_CTL_44(base) = DENALI_CTL_44_DATA   ; // DFI_ERROR_INFO:RD:8:20:=0x000000 DFI_ERROR:RD:0:5:=0x00
    rgDENALI_CTL_45(base) = DENALI_CTL_45_DATA   ; // INT_STATUS:RD:8:23:=0x000000 RESERVED:RW+:0:1:=0x00
    rgDENALI_CTL_46(base) = DENALI_CTL_46_DATA   ; // INT_ACK:WR:0:22:=0x000000
    rgDENALI_CTL_47(base) = DENALI_CTL_47_DATA   ; // INT_MASK:RW:0:23:=0x000000
    rgDENALI_CTL_48(base) = DENALI_CTL_48_DATA   ; // OUT_OF_RANGE_ADDR:RD:0:30:=0x00000000
    rgDENALI_CTL_49(base) = DENALI_CTL_49_DATA   ; // OUT_OF_RANGE_SOURCE_ID:RD:16:16:=0x0000 OUT_OF_RANGE_TYPE:RD:8:7:=0x00 OUT_OF_RANGE_LENGTH:RD:0:7:=0x00
    rgDENALI_CTL_50(base) = DENALI_CTL_50_DATA   ; // PORT_CMD_ERROR_ADDR:RD:0:30:=0x00000000
    rgDENALI_CTL_51(base) = DENALI_CTL_51_DATA   ; // TODTL_2CMD:RW:24:8:=0x07 PORT_CMD_ERROR_TYPE:RD:16:2:=0x00 PORT_CMD_ERROR_ID:RD:0:16:=0x0000
    rgDENALI_CTL_52(base) = DENALI_CTL_52_DATA   ; // R2R_SAMECS_DLY:RW:24:5:=0x00 RESERVED:RW:16:5:=0x00 ODT_EN:RW:8:1:=0x01 TODTH_WR:RW:0:4:=0x06
    rgDENALI_CTL_53(base) = DENALI_CTL_53_DATA   ; // SW_LEVELING_MODE:RW:24:3:=0x00 W2W_SAMECS_DLY:RW:16:5:=0x00 W2R_SAMECS_DLY:RW:8:5:=0x00 R2W_SAMECS_DLY:RW_D:0:5:=0x02
    rgDENALI_CTL_54(base) = DENALI_CTL_54_DATA   ; // SWLVL_OP_DONE:RD:24:1:=0x00 SWLVL_EXIT:WR:16:1:=0x00 SWLVL_START:WR:8:1:=0x00 SWLVL_LOAD:WR:0:1:=0x00
    rgDENALI_CTL_55(base) = DENALI_CTL_55_DATA   ; // SWLVL_RESP_3:RD:24:1:=0x00 SWLVL_RESP_2:RD:16:1:=0x00 SWLVL_RESP_1:RD:8:1:=0x00 SWLVL_RESP_0:RD:0:1:=0x00
    rgDENALI_CTL_56(base) = DENALI_CTL_56_DATA   ; // WLMRD:RW:24:6:=0x28 WLDQSEN:RW:16:6:=0x0d WRLVL_CS:RW:8:1:=0x00 WRLVL_REQ:WR:0:1:=0x00
    rgDENALI_CTL_57(base) = DENALI_CTL_57_DATA   ; // DFI_PHY_WRLVL_MODE:RW:24:1:=0x01 WRLVL_INTERVAL:RW:8:16:=0x0000 WRLVL_EN:RW:0:1:=0x00
    rgDENALI_CTL_58(base) = DENALI_CTL_58_DATA   ; // WRLVL_AREF_EN:RW:24:1:=0x01 WRLVL_RESP_MASK:RW:16:4:=0x00 WRLVL_ON_SREF_EXIT:RW:8:1:=0x00 WRLVL_PERIODIC:RW:0:1:=0x00
    rgDENALI_CTL_59(base) = DENALI_CTL_59_DATA   ; // RDLVL_CS:RW:24:1:=0x00 RDLVL_GATE_REQ:WR:16:1:=0x00 RDLVL_REQ:WR:8:1:=0x00 WRLVL_ERROR_STATUS:RD:0:2:=0x00
    rgDENALI_CTL_60(base) = DENALI_CTL_60_DATA   ; // DFI_PHY_RDLVL_GATE_MODE:RW:24:1:=0x01 DFI_PHY_RDLVL_MODE:RW:16:1:=0x01 RDLVL_GATE_SEQ_EN:RW:8:1:=0x00 RDLVL_SEQ_EN:RW:0:1:=0x00
    rgDENALI_CTL_61(base) = DENALI_CTL_61_DATA   ; // RDLVL_GATE_ON_SREF_EXIT:RW:24:1:=0x00 RDLVL_GATE_PERIODIC:RW:16:1:=0x00 RDLVL_ON_SREF_EXIT:RW:8:1:=0x00 RDLVL_PERIODIC:RW:0:1:=0x00
    rgDENALI_CTL_62(base) = DENALI_CTL_62_DATA   ; // AXI0_R_PRIORITY:RW:24:1:=0x01 AXI0_FIXED_PORT_PRIORITY_ENABLE:RW:16:1:=0x00 AXI0_ALL_STROBES_USED_ENABLE:RW:8:1:=0x00 RDLVL_AREF_EN:RW:0:1:=0x01
    rgDENALI_CTL_63(base) = DENALI_CTL_63_DATA   ; // MEM_RST_VALID:RD:24:1:=0x00 CKE_STATUS:RD:16:1:=0x00 AXI0_FIFO_TYPE_REG:RW:8:2:=0x00 AXI0_W_PRIORITY:RW:0:1:=0x01
    rgDENALI_CTL_64(base) = DENALI_CTL_64_DATA   ; // TDFI_PHY_WRLAT:RD:24:6:=0x00 DLL_RST_ADJ_DLY:RW:16:8:=0x00 DLL_RST_DELAY:RW:0:16:=0x0000
    rgDENALI_CTL_65(base) = DENALI_CTL_65_DATA   ; // DRAM_CLK_DISABLE:RW:24:1:=0x00 TDFI_RDDATA_EN:RD:16:6:=0x00 TDFI_PHY_RDLAT:RW_D:8:6:=0x17 UPDATE_ERROR_STATUS:RD:0:7:=0x00
    rgDENALI_CTL_66(base) = DENALI_CTL_66_DATA   ; // TDFI_CTRLUPD_MAX:RW:8:14:=0x30b0 TDFI_CTRLUPD_MIN:RW:0:4:=0x05
    rgDENALI_CTL_67(base) = DENALI_CTL_67_DATA   ; // TDFI_PHYUPD_TYPE1:RW:16:16:=0x0200 TDFI_PHYUPD_TYPE0:RW:0:16:=0x0200
    rgDENALI_CTL_68(base) = DENALI_CTL_68_DATA   ; // TDFI_PHYUPD_TYPE3:RW:16:16:=0x0200 TDFI_PHYUPD_TYPE2:RW:0:16:=0x0200
    rgDENALI_CTL_69(base) = DENALI_CTL_69_DATA   ; // TDFI_PHYUPD_RESP:RW:0:14:=0x30b0
    rgDENALI_CTL_70(base) = DENALI_CTL_70_DATA   ; // TDFI_CTRLUPD_INTERVAL:RW:0:32:=0x0001e6e0
    rgDENALI_CTL_71(base) = DENALI_CTL_71_DATA   ; // TDFI_DRAM_CLK_DISABLE:RW:24:4:=0x02 TDFI_CTRL_DELAY:RW_D:16:4:=0x02 WRLAT_ADJ:RW:8:6:=0x07 RDLAT_ADJ:RW:0:6:=0x06
    rgDENALI_CTL_72(base) = DENALI_CTL_72_DATA   ; // TDFI_WRLVL_WW:RW:16:10:=0x0014 TDFI_WRLVL_EN:RW:8:8:=0x03 TDFI_DRAM_CLK_ENABLE:RW:0:4:=0x03
    rgDENALI_CTL_73(base) = DENALI_CTL_73_DATA   ; // TDFI_WRLVL_RESP:RW:0:32:=0x00000000
    rgDENALI_CTL_74(base) = DENALI_CTL_74_DATA   ; // TDFI_WRLVL_MAX:RW:0:32:=0x00000000
    rgDENALI_CTL_75(base) = DENALI_CTL_75_DATA   ; // TDFI_RDLVL_RR:RW:8:10:=0x0014 TDFI_RDLVL_EN:RW:0:8:=0x03
    rgDENALI_CTL_76(base) = DENALI_CTL_76_DATA   ; // TDFI_RDLVL_RESP:RW:0:32:=0x000007d0
    rgDENALI_CTL_77(base) = DENALI_CTL_77_DATA   ; // RDLVL_GATE_EN:RW:16:1:=0x00 RDLVL_EN:RW:8:1:=0x00 RDLVL_RESP_MASK:RW:0:4:=0x00
    rgDENALI_CTL_78(base) = DENALI_CTL_78_DATA   ; // TDFI_RDLVL_MAX:RW:0:32:=0x00000000
    rgDENALI_CTL_79(base) = DENALI_CTL_79_DATA   ; // RDLVL_INTERVAL:RW:8:16:=0x0000 RDLVL_ERROR_STATUS:RD:0:2:=0x00
    rgDENALI_CTL_80(base) = DENALI_CTL_80_DATA   ; // TDFI_RDCSLAT:RW:24:6:=0x07 TDFI_PHY_WRDATA:RW:16:3:=0x01 RDLVL_GATE_INTERVAL:RW:0:16:=0x0000
    rgDENALI_CTL_81(base) = DENALI_CTL_81_DATA   ; // TDFI_WRCSLAT:RW:0:6:=0x06
                       
    rgDENALI_PHY_00(base) = DENALI_PHY_00_DATA   ; // PHY_DQ_DM_SWIZZLE00:RW:0:32:=0x76543210
    rgDENALI_PHY_01(base) = DENALI_PHY_01_DATA   ; // PHY_CLK_WR_BYPASS_SLAVE_DELAY_0:RW:8:11:=0x04c0 PHY_DQ_DM_SWIZZLE10:RW:0:4:=0x08
    rgDENALI_PHY_02(base) = DENALI_PHY_02_DATA   ; // PHY_SW_WRDQ0SHIFT_0:RW:24:5:=0x00 PHY_CLK_BYPASS_OVERRIDE_0:RW:16:1:=0x00 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_0:RW:0:10:=0x0099
    rgDENALI_PHY_03(base) = DENALI_PHY_03_DATA   ; // PHY_SW_WRDQ4_SHIFT_0:RW:24:5:=0x00 PHY_SW_WRDQ3_SHIFT_0:RW:16:5:=0x00 PHY_SW_WRDQ2_SHIFT_0:RW:8:5:=0x00 PHY_SW_WRDQ1SHIFT_0:RW:0:5:=0x00
    rgDENALI_PHY_04(base) = DENALI_PHY_04_DATA   ; // PHY_SW_WRDM_SHIFT_0:RW:24:5:=0x00 PHY_SW_WRDQ7_SHIFT_0:RW:16:5:=0x00 PHY_SW_WRDQ6_SHIFT_0:RW:8:5:=0x00 PHY_SW_WRDQ5_SHIFT_0:RW:0:5:=0x00
    rgDENALI_PHY_05(base) = DENALI_PHY_05_DATA   ; // PHY_DQ_TSEL_ENABLE_0:RW:8:3:=0x01 PHY_SW_WRDQS_SHIFT_0:RW:0:4:=0x00
    rgDENALI_PHY_06(base) = DENALI_PHY_06_DATA   ; // PHY_DQS_TSEL_ENABLE_0:RW:24:3:=0x01 PHY_DQ_TSEL_SELECT_0:RW:0:24:=0x665555
    rgDENALI_PHY_07(base) = DENALI_PHY_07_DATA   ; // PHY_LPBK_CONTROL_0:RW:24:8:=0x00 PHY_DQS_TSEL_SELECT_0:RW:0:24:=0x665555
    rgDENALI_PHY_08(base) = DENALI_PHY_08_DATA   ; // PHY_AUTO_TIMING_MARGIN_CONTROL_0:RW:0:32:=0x00000000
    rgDENALI_PHY_09(base) = DENALI_PHY_09_DATA   ; // PHY_AUTO_TIMING_MARGIN_OBS_0:RD:0:28:=0x00000000
    rgDENALI_PHY_10(base) = DENALI_PHY_10_DATA   ; // PHY_PRBS_PATTERN_MASK_0:RW:16:9:=0x0000 PHY_PRBS_PATTERN_START_0:RW_D:8:7:=0x01 PHY_SLICE_PWR_RDC_DISABLE_0:RW:0:1:=0x00
    rgDENALI_PHY_11(base) = DENALI_PHY_11_DATA   ; // SC_PHY_SNAP_OBS_REGS_0:WR:24:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_0:RW:16:5:=0x17 PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_0:RW:0:10:=0x00c0
    rgDENALI_PHY_12(base) = DENALI_PHY_12_DATA   ; // PHY_RDDQ_ENC_OBS_SELECT_0:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_0:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_0:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_0:RW:0:3:=0x00
    rgDENALI_PHY_13(base) = DENALI_PHY_13_DATA   ; // PHY_FIFO_PTR_OBS_SELECT_0:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_0:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_0:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_0:RW:0:4:=0x00
    rgDENALI_PHY_14(base) = DENALI_PHY_14_DATA   ; // PHY_WRLVL_UPDT_WAIT_CNT_0:RW:24:4:=0x04 PHY_WRLVL_CAPTURE_CNT_0:RW:16:6:=0x08 SC_PHY_LVL_DEBUG_CONT_0:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_0:RW:0:1:=0x00
    rgDENALI_PHY_15(base) = DENALI_PHY_15_DATA   ; // PHY_RDLVL_UPDT_WAIT_CNT_0:RW:24:4:=0x04 PHY_RDLVL_CAPTURE_CNT_0:RW:16:6:=0x08 PHY_GTLVL_UPDT_WAIT_CNT_0:RW:8:4:=0x04 PHY_GTLVL_CAPTURE_CNT_0:RW:0:6:=0x00
    rgDENALI_PHY_16(base) = DENALI_PHY_16_DATA   ; // SC_PHY_MANUAL_CLEAR_0:WR:24:5:=0x00 PHY_RDLVL_DATA_MASK_0:RW:16:8:=0x00 PHY_RDLVL_RDDQS_DQ_OBS_SELECT_0:RW:8:4:=0x00 PHY_RDLVL_OP_MODE_0:RW:0:2:=0x00
    rgDENALI_PHY_17(base) = DENALI_PHY_17_DATA   ; // PHY_FIFO_PTR_OBS_0:RD:0:8:=0x00
    rgDENALI_PHY_18(base) = DENALI_PHY_18_DATA   ; // PHY_LPBK_RESULT_OBS_0:RD:0:32:=0x00000000
    rgDENALI_PHY_19(base) = DENALI_PHY_19_DATA   ; // PHY_MASTER_DLY_LOCK_OBS_0:RD:16:10:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_0:RD:0:16:=0x0000
    rgDENALI_PHY_20(base) = DENALI_PHY_20_DATA   ; // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_0:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_0:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_0:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_0:RD:0:6:=0x00
    rgDENALI_PHY_21(base) = DENALI_PHY_21_DATA   ; // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_0:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_0:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_0:RD:0:10:=0x0000
    rgDENALI_PHY_22(base) = DENALI_PHY_22_DATA   ; // PHY_WRLVL_HARD0DELAY_OBS_0:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_0:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_0:RD:0:8:=0x00
    rgDENALI_PHY_23(base) = DENALI_PHY_23_DATA   ; // PHY_WRLVL_HARD1DELAY_OBS_0:RD:0:10:=0x0000
    rgDENALI_PHY_24(base) = DENALI_PHY_24_DATA   ; // PHY_WRLVL_STATUS_OBS_0:RD:0:17:=0x000000
    rgDENALI_PHY_25(base) = DENALI_PHY_25_DATA   ; // PHY_GTLVL_HARD1DELAY_OBS_0:RD:16:14:=0x0000 PHY_GTLVL_HARD0DELAY_OBS_0:RD:0:14:=0x0000
    rgDENALI_PHY_26(base) = DENALI_PHY_26_DATA   ; // PHY_GTLVL_STATUS_OBS_0:RD:0:18:=0x000000
    rgDENALI_PHY_27(base) = DENALI_PHY_27_DATA   ; // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_0:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_0:RD:0:10:=0x0000
    rgDENALI_PHY_28(base) = DENALI_PHY_28_DATA   ; // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_0:RD:0:2:=0x00
    rgDENALI_PHY_29(base) = DENALI_PHY_29_DATA   ; // PHY_RDLVL_STATUS_OBS_0:RD:0:32:=0x00000000
    rgDENALI_PHY_30(base) = DENALI_PHY_30_DATA   ; // PHY_DDL_MODE_0:RW:0:18:=0x000000
    rgDENALI_PHY_31(base) = DENALI_PHY_31_DATA   ; // PHY_DDL_TEST_OBS_0:RD:0:32:=0x00000000
    rgDENALI_PHY_32(base) = DENALI_PHY_32_DATA   ; // PHY_DDL_TEST_MSTR_DLY_OBS_0:RD:0:32:=0x00000000
    rgDENALI_PHY_33(base) = DENALI_PHY_33_DATA   ; // PHY_RX_CAL_SAMPLE_WAIT_0:RW:24:8:=0x20 PHY_RX_CAL_OVERRIDE_0:RW:16:1:=0x00 SC_PHY_RX_CAL_START_0:WR:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_0:RW:0:8:=0x04
    rgDENALI_PHY_34(base) = DENALI_PHY_34_DATA   ; // PHY_RX_CAL_DQ10:RW+:16:12:=0x0000 PHY_RX_CAL_DQ00:RW+:0:12:=0x0000
    rgDENALI_PHY_35(base) = DENALI_PHY_35_DATA   ; // PHY_RX_CAL_DQ3_0:RW+:16:12:=0x0000 PHY_RX_CAL_DQ2_0:RW+:0:12:=0x0000
    rgDENALI_PHY_36(base) = DENALI_PHY_36_DATA   ; // PHY_RX_CAL_DQ5_0:RW+:16:12:=0x0000 PHY_RX_CAL_DQ4_0:RW+:0:12:=0x0000
    rgDENALI_PHY_37(base) = DENALI_PHY_37_DATA   ; // PHY_RX_CAL_DQ7_0:RW+:16:12:=0x0000 PHY_RX_CAL_DQ6_0:RW+:0:12:=0x0000
    rgDENALI_PHY_38(base) = DENALI_PHY_38_DATA   ; // PHY_RX_CAL_DQS_0:RW+:16:12:=0x0000 PHY_RX_CAL_DM_0:RW+:0:12:=0x0000
    rgDENALI_PHY_39(base) = DENALI_PHY_39_DATA   ; // PHY_RX_CAL_OBS_0:RD:16:11:=0x0000 PHY_RX_CAL_FDBK_0:RW+:0:12:=0x0000
    rgDENALI_PHY_40(base) = DENALI_PHY_40_DATA   ; // PHY_RX_CAL_DISABLE_0:RW:16:1:=0x00 PHY_RX_CAL_LOCK_OBS_0:RD:0:9:=0x0000
    rgDENALI_PHY_41(base) = DENALI_PHY_41_DATA   ; // PHY_CLK_WRDQ1SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ0SLAVE_DELAY_0:RW+:0:11:=0x0280
    rgDENALI_PHY_42(base) = DENALI_PHY_42_DATA   ; // PHY_CLK_WRDQ3_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_0:RW+:0:11:=0x0280
    rgDENALI_PHY_43(base) = DENALI_PHY_43_DATA   ; // PHY_CLK_WRDQ5_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_0:RW+:0:11:=0x0280
    rgDENALI_PHY_44(base) = DENALI_PHY_44_DATA   ; // PHY_CLK_WRDQ7_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_0:RW+:0:11:=0x0280
    rgDENALI_PHY_45(base) = DENALI_PHY_45_DATA   ; // PHY_CLK_WRDQS_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_0:RW+:0:11:=0x0280
    rgDENALI_PHY_46(base) = DENALI_PHY_46_DATA   ; // PHY_RDDQ0SLAVE_DELAY_0:RW:8:10:=0x0000 PHY_WRLVL_THRESHOLD_ADJUST_0:RW+:0:2:=0x00
    rgDENALI_PHY_47(base) = DENALI_PHY_47_DATA   ; // PHY_RDDQ2_SLAVE_DELAY_0:RW:16:10:=0x0000 PHY_RDDQ1SLAVE_DELAY_0:RW:0:10:=0x0000
    rgDENALI_PHY_48(base) = DENALI_PHY_48_DATA   ; // PHY_RDDQ4_SLAVE_DELAY_0:RW:16:10:=0x0000 PHY_RDDQ3_SLAVE_DELAY_0:RW:0:10:=0x0000
    rgDENALI_PHY_49(base) = DENALI_PHY_49_DATA   ; // PHY_RDDQ6_SLAVE_DELAY_0:RW:16:10:=0x0000 PHY_RDDQ5_SLAVE_DELAY_0:RW:0:10:=0x0000
    rgDENALI_PHY_50(base) = DENALI_PHY_50_DATA   ; // PHY_RDDM_SLAVE_DELAY_0:RW:16:10:=0x0000 PHY_RDDQ7_SLAVE_DELAY_0:RW:0:10:=0x0000
    rgDENALI_PHY_51(base) = DENALI_PHY_51_DATA   ; // PHY_RDDQS_DQ0FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ0RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_52(base) = DENALI_PHY_52_DATA   ; // PHY_RDDQS_DQ1FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ1RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_53(base) = DENALI_PHY_53_DATA   ; // PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_54(base) = DENALI_PHY_54_DATA   ; // PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_55(base) = DENALI_PHY_55_DATA   ; // PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_56(base) = DENALI_PHY_56_DATA   ; // PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_57(base) = DENALI_PHY_57_DATA   ; // PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_58(base) = DENALI_PHY_58_DATA   ; // PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_59(base) = DENALI_PHY_59_DATA   ; // PHY_RDDQS_DM_FALL_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DM_RISE_SLAVE_DELAY_0:RW+:0:10:=0x0080
    rgDENALI_PHY_60(base) = DENALI_PHY_60_DATA   ; // PHY_WRITE_PATH_LAT_ADD_0:RW:24:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_0:RW+:16:4:=0x00 PHY_RDDQS_GATE_SLAVE_DELAY_0:RW+:0:10:=0x0099
    rgDENALI_PHY_61(base) = DENALI_PHY_61_DATA   ; // PHY_WRLVL_DELAY_PERIOD_THRESHOLD_0:RW:16:10:=0x0000 PHY_WRLVL_DELAY_EARLY_THRESHOLD_0:RW:0:10:=0x01d0
    rgDENALI_PHY_62(base) = DENALI_PHY_62_DATA   ; // PHY_GTLVL_LAT_ADJ_START_0:RW:24:4:=0x00 PHY_GTLVL_RDDQS_SLV_DLY_START_0:RW:8:10:=0x0000 PHY_WRLVL_EARLY_FORCE_ZERO_0:RW:0:1:=0x00
    rgDENALI_PHY_63(base) = DENALI_PHY_63_DATA   ; // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_0:RW:0:10:=0x0000
    rgDENALI_PHY_64(base) = DENALI_PHY_64_DATA   ; // PHY_FDBK_PWR_CTRL_0:RW:0:3:=0x04
    rgDENALI_PHY_65(base) = DENALI_PHY_65_DATA   ; // PHY_DQS_OE_TIMING_0:RW:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_0:RW:16:8:=0x41 PHY_DQ_TSEL_RD_TIMING_0:RW:8:8:=0x41 PHY_DQ_OE_TIMING_0:RW:0:8:=0x52
    rgDENALI_PHY_66(base) = DENALI_PHY_66_DATA   ; // PHY_DQS_IE_TIMING_0:RW:24:8:=0x80 PHY_DQ_IE_TIMING_0:RW:16:8:=0x80 PHY_DQS_TSEL_WR_TIMING_0:RW:8:8:=0x41 PHY_DQS_TSEL_RD_TIMING_0:RW:0:8:=0x41
    rgDENALI_PHY_67(base) = DENALI_PHY_67_DATA   ; // PHY_RDDATA_EN_TSEL_DLY_0:RW:24:5:=0x01 PHY_RDDATA_EN_DLY_0:RW:16:5:=0x02 PHY_IE_MODE_0:RW:8:2:=0x00 PHY_RDDATA_EN_IE_DLY_0:RW:0:2:=0x00
    rgDENALI_PHY_68(base) = DENALI_PHY_68_DATA   ; // PHY_MASTER_DELAY_STEP_0:RW:24:6:=0x08 PHY_MASTER_DELAY_START_0:RW:8:10:=0x0010 PHY_SW_MASTER_MODE_0:RW:0:4:=0x00
    rgDENALI_PHY_69(base) = DENALI_PHY_69_DATA   ; // PHY_WRLVL_DLY_STEP_0:RW:24:4:=0x0c PHY_RPTR_UPDATE_0:RW:16:4:=0x05 PHY_MASTER_DELAY_HALF_MEASURE_0:RW:8:8:=0x3e PHY_MASTER_DELAY_WAIT_0:RW:0:8:=0x42
    rgDENALI_PHY_70(base) = DENALI_PHY_70_DATA   ; // PHY_GTLVL_RESP_WAIT_CNT_0:RW:16:5:=0x0f PHY_GTLVL_DLY_STEP_0:RW:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_0:RW:0:5:=0x0f
    rgDENALI_PHY_71(base) = DENALI_PHY_71_DATA   ; // PHY_GTLVL_FINAL_STEP_0:RW:16:10:=0x0100 PHY_GTLVL_BACK_STEP_0:RW:0:10:=0x0140
    rgDENALI_PHY_72(base) = DENALI_PHY_72_DATA   ; // PHY_RDLVL_DLY_STEP_0:RW:0:4:=0x0c
                       
    rgDENALI_PHY_128(base) = DENALI_PHY_128_DATA  ; // PHY_DQ_DM_SWIZZLE01:RW:0:32:=0x76543210
    rgDENALI_PHY_129(base) = DENALI_PHY_129_DATA  ; // PHY_CLK_WR_BYPASS_SLAVE_DELAY_1:RW:8:11:=0x04c0 PHY_DQ_DM_SWIZZLE11:RW:0:4:=0x08
    rgDENALI_PHY_130(base) = DENALI_PHY_130_DATA  ; // PHY_SW_WRDQ0SHIFT_1:RW:24:5:=0x00 PHY_CLK_BYPASS_OVERRIDE_1:RW:16:1:=0x00 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_1:RW:0:10:=0x0099
    rgDENALI_PHY_131(base) = DENALI_PHY_131_DATA  ; // PHY_SW_WRDQ4_SHIFT_1:RW:24:5:=0x00 PHY_SW_WRDQ3_SHIFT_1:RW:16:5:=0x00 PHY_SW_WRDQ2_SHIFT_1:RW:8:5:=0x00 PHY_SW_WRDQ1SHIFT_1:RW:0:5:=0x00
    rgDENALI_PHY_132(base) = DENALI_PHY_132_DATA  ; // PHY_SW_WRDM_SHIFT_1:RW:24:5:=0x00 PHY_SW_WRDQ7_SHIFT_1:RW:16:5:=0x00 PHY_SW_WRDQ6_SHIFT_1:RW:8:5:=0x00 PHY_SW_WRDQ5_SHIFT_1:RW:0:5:=0x00
    rgDENALI_PHY_133(base) = DENALI_PHY_133_DATA  ; // PHY_DQ_TSEL_ENABLE_1:RW:8:3:=0x01 PHY_SW_WRDQS_SHIFT_1:RW:0:4:=0x00
    rgDENALI_PHY_134(base) = DENALI_PHY_134_DATA  ; // PHY_DQS_TSEL_ENABLE_1:RW:24:3:=0x01 PHY_DQ_TSEL_SELECT_1:RW:0:24:=0x665555
    rgDENALI_PHY_135(base) = DENALI_PHY_135_DATA  ; // PHY_LPBK_CONTROL_1:RW:24:8:=0x00 PHY_DQS_TSEL_SELECT_1:RW:0:24:=0x665555
    rgDENALI_PHY_136(base) = DENALI_PHY_136_DATA  ; // PHY_AUTO_TIMING_MARGIN_CONTROL_1:RW:0:32:=0x00000000
    rgDENALI_PHY_137(base) = DENALI_PHY_137_DATA  ; // PHY_AUTO_TIMING_MARGIN_OBS_1:RD:0:28:=0x00000000
    rgDENALI_PHY_138(base) = DENALI_PHY_138_DATA  ; // PHY_PRBS_PATTERN_MASK_1:RW:16:9:=0x0000 PHY_PRBS_PATTERN_START_1:RW_D:8:7:=0x01 PHY_SLICE_PWR_RDC_DISABLE_1:RW:0:1:=0x00
    rgDENALI_PHY_139(base) = DENALI_PHY_139_DATA  ; // SC_PHY_SNAP_OBS_REGS_1:WR:24:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_1:RW:16:5:=0x17 PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_1:RW:0:10:=0x00c0
    rgDENALI_PHY_140(base) = DENALI_PHY_140_DATA  ; // PHY_RDDQ_ENC_OBS_SELECT_1:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_1:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_1:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_1:RW:0:3:=0x00
    rgDENALI_PHY_141(base) = DENALI_PHY_141_DATA  ; // PHY_FIFO_PTR_OBS_SELECT_1:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_1:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_1:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_1:RW:0:4:=0x00
    rgDENALI_PHY_142(base) = DENALI_PHY_142_DATA  ; // PHY_WRLVL_UPDT_WAIT_CNT_1:RW:24:4:=0x04 PHY_WRLVL_CAPTURE_CNT_1:RW:16:6:=0x08 SC_PHY_LVL_DEBUG_CONT_1:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_1:RW:0:1:=0x00
    rgDENALI_PHY_143(base) = DENALI_PHY_143_DATA  ; // PHY_RDLVL_UPDT_WAIT_CNT_1:RW:24:4:=0x04 PHY_RDLVL_CAPTURE_CNT_1:RW:16:6:=0x08 PHY_GTLVL_UPDT_WAIT_CNT_1:RW:8:4:=0x04 PHY_GTLVL_CAPTURE_CNT_1:RW:0:6:=0x00
    rgDENALI_PHY_144(base) = DENALI_PHY_144_DATA  ; // SC_PHY_MANUAL_CLEAR_1:WR:24:5:=0x00 PHY_RDLVL_DATA_MASK_1:RW:16:8:=0x00 PHY_RDLVL_RDDQS_DQ_OBS_SELECT_1:RW:8:4:=0x00 PHY_RDLVL_OP_MODE_1:RW:0:2:=0x00
    rgDENALI_PHY_145(base) = DENALI_PHY_145_DATA  ; // PHY_FIFO_PTR_OBS_1:RD:0:8:=0x00
    rgDENALI_PHY_146(base) = DENALI_PHY_146_DATA  ; // PHY_LPBK_RESULT_OBS_1:RD:0:32:=0x00000000
    rgDENALI_PHY_147(base) = DENALI_PHY_147_DATA  ; // PHY_MASTER_DLY_LOCK_OBS_1:RD:16:10:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_1:RD:0:16:=0x0000
    rgDENALI_PHY_148(base) = DENALI_PHY_148_DATA  ; // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_1:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_1:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_1:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_1:RD:0:6:=0x00
    rgDENALI_PHY_149(base) = DENALI_PHY_149_DATA  ; // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_1:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_1:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_1:RD:0:10:=0x0000
    rgDENALI_PHY_150(base) = DENALI_PHY_150_DATA  ; // PHY_WRLVL_HARD0DELAY_OBS_1:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_1:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_1:RD:0:8:=0x00
    rgDENALI_PHY_151(base) = DENALI_PHY_151_DATA  ; // PHY_WRLVL_HARD1DELAY_OBS_1:RD:0:10:=0x0000
    rgDENALI_PHY_152(base) = DENALI_PHY_152_DATA  ; // PHY_WRLVL_STATUS_OBS_1:RD:0:17:=0x000000
    rgDENALI_PHY_153(base) = DENALI_PHY_153_DATA  ; // PHY_GTLVL_HARD1DELAY_OBS_1:RD:16:14:=0x0000 PHY_GTLVL_HARD0DELAY_OBS_1:RD:0:14:=0x0000
    rgDENALI_PHY_154(base) = DENALI_PHY_154_DATA  ; // PHY_GTLVL_STATUS_OBS_1:RD:0:18:=0x000000
    rgDENALI_PHY_155(base) = DENALI_PHY_155_DATA  ; // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_1:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_1:RD:0:10:=0x0000
    rgDENALI_PHY_156(base) = DENALI_PHY_156_DATA  ; // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_1:RD:0:2:=0x00
    rgDENALI_PHY_157(base) = DENALI_PHY_157_DATA  ; // PHY_RDLVL_STATUS_OBS_1:RD:0:32:=0x00000000
    rgDENALI_PHY_158(base) = DENALI_PHY_158_DATA  ; // PHY_DDL_MODE_1:RW:0:18:=0x000000
    rgDENALI_PHY_159(base) = DENALI_PHY_159_DATA  ; // PHY_DDL_TEST_OBS_1:RD:0:32:=0x00000000
    rgDENALI_PHY_160(base) = DENALI_PHY_160_DATA  ; // PHY_DDL_TEST_MSTR_DLY_OBS_1:RD:0:32:=0x00000000
    rgDENALI_PHY_161(base) = DENALI_PHY_161_DATA  ; // PHY_RX_CAL_SAMPLE_WAIT_1:RW:24:8:=0x20 PHY_RX_CAL_OVERRIDE_1:RW:16:1:=0x00 SC_PHY_RX_CAL_START_1:WR:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_1:RW:0:8:=0x04
    rgDENALI_PHY_162(base) = DENALI_PHY_162_DATA  ; // PHY_RX_CAL_DQ11:RW+:16:12:=0x0000 PHY_RX_CAL_DQ01:RW+:0:12:=0x0000
    rgDENALI_PHY_163(base) = DENALI_PHY_163_DATA  ; // PHY_RX_CAL_DQ3_1:RW+:16:12:=0x0000 PHY_RX_CAL_DQ2_1:RW+:0:12:=0x0000
    rgDENALI_PHY_164(base) = DENALI_PHY_164_DATA  ; // PHY_RX_CAL_DQ5_1:RW+:16:12:=0x0000 PHY_RX_CAL_DQ4_1:RW+:0:12:=0x0000
    rgDENALI_PHY_165(base) = DENALI_PHY_165_DATA  ; // PHY_RX_CAL_DQ7_1:RW+:16:12:=0x0000 PHY_RX_CAL_DQ6_1:RW+:0:12:=0x0000
    rgDENALI_PHY_166(base) = DENALI_PHY_166_DATA  ; // PHY_RX_CAL_DQS_1:RW+:16:12:=0x0000 PHY_RX_CAL_DM_1:RW+:0:12:=0x0000
    rgDENALI_PHY_167(base) = DENALI_PHY_167_DATA  ; // PHY_RX_CAL_OBS_1:RD:16:11:=0x0000 PHY_RX_CAL_FDBK_1:RW+:0:12:=0x0000
    rgDENALI_PHY_168(base) = DENALI_PHY_168_DATA  ; // PHY_RX_CAL_DISABLE_1:RW:16:1:=0x00 PHY_RX_CAL_LOCK_OBS_1:RD:0:9:=0x0000
    rgDENALI_PHY_169(base) = DENALI_PHY_169_DATA  ; // PHY_CLK_WRDQ1SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ0SLAVE_DELAY_1:RW+:0:11:=0x0280
    rgDENALI_PHY_170(base) = DENALI_PHY_170_DATA  ; // PHY_CLK_WRDQ3_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_1:RW+:0:11:=0x0280
    rgDENALI_PHY_171(base) = DENALI_PHY_171_DATA  ; // PHY_CLK_WRDQ5_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_1:RW+:0:11:=0x0280
    rgDENALI_PHY_172(base) = DENALI_PHY_172_DATA  ; // PHY_CLK_WRDQ7_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_1:RW+:0:11:=0x0280
    rgDENALI_PHY_173(base) = DENALI_PHY_173_DATA  ; // PHY_CLK_WRDQS_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_1:RW+:0:11:=0x0280
    rgDENALI_PHY_174(base) = DENALI_PHY_174_DATA  ; // PHY_RDDQ0SLAVE_DELAY_1:RW:8:10:=0x0000 PHY_WRLVL_THRESHOLD_ADJUST_1:RW+:0:2:=0x00
    rgDENALI_PHY_175(base) = DENALI_PHY_175_DATA  ; // PHY_RDDQ2_SLAVE_DELAY_1:RW:16:10:=0x0000 PHY_RDDQ1SLAVE_DELAY_1:RW:0:10:=0x0000
    rgDENALI_PHY_176(base) = DENALI_PHY_176_DATA  ; // PHY_RDDQ4_SLAVE_DELAY_1:RW:16:10:=0x0000 PHY_RDDQ3_SLAVE_DELAY_1:RW:0:10:=0x0000
    rgDENALI_PHY_177(base) = DENALI_PHY_177_DATA  ; // PHY_RDDQ6_SLAVE_DELAY_1:RW:16:10:=0x0000 PHY_RDDQ5_SLAVE_DELAY_1:RW:0:10:=0x0000
    rgDENALI_PHY_178(base) = DENALI_PHY_178_DATA  ; // PHY_RDDM_SLAVE_DELAY_1:RW:16:10:=0x0000 PHY_RDDQ7_SLAVE_DELAY_1:RW:0:10:=0x0000
    rgDENALI_PHY_179(base) = DENALI_PHY_179_DATA  ; // PHY_RDDQS_DQ0FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ0RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_180(base) = DENALI_PHY_180_DATA  ; // PHY_RDDQS_DQ1FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ1RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_181(base) = DENALI_PHY_181_DATA  ; // PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_182(base) = DENALI_PHY_182_DATA  ; // PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_183(base) = DENALI_PHY_183_DATA  ; // PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_184(base) = DENALI_PHY_184_DATA  ; // PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_185(base) = DENALI_PHY_185_DATA  ; // PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_186(base) = DENALI_PHY_186_DATA  ; // PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_187(base) = DENALI_PHY_187_DATA  ; // PHY_RDDQS_DM_FALL_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DM_RISE_SLAVE_DELAY_1:RW+:0:10:=0x0080
    rgDENALI_PHY_188(base) = DENALI_PHY_188_DATA  ; // PHY_WRITE_PATH_LAT_ADD_1:RW:24:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_1:RW+:16:4:=0x00 PHY_RDDQS_GATE_SLAVE_DELAY_1:RW+:0:10:=0x0099
    rgDENALI_PHY_189(base) = DENALI_PHY_189_DATA  ; // PHY_WRLVL_DELAY_PERIOD_THRESHOLD_1:RW:16:10:=0x0000 PHY_WRLVL_DELAY_EARLY_THRESHOLD_1:RW:0:10:=0x01d0
    rgDENALI_PHY_190(base) = DENALI_PHY_190_DATA  ; // PHY_GTLVL_LAT_ADJ_START_1:RW:24:4:=0x00 PHY_GTLVL_RDDQS_SLV_DLY_START_1:RW:8:10:=0x0000 PHY_WRLVL_EARLY_FORCE_ZERO_1:RW:0:1:=0x00
    rgDENALI_PHY_191(base) = DENALI_PHY_191_DATA  ; // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_1:RW:0:10:=0x0000
    rgDENALI_PHY_192(base) = DENALI_PHY_192_DATA  ; // PHY_FDBK_PWR_CTRL_1:RW:0:3:=0x04
    rgDENALI_PHY_193(base) = DENALI_PHY_193_DATA  ; // PHY_DQS_OE_TIMING_1:RW:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_1:RW:16:8:=0x41 PHY_DQ_TSEL_RD_TIMING_1:RW:8:8:=0x41 PHY_DQ_OE_TIMING_1:RW:0:8:=0x52
    rgDENALI_PHY_194(base) = DENALI_PHY_194_DATA  ; // PHY_DQS_IE_TIMING_1:RW:24:8:=0x80 PHY_DQ_IE_TIMING_1:RW:16:8:=0x80 PHY_DQS_TSEL_WR_TIMING_1:RW:8:8:=0x41 PHY_DQS_TSEL_RD_TIMING_1:RW:0:8:=0x41
    rgDENALI_PHY_195(base) = DENALI_PHY_195_DATA  ; // PHY_RDDATA_EN_TSEL_DLY_1:RW:24:5:=0x01 PHY_RDDATA_EN_DLY_1:RW:16:5:=0x02 PHY_IE_MODE_1:RW:8:2:=0x00 PHY_RDDATA_EN_IE_DLY_1:RW:0:2:=0x00
    rgDENALI_PHY_196(base) = DENALI_PHY_196_DATA  ; // PHY_MASTER_DELAY_STEP_1:RW:24:6:=0x08 PHY_MASTER_DELAY_START_1:RW:8:10:=0x0010 PHY_SW_MASTER_MODE_1:RW:0:4:=0x00
    rgDENALI_PHY_197(base) = DENALI_PHY_197_DATA  ; // PHY_WRLVL_DLY_STEP_1:RW:24:4:=0x0c PHY_RPTR_UPDATE_1:RW:16:4:=0x05 PHY_MASTER_DELAY_HALF_MEASURE_1:RW:8:8:=0x3e PHY_MASTER_DELAY_WAIT_1:RW:0:8:=0x42
    rgDENALI_PHY_198(base) = DENALI_PHY_198_DATA  ; // PHY_GTLVL_RESP_WAIT_CNT_1:RW:16:5:=0x0f PHY_GTLVL_DLY_STEP_1:RW:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_1:RW:0:5:=0x0f
    rgDENALI_PHY_199(base) = DENALI_PHY_199_DATA  ; // PHY_GTLVL_FINAL_STEP_1:RW:16:10:=0x0100 PHY_GTLVL_BACK_STEP_1:RW:0:10:=0x0140
    rgDENALI_PHY_200(base) = DENALI_PHY_200_DATA  ; // PHY_RDLVL_DLY_STEP_1:RW:0:4:=0x0c
                       
    rgDENALI_PHY_256(base) = DENALI_PHY_256_DATA  ; // PHY_DQ_DM_SWIZZLE02:RW:0:32:=0x76543210
    rgDENALI_PHY_257(base) = DENALI_PHY_257_DATA  ; // PHY_CLK_WR_BYPASS_SLAVE_DELAY_2:RW:8:11:=0x04c0 PHY_DQ_DM_SWIZZLE12:RW:0:4:=0x08
    rgDENALI_PHY_258(base) = DENALI_PHY_258_DATA  ; // PHY_SW_WRDQ0SHIFT_2:RW:24:5:=0x00 PHY_CLK_BYPASS_OVERRIDE_2:RW:16:1:=0x00 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_2:RW:0:10:=0x0099
    rgDENALI_PHY_259(base) = DENALI_PHY_259_DATA  ; // PHY_SW_WRDQ4_SHIFT_2:RW:24:5:=0x00 PHY_SW_WRDQ3_SHIFT_2:RW:16:5:=0x00 PHY_SW_WRDQ2_SHIFT_2:RW:8:5:=0x00 PHY_SW_WRDQ1SHIFT_2:RW:0:5:=0x00
    rgDENALI_PHY_260(base) = DENALI_PHY_260_DATA  ; // PHY_SW_WRDM_SHIFT_2:RW:24:5:=0x00 PHY_SW_WRDQ7_SHIFT_2:RW:16:5:=0x00 PHY_SW_WRDQ6_SHIFT_2:RW:8:5:=0x00 PHY_SW_WRDQ5_SHIFT_2:RW:0:5:=0x00
    rgDENALI_PHY_261(base) = DENALI_PHY_261_DATA  ; // PHY_DQ_TSEL_ENABLE_2:RW:8:3:=0x01 PHY_SW_WRDQS_SHIFT_2:RW:0:4:=0x00
    rgDENALI_PHY_262(base) = DENALI_PHY_262_DATA  ; // PHY_DQS_TSEL_ENABLE_2:RW:24:3:=0x01 PHY_DQ_TSEL_SELECT_2:RW:0:24:=0x665555
    rgDENALI_PHY_263(base) = DENALI_PHY_263_DATA  ; // PHY_LPBK_CONTROL_2:RW:24:8:=0x00 PHY_DQS_TSEL_SELECT_2:RW:0:24:=0x665555
    rgDENALI_PHY_264(base) = DENALI_PHY_264_DATA  ; // PHY_AUTO_TIMING_MARGIN_CONTROL_2:RW:0:32:=0x00000000
    rgDENALI_PHY_265(base) = DENALI_PHY_265_DATA  ; // PHY_AUTO_TIMING_MARGIN_OBS_2:RD:0:28:=0x00000000
    rgDENALI_PHY_266(base) = DENALI_PHY_266_DATA  ; // PHY_PRBS_PATTERN_MASK_2:RW:16:9:=0x0000 PHY_PRBS_PATTERN_START_2:RW_D:8:7:=0x01 PHY_SLICE_PWR_RDC_DISABLE_2:RW:0:1:=0x00
    rgDENALI_PHY_267(base) = DENALI_PHY_267_DATA  ; // SC_PHY_SNAP_OBS_REGS_2:WR:24:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_2:RW:16:5:=0x17 PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_2:RW:0:10:=0x00c0
    rgDENALI_PHY_268(base) = DENALI_PHY_268_DATA  ; // PHY_RDDQ_ENC_OBS_SELECT_2:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_2:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_2:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_2:RW:0:3:=0x00
    rgDENALI_PHY_269(base) = DENALI_PHY_269_DATA  ; // PHY_FIFO_PTR_OBS_SELECT_2:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_2:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_2:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_2:RW:0:4:=0x00
    rgDENALI_PHY_270(base) = DENALI_PHY_270_DATA  ; // PHY_WRLVL_UPDT_WAIT_CNT_2:RW:24:4:=0x04 PHY_WRLVL_CAPTURE_CNT_2:RW:16:6:=0x08 SC_PHY_LVL_DEBUG_CONT_2:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_2:RW:0:1:=0x00
    rgDENALI_PHY_271(base) = DENALI_PHY_271_DATA  ; // PHY_RDLVL_UPDT_WAIT_CNT_2:RW:24:4:=0x04 PHY_RDLVL_CAPTURE_CNT_2:RW:16:6:=0x08 PHY_GTLVL_UPDT_WAIT_CNT_2:RW:8:4:=0x04 PHY_GTLVL_CAPTURE_CNT_2:RW:0:6:=0x00
    rgDENALI_PHY_272(base) = DENALI_PHY_272_DATA  ; // SC_PHY_MANUAL_CLEAR_2:WR:24:5:=0x00 PHY_RDLVL_DATA_MASK_2:RW:16:8:=0x00 PHY_RDLVL_RDDQS_DQ_OBS_SELECT_2:RW:8:4:=0x00 PHY_RDLVL_OP_MODE_2:RW:0:2:=0x00
    rgDENALI_PHY_273(base) = DENALI_PHY_273_DATA  ; // PHY_FIFO_PTR_OBS_2:RD:0:8:=0x00
    rgDENALI_PHY_274(base) = DENALI_PHY_274_DATA  ; // PHY_LPBK_RESULT_OBS_2:RD:0:32:=0x00000000
    rgDENALI_PHY_275(base) = DENALI_PHY_275_DATA  ; // PHY_MASTER_DLY_LOCK_OBS_2:RD:16:10:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_2:RD:0:16:=0x0000
    rgDENALI_PHY_276(base) = DENALI_PHY_276_DATA  ; // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_2:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_2:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_2:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_2:RD:0:6:=0x00
    rgDENALI_PHY_277(base) = DENALI_PHY_277_DATA  ; // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_2:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_2:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_2:RD:0:10:=0x0000
    rgDENALI_PHY_278(base) = DENALI_PHY_278_DATA  ; // PHY_WRLVL_HARD0DELAY_OBS_2:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_2:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_2:RD:0:8:=0x00
    rgDENALI_PHY_279(base) = DENALI_PHY_279_DATA  ; // PHY_WRLVL_HARD1DELAY_OBS_2:RD:0:10:=0x0000
    rgDENALI_PHY_280(base) = DENALI_PHY_280_DATA  ; // PHY_WRLVL_STATUS_OBS_2:RD:0:17:=0x000000
    rgDENALI_PHY_281(base) = DENALI_PHY_281_DATA  ; // PHY_GTLVL_HARD1DELAY_OBS_2:RD:16:14:=0x0000 PHY_GTLVL_HARD0DELAY_OBS_2:RD:0:14:=0x0000
    rgDENALI_PHY_282(base) = DENALI_PHY_282_DATA  ; // PHY_GTLVL_STATUS_OBS_2:RD:0:18:=0x000000
    rgDENALI_PHY_283(base) = DENALI_PHY_283_DATA  ; // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_2:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_2:RD:0:10:=0x0000
    rgDENALI_PHY_284(base) = DENALI_PHY_284_DATA  ; // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_2:RD:0:2:=0x00
    rgDENALI_PHY_285(base) = DENALI_PHY_285_DATA  ; // PHY_RDLVL_STATUS_OBS_2:RD:0:32:=0x00000000
    rgDENALI_PHY_286(base) = DENALI_PHY_286_DATA  ; // PHY_DDL_MODE_2:RW:0:18:=0x000000
    rgDENALI_PHY_287(base) = DENALI_PHY_287_DATA  ; // PHY_DDL_TEST_OBS_2:RD:0:32:=0x00000000
    rgDENALI_PHY_288(base) = DENALI_PHY_288_DATA  ; // PHY_DDL_TEST_MSTR_DLY_OBS_2:RD:0:32:=0x00000000
    rgDENALI_PHY_289(base) = DENALI_PHY_289_DATA  ; // PHY_RX_CAL_SAMPLE_WAIT_2:RW:24:8:=0x20 PHY_RX_CAL_OVERRIDE_2:RW:16:1:=0x00 SC_PHY_RX_CAL_START_2:WR:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_2:RW:0:8:=0x04
    rgDENALI_PHY_290(base) = DENALI_PHY_290_DATA  ; // PHY_RX_CAL_DQ12:RW+:16:12:=0x0000 PHY_RX_CAL_DQ02:RW+:0:12:=0x0000
    rgDENALI_PHY_291(base) = DENALI_PHY_291_DATA  ; // PHY_RX_CAL_DQ3_2:RW+:16:12:=0x0000 PHY_RX_CAL_DQ2_2:RW+:0:12:=0x0000
    rgDENALI_PHY_292(base) = DENALI_PHY_292_DATA  ; // PHY_RX_CAL_DQ5_2:RW+:16:12:=0x0000 PHY_RX_CAL_DQ4_2:RW+:0:12:=0x0000
    rgDENALI_PHY_293(base) = DENALI_PHY_293_DATA  ; // PHY_RX_CAL_DQ7_2:RW+:16:12:=0x0000 PHY_RX_CAL_DQ6_2:RW+:0:12:=0x0000
    rgDENALI_PHY_294(base) = DENALI_PHY_294_DATA  ; // PHY_RX_CAL_DQS_2:RW+:16:12:=0x0000 PHY_RX_CAL_DM_2:RW+:0:12:=0x0000
    rgDENALI_PHY_295(base) = DENALI_PHY_295_DATA  ; // PHY_RX_CAL_OBS_2:RD:16:11:=0x0000 PHY_RX_CAL_FDBK_2:RW+:0:12:=0x0000
    rgDENALI_PHY_296(base) = DENALI_PHY_296_DATA  ; // PHY_RX_CAL_DISABLE_2:RW:16:1:=0x00 PHY_RX_CAL_LOCK_OBS_2:RD:0:9:=0x0000
    rgDENALI_PHY_297(base) = DENALI_PHY_297_DATA  ; // PHY_CLK_WRDQ1SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ0SLAVE_DELAY_2:RW+:0:11:=0x0280
    rgDENALI_PHY_298(base) = DENALI_PHY_298_DATA  ; // PHY_CLK_WRDQ3_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_2:RW+:0:11:=0x0280
    rgDENALI_PHY_299(base) = DENALI_PHY_299_DATA  ; // PHY_CLK_WRDQ5_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_2:RW+:0:11:=0x0280
    rgDENALI_PHY_300(base) = DENALI_PHY_300_DATA  ; // PHY_CLK_WRDQ7_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_2:RW+:0:11:=0x0280
    rgDENALI_PHY_301(base) = DENALI_PHY_301_DATA  ; // PHY_CLK_WRDQS_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_2:RW+:0:11:=0x0280
    rgDENALI_PHY_302(base) = DENALI_PHY_302_DATA  ; // PHY_RDDQ0_SLAVE_DELAY_2:RW:8:10:=0x0000 PHY_WRLVL_THRESHOLD_ADJUST_2:RW+:0:2:=0x00
    rgDENALI_PHY_303(base) = DENALI_PHY_303_DATA  ; // PHY_RDDQ2_SLAVE_DELAY_2:RW:16:10:=0x0000 PHY_RDDQ1SLAVE_DELAY_2:RW:0:10:=0x0000
    rgDENALI_PHY_304(base) = DENALI_PHY_304_DATA  ; // PHY_RDDQ4_SLAVE_DELAY_2:RW:16:10:=0x0000 PHY_RDDQ3_SLAVE_DELAY_2:RW:0:10:=0x0000
    rgDENALI_PHY_305(base) = DENALI_PHY_305_DATA  ; // PHY_RDDQ6_SLAVE_DELAY_2:RW:16:10:=0x0000 PHY_RDDQ5_SLAVE_DELAY_2:RW:0:10:=0x0000
    rgDENALI_PHY_306(base) = DENALI_PHY_306_DATA  ; // PHY_RDDM_SLAVE_DELAY_2:RW:16:10:=0x0000 PHY_RDDQ7_SLAVE_DELAY_2:RW:0:10:=0x0000
    rgDENALI_PHY_307(base) = DENALI_PHY_307_DATA  ; // PHY_RDDQS_DQ0FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ0RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_308(base) = DENALI_PHY_308_DATA  ; // PHY_RDDQS_DQ1FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ1RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_309(base) = DENALI_PHY_309_DATA  ; // PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_310(base) = DENALI_PHY_310_DATA  ; // PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_311(base) = DENALI_PHY_311_DATA  ; // PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_312(base) = DENALI_PHY_312_DATA  ; // PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_313(base) = DENALI_PHY_313_DATA  ; // PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_314(base) = DENALI_PHY_314_DATA  ; // PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_315(base) = DENALI_PHY_315_DATA  ; // PHY_RDDQS_DM_FALL_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DM_RISE_SLAVE_DELAY_2:RW+:0:10:=0x0080
    rgDENALI_PHY_316(base) = DENALI_PHY_316_DATA  ; // PHY_WRITE_PATH_LAT_ADD_2:RW:24:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_2:RW+:16:4:=0x00 PHY_RDDQS_GATE_SLAVE_DELAY_2:RW+:0:10:=0x0099
    rgDENALI_PHY_317(base) = DENALI_PHY_317_DATA  ; // PHY_WRLVL_DELAY_PERIOD_THRESHOLD_2:RW:16:10:=0x0000 PHY_WRLVL_DELAY_EARLY_THRESHOLD_2:RW:0:10:=0x01d0
    rgDENALI_PHY_318(base) = DENALI_PHY_318_DATA  ; // PHY_GTLVL_LAT_ADJ_START_2:RW:24:4:=0x00 PHY_GTLVL_RDDQS_SLV_DLY_START_2:RW:8:10:=0x0000 PHY_WRLVL_EARLY_FORCE_ZERO_2:RW:0:1:=0x00
    rgDENALI_PHY_319(base) = DENALI_PHY_319_DATA  ; // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_2:RW:0:10:=0x0000
    rgDENALI_PHY_320(base) = DENALI_PHY_320_DATA  ; // PHY_FDBK_PWR_CTRL_2:RW:0:3:=0x04
    rgDENALI_PHY_321(base) = DENALI_PHY_321_DATA  ; // PHY_DQS_OE_TIMING_2:RW:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_2:RW:16:8:=0x41 PHY_DQ_TSEL_RD_TIMING_2:RW:8:8:=0x41 PHY_DQ_OE_TIMING_2:RW:0:8:=0x52
    rgDENALI_PHY_322(base) = DENALI_PHY_322_DATA  ; // PHY_DQS_IE_TIMING_2:RW:24:8:=0x80 PHY_DQ_IE_TIMING_2:RW:16:8:=0x80 PHY_DQS_TSEL_WR_TIMING_2:RW:8:8:=0x41 PHY_DQS_TSEL_RD_TIMING_2:RW:0:8:=0x41
    rgDENALI_PHY_323(base) = DENALI_PHY_323_DATA  ; // PHY_RDDATA_EN_TSEL_DLY_2:RW:24:5:=0x01 PHY_RDDATA_EN_DLY_2:RW:16:5:=0x02 PHY_IE_MODE_2:RW:8:2:=0x00 PHY_RDDATA_EN_IE_DLY_2:RW:0:2:=0x00
    rgDENALI_PHY_324(base) = DENALI_PHY_324_DATA  ; // PHY_MASTER_DELAY_STEP_2:RW:24:6:=0x08 PHY_MASTER_DELAY_START_2:RW:8:10:=0x0010 PHY_SW_MASTER_MODE_2:RW:0:4:=0x00
    rgDENALI_PHY_325(base) = DENALI_PHY_325_DATA  ; // PHY_WRLVL_DLY_STEP_2:RW:24:4:=0x0c PHY_RPTR_UPDATE_2:RW:16:4:=0x05 PHY_MASTER_DELAY_HALF_MEASURE_2:RW:8:8:=0x3e PHY_MASTER_DELAY_WAIT_2:RW:0:8:=0x42
    rgDENALI_PHY_326(base) = DENALI_PHY_326_DATA  ; // PHY_GTLVL_RESP_WAIT_CNT_2:RW:16:5:=0x0f PHY_GTLVL_DLY_STEP_2:RW:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_2:RW:0:5:=0x0f
    rgDENALI_PHY_327(base) = DENALI_PHY_327_DATA  ; // PHY_GTLVL_FINAL_STEP_2:RW:16:10:=0x0100 PHY_GTLVL_BACK_STEP_2:RW:0:10:=0x0140
    rgDENALI_PHY_328(base) = DENALI_PHY_328_DATA  ; // PHY_RDLVL_DLY_STEP_2:RW:0:4:=0x0c
                       
    rgDENALI_PHY_384(base) = DENALI_PHY_384_DATA  ; // PHY_DQ_DM_SWIZZLE03:RW:0:32:=0x76543210
    rgDENALI_PHY_385(base) = DENALI_PHY_385_DATA  ; // PHY_CLK_WR_BYPASS_SLAVE_DELAY_3:RW:8:11:=0x04c0 PHY_DQ_DM_SWIZZLE13:RW:0:4:=0x08
    rgDENALI_PHY_386(base) = DENALI_PHY_386_DATA  ; // PHY_SW_WRDQ0SHIFT_3:RW:24:5:=0x00 PHY_CLK_BYPASS_OVERRIDE_3:RW:16:1:=0x00 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_3:RW:0:10:=0x0099
    rgDENALI_PHY_387(base) = DENALI_PHY_387_DATA  ; // PHY_SW_WRDQ4_SHIFT_3:RW:24:5:=0x00 PHY_SW_WRDQ3_SHIFT_3:RW:16:5:=0x00 PHY_SW_WRDQ2_SHIFT_3:RW:8:5:=0x00 PHY_SW_WRDQ1SHIFT_3:RW:0:5:=0x00
    rgDENALI_PHY_388(base) = DENALI_PHY_388_DATA  ; // PHY_SW_WRDM_SHIFT_3:RW:24:5:=0x00 PHY_SW_WRDQ7_SHIFT_3:RW:16:5:=0x00 PHY_SW_WRDQ6_SHIFT_3:RW:8:5:=0x00 PHY_SW_WRDQ5_SHIFT_3:RW:0:5:=0x00
    rgDENALI_PHY_389(base) = DENALI_PHY_389_DATA  ; // PHY_DQ_TSEL_ENABLE_3:RW:8:3:=0x01 PHY_SW_WRDQS_SHIFT_3:RW:0:4:=0x00
    rgDENALI_PHY_390(base) = DENALI_PHY_390_DATA  ; // PHY_DQS_TSEL_ENABLE_3:RW:24:3:=0x01 PHY_DQ_TSEL_SELECT_3:RW:0:24:=0x665555
    rgDENALI_PHY_391(base) = DENALI_PHY_391_DATA  ; // PHY_LPBK_CONTROL_3:RW:24:8:=0x00 PHY_DQS_TSEL_SELECT_3:RW:0:24:=0x665555
    rgDENALI_PHY_392(base) = DENALI_PHY_392_DATA  ; // PHY_AUTO_TIMING_MARGIN_CONTROL_3:RW:0:32:=0x00000000
    rgDENALI_PHY_393(base) = DENALI_PHY_393_DATA  ; // PHY_AUTO_TIMING_MARGIN_OBS_3:RD:0:28:=0x00000000
    rgDENALI_PHY_394(base) = DENALI_PHY_394_DATA  ; // PHY_PRBS_PATTERN_MASK_3:RW:16:9:=0x0000 PHY_PRBS_PATTERN_START_3:RW_D:8:7:=0x01 PHY_SLICE_PWR_RDC_DISABLE_3:RW:0:1:=0x00
    rgDENALI_PHY_395(base) = DENALI_PHY_395_DATA  ; // SC_PHY_SNAP_OBS_REGS_3:WR:24:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_3:RW:16:5:=0x17 PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_3:RW:0:10:=0x00c0
    rgDENALI_PHY_396(base) = DENALI_PHY_396_DATA  ; // PHY_RDDQ_ENC_OBS_SELECT_3:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_3:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_3:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_3:RW:0:3:=0x00
    rgDENALI_PHY_397(base) = DENALI_PHY_397_DATA  ; // PHY_FIFO_PTR_OBS_SELECT_3:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_3:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_3:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_3:RW:0:4:=0x00
    rgDENALI_PHY_398(base) = DENALI_PHY_398_DATA  ; // PHY_WRLVL_UPDT_WAIT_CNT_3:RW:24:4:=0x04 PHY_WRLVL_CAPTURE_CNT_3:RW:16:6:=0x08 SC_PHY_LVL_DEBUG_CONT_3:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_3:RW:0:1:=0x00
    rgDENALI_PHY_399(base) = DENALI_PHY_399_DATA  ; // PHY_RDLVL_UPDT_WAIT_CNT_3:RW:24:4:=0x04 PHY_RDLVL_CAPTURE_CNT_3:RW:16:6:=0x08 PHY_GTLVL_UPDT_WAIT_CNT_3:RW:8:4:=0x04 PHY_GTLVL_CAPTURE_CNT_3:RW:0:6:=0x00
    rgDENALI_PHY_400(base) = DENALI_PHY_400_DATA  ; // SC_PHY_MANUAL_CLEAR_3:WR:24:5:=0x00 PHY_RDLVL_DATA_MASK_3:RW:16:8:=0x00 PHY_RDLVL_RDDQS_DQ_OBS_SELECT_3:RW:8:4:=0x00 PHY_RDLVL_OP_MODE_3:RW:0:2:=0x00
    rgDENALI_PHY_401(base) = DENALI_PHY_401_DATA  ; // PHY_FIFO_PTR_OBS_3:RD:0:8:=0x00
    rgDENALI_PHY_402(base) = DENALI_PHY_402_DATA  ; // PHY_LPBK_RESULT_OBS_3:RD:0:32:=0x00000000
    rgDENALI_PHY_403(base) = DENALI_PHY_403_DATA  ; // PHY_MASTER_DLY_LOCK_OBS_3:RD:16:10:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_3:RD:0:16:=0x0000
    rgDENALI_PHY_404(base) = DENALI_PHY_404_DATA  ; // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_3:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_3:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_3:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_3:RD:0:6:=0x00
    rgDENALI_PHY_405(base) = DENALI_PHY_405_DATA  ; // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_3:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_3:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_3:RD:0:10:=0x0000
    rgDENALI_PHY_406(base) = DENALI_PHY_406_DATA  ; // PHY_WRLVL_HARD0DELAY_OBS_3:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_3:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_3:RD:0:8:=0x00
    rgDENALI_PHY_407(base) = DENALI_PHY_407_DATA  ; // PHY_WRLVL_HARD1DELAY_OBS_3:RD:0:10:=0x0000
    rgDENALI_PHY_408(base) = DENALI_PHY_408_DATA  ; // PHY_WRLVL_STATUS_OBS_3:RD:0:17:=0x000000
    rgDENALI_PHY_409(base) = DENALI_PHY_409_DATA  ; // PHY_GTLVL_HARD1DELAY_OBS_3:RD:16:14:=0x0000 PHY_GTLVL_HARD0DELAY_OBS_3:RD:0:14:=0x0000
    rgDENALI_PHY_410(base) = DENALI_PHY_410_DATA  ; // PHY_GTLVL_STATUS_OBS_3:RD:0:18:=0x000000
    rgDENALI_PHY_411(base) = DENALI_PHY_411_DATA  ; // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_3:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_3:RD:0:10:=0x0000
    rgDENALI_PHY_412(base) = DENALI_PHY_412_DATA  ; // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_3:RD:0:2:=0x00
    rgDENALI_PHY_413(base) = DENALI_PHY_413_DATA  ; // PHY_RDLVL_STATUS_OBS_3:RD:0:32:=0x00000000
    rgDENALI_PHY_414(base) = DENALI_PHY_414_DATA  ; // PHY_DDL_MODE_3:RW:0:18:=0x000000
    rgDENALI_PHY_415(base) = DENALI_PHY_415_DATA  ; // PHY_DDL_TEST_OBS_3:RD:0:32:=0x00000000
    rgDENALI_PHY_416(base) = DENALI_PHY_416_DATA  ; // PHY_DDL_TEST_MSTR_DLY_OBS_3:RD:0:32:=0x00000000
    rgDENALI_PHY_417(base) = DENALI_PHY_417_DATA  ; // PHY_RX_CAL_SAMPLE_WAIT_3:RW:24:8:=0x20 PHY_RX_CAL_OVERRIDE_3:RW:16:1:=0x00 SC_PHY_RX_CAL_START_3:WR:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_3:RW:0:8:=0x04
    rgDENALI_PHY_418(base) = DENALI_PHY_418_DATA  ; // PHY_RX_CAL_DQ13:RW+:16:12:=0x0000 PHY_RX_CAL_DQ03:RW+:0:12:=0x0000
    rgDENALI_PHY_419(base) = DENALI_PHY_419_DATA  ; // PHY_RX_CAL_DQ3_3:RW+:16:12:=0x0000 PHY_RX_CAL_DQ2_3:RW+:0:12:=0x0000
    rgDENALI_PHY_420(base) = DENALI_PHY_420_DATA  ; // PHY_RX_CAL_DQ5_3:RW+:16:12:=0x0000 PHY_RX_CAL_DQ4_3:RW+:0:12:=0x0000
    rgDENALI_PHY_421(base) = DENALI_PHY_421_DATA  ; // PHY_RX_CAL_DQ7_3:RW+:16:12:=0x0000 PHY_RX_CAL_DQ6_3:RW+:0:12:=0x0000
    rgDENALI_PHY_422(base) = DENALI_PHY_422_DATA  ; // PHY_RX_CAL_DQS_3:RW+:16:12:=0x0000 PHY_RX_CAL_DM_3:RW+:0:12:=0x0000
    rgDENALI_PHY_423(base) = DENALI_PHY_423_DATA  ; // PHY_RX_CAL_OBS_3:RD:16:11:=0x0000 PHY_RX_CAL_FDBK_3:RW+:0:12:=0x0000
    rgDENALI_PHY_424(base) = DENALI_PHY_424_DATA  ; // PHY_RX_CAL_DISABLE_3:RW:16:1:=0x00 PHY_RX_CAL_LOCK_OBS_3:RD:0:9:=0x0000
    rgDENALI_PHY_425(base) = DENALI_PHY_425_DATA  ; // PHY_CLK_WRDQ1SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ0SLAVE_DELAY_3:RW+:0:11:=0x0280
    rgDENALI_PHY_426(base) = DENALI_PHY_426_DATA  ; // PHY_CLK_WRDQ3_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_3:RW+:0:11:=0x0280
    rgDENALI_PHY_427(base) = DENALI_PHY_427_DATA  ; // PHY_CLK_WRDQ5_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_3:RW+:0:11:=0x0280
    rgDENALI_PHY_428(base) = DENALI_PHY_428_DATA  ; // PHY_CLK_WRDQ7_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_3:RW+:0:11:=0x0280
    rgDENALI_PHY_429(base) = DENALI_PHY_429_DATA  ; // PHY_CLK_WRDQS_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_3:RW+:0:11:=0x0280
    rgDENALI_PHY_430(base) = DENALI_PHY_430_DATA  ; // PHY_RDDQ0SLAVE_DELAY_3:RW:8:10:=0x0000 PHY_WRLVL_THRESHOLD_ADJUST_3:RW+:0:2:=0x00
    rgDENALI_PHY_431(base) = DENALI_PHY_431_DATA  ; // PHY_RDDQ2_SLAVE_DELAY_3:RW:16:10:=0x0000 PHY_RDDQ1SLAVE_DELAY_3:RW:0:10:=0x0000
    rgDENALI_PHY_432(base) = DENALI_PHY_432_DATA  ; // PHY_RDDQ4_SLAVE_DELAY_3:RW:16:10:=0x0000 PHY_RDDQ3_SLAVE_DELAY_3:RW:0:10:=0x0000
    rgDENALI_PHY_433(base) = DENALI_PHY_433_DATA  ; // PHY_RDDQ6_SLAVE_DELAY_3:RW:16:10:=0x0000 PHY_RDDQ5_SLAVE_DELAY_3:RW:0:10:=0x0000
    rgDENALI_PHY_434(base) = DENALI_PHY_434_DATA  ; // PHY_RDDM_SLAVE_DELAY_3:RW:16:10:=0x0000 PHY_RDDQ7_SLAVE_DELAY_3:RW:0:10:=0x0000
    rgDENALI_PHY_435(base) = DENALI_PHY_435_DATA  ; // PHY_RDDQS_DQ0FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ0RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_436(base) = DENALI_PHY_436_DATA  ; // PHY_RDDQS_DQ1FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ1RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_437(base) = DENALI_PHY_437_DATA  ; // PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_438(base) = DENALI_PHY_438_DATA  ; // PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_439(base) = DENALI_PHY_439_DATA  ; // PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_440(base) = DENALI_PHY_440_DATA  ; // PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_441(base) = DENALI_PHY_441_DATA  ; // PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_442(base) = DENALI_PHY_442_DATA  ; // PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_443(base) = DENALI_PHY_443_DATA  ; // PHY_RDDQS_DM_FALL_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DM_RISE_SLAVE_DELAY_3:RW+:0:10:=0x0080
    rgDENALI_PHY_444(base) = DENALI_PHY_444_DATA  ; // PHY_WRITE_PATH_LAT_ADD_3:RW:24:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_3:RW+:16:4:=0x00 PHY_RDDQS_GATE_SLAVE_DELAY_3:RW+:0:10:=0x0099
    rgDENALI_PHY_445(base) = DENALI_PHY_445_DATA  ; // PHY_WRLVL_DELAY_PERIOD_THRESHOLD_3:RW:16:10:=0x0000 PHY_WRLVL_DELAY_EARLY_THRESHOLD_3:RW:0:10:=0x01d0
    rgDENALI_PHY_446(base) = DENALI_PHY_446_DATA  ; // PHY_GTLVL_LAT_ADJ_START_3:RW:24:4:=0x00 PHY_GTLVL_RDDQS_SLV_DLY_START_3:RW:8:10:=0x0000 PHY_WRLVL_EARLY_FORCE_ZERO_3:RW:0:1:=0x00
    rgDENALI_PHY_447(base) = DENALI_PHY_447_DATA  ; // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_3:RW:0:10:=0x0000
    rgDENALI_PHY_448(base) = DENALI_PHY_448_DATA  ; // PHY_FDBK_PWR_CTRL_3:RW:0:3:=0x04
    rgDENALI_PHY_449(base) = DENALI_PHY_449_DATA  ; // PHY_DQS_OE_TIMING_3:RW:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_3:RW:16:8:=0x41 PHY_DQ_TSEL_RD_TIMING_3:RW:8:8:=0x41 PHY_DQ_OE_TIMING_3:RW:0:8:=0x52
    rgDENALI_PHY_450(base) = DENALI_PHY_450_DATA  ; // PHY_DQS_IE_TIMING_3:RW:24:8:=0x80 PHY_DQ_IE_TIMING_3:RW:16:8:=0x80 PHY_DQS_TSEL_WR_TIMING_3:RW:8:8:=0x41 PHY_DQS_TSEL_RD_TIMING_3:RW:0:8:=0x41
    rgDENALI_PHY_451(base) = DENALI_PHY_451_DATA  ; // PHY_RDDATA_EN_TSEL_DLY_3:RW:24:5:=0x01 PHY_RDDATA_EN_DLY_3:RW:16:5:=0x02 PHY_IE_MODE_3:RW:8:2:=0x00 PHY_RDDATA_EN_IE_DLY_3:RW:0:2:=0x00
    rgDENALI_PHY_452(base) = DENALI_PHY_452_DATA  ; // PHY_MASTER_DELAY_STEP_3:RW:24:6:=0x08 PHY_MASTER_DELAY_START_3:RW:8:10:=0x0010 PHY_SW_MASTER_MODE_3:RW:0:4:=0x00
    rgDENALI_PHY_453(base) = DENALI_PHY_453_DATA  ; // PHY_WRLVL_DLY_STEP_3:RW:24:4:=0x0c PHY_RPTR_UPDATE_3:RW:16:4:=0x05 PHY_MASTER_DELAY_HALF_MEASURE_3:RW:8:8:=0x3e PHY_MASTER_DELAY_WAIT_3:RW:0:8:=0x42
    rgDENALI_PHY_454(base) = DENALI_PHY_454_DATA  ; // PHY_GTLVL_RESP_WAIT_CNT_3:RW:16:5:=0x0f PHY_GTLVL_DLY_STEP_3:RW:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_3:RW:0:5:=0x0f
    rgDENALI_PHY_455(base) = DENALI_PHY_455_DATA  ; // PHY_GTLVL_FINAL_STEP_3:RW:16:10:=0x0100 PHY_GTLVL_BACK_STEP_3:RW:0:10:=0x0140
    rgDENALI_PHY_456(base) = DENALI_PHY_456_DATA  ; // PHY_RDLVL_DLY_STEP_3:RW:0:4:=0x0c
                       
    rgDENALI_PHY_512(base) = DENALI_PHY_512_DATA  ; // PHY_SW_GRP_SHIFT_3:RW+:24:4:=0x00 PHY_SW_GRP_SHIFT_2:RW+:16:4:=0x00 PHY_SW_GRP_SHIFT_1:RW+:8:4:=0x00 PHY_SW_GRP_SHIFT_0:RW+:0:4:=0x00
    rgDENALI_PHY_513(base) = DENALI_PHY_513_DATA  ; // PHY_SW_GRP_SHIFT_6:RW+:16:4:=0x00 PHY_SW_GRP_SHIFT_5:RW+:8:4:=0x00 PHY_SW_GRP_SHIFT_4:RW+:0:4:=0x00
    rgDENALI_PHY_514(base) = DENALI_PHY_514_DATA  ; // PHY_GRP_BYPASS_OVERRIDE:RW:24:1:=0x00 PHY_SW_GRP_BYPASS_SHIFT:RW:16:4:=0x05 PHY_GRP_BYPASS_SLAVE_DELAY:RW:0:10:=0x0000
    rgDENALI_PHY_515(base) = DENALI_PHY_515_DATA  ; // PHY_GRP_SHIFT_OBS_SELECT:RW:24:5:=0x00 PHY_GRP_SLV_DLY_ENC_OBS_SELECT:RW:8:10:=0x0000 SC_PHY_MANUAL_UPDATE:WR:0:1:=0x00
    rgDENALI_PHY_516(base) = DENALI_PHY_516_DATA  ; // PHY_ADRCTL_MANUAL_CLEAR:WR:24:2:=0x00 PHY_GRP_SHIFT_OBS:RD:16:2:=0x00 PHY_GRP_SLV_DLY_ENC_OBS:RD:0:10:=0x0000
    rgDENALI_PHY_517(base) = DENALI_PHY_517_DATA  ; // PHY_ADRCTL_SLAVE_LOOP_CNT_UPDATE:RW:24:3:=0x00 PHY_ADRCTL_MASTER_DLY_LOCK_OBS:RD:8:10:=0x0000 PHY_ADRCTL_MASTER_DLY_LOCK_OBS_SELECT:RW:0:4:=0x00
    rgDENALI_PHY_518(base) = DENALI_PHY_518_DATA  ; // PHY_CONTINUOUS_CLK_CAL_UPDATE:RW:24:1:=0x00 SC_PHY_UPDATE_CLK_CAL_VALUES:WR:16:1:=0x00 PHY_DFI_PHYUPD_TYPE:RW:8:2:=0x01 PHY_ADRCTL_SNAP_OBS_REGS:WR:0:1:=0x00
    rgDENALI_PHY_519(base) = DENALI_PHY_519_DATA  ; // PHY_SW_TXIO_CTRL_3:RW:24:4:=0x00 PHY_SW_TXIO_CTRL_2:RW:16:4:=0x00 PHY_SW_TXIO_CTRL_1:RW:8:4:=0x00 PHY_SW_TXIO_CTRL_0:RW:0:4:=0x00
    rgDENALI_PHY_520(base) = DENALI_PHY_520_DATA  ; // PHY_MEMCLK_SW_TXIO_CTRL:RW:24:1:=0x00 PHY_SW_TXIO_CTRL_6:RW:16:4:=0x00 PHY_SW_TXIO_CTRL_5:RW:8:4:=0x00 PHY_SW_TXIO_CTRL_4:RW:0:4:=0x00
    rgDENALI_PHY_521(base) = DENALI_PHY_521_DATA  ; // PHY_MEMCLK_SW_TXPWR_CTRL:RW:8:1:=0x01 PHY_CA_SW_TXPWR_CTRL:RW:0:1:=0x01
    rgDENALI_PHY_522(base) = DENALI_PHY_522_DATA  ; // PHY_USER_DEF_REG_AC_0:RW:0:32:=0x00000000
    rgDENALI_PHY_523(base) = DENALI_PHY_523_DATA  ; // PHY_USER_DEF_REG_AC_1:RW:0:32:=0x00000000
    rgDENALI_PHY_524(base) = DENALI_PHY_524_DATA  ; // PHY_USER_DEF_REG_AC_2:RW:0:32:=0x00000000
    rgDENALI_PHY_525(base) = DENALI_PHY_525_DATA  ; // PHY_USER_DEF_REG_AC_3:RW:0:32:=0x00000000
    rgDENALI_PHY_526(base) = DENALI_PHY_526_DATA  ; // PHY_PLL_CTRL:RW:8:13:=0x1102 PHY_PLL_WAIT:RW:0:8:=0x64
    rgDENALI_PHY_527(base) = DENALI_PHY_527_DATA  ; // PHY_PLL_CTRL_CA:RW:0:13:=0x0122
    rgDENALI_PHY_528(base) = DENALI_PHY_528_DATA  ; // PHY_PLL_BYPASS:RW+:0:4:=0x00
    rgDENALI_PHY_529(base) = DENALI_PHY_529_DATA  ; // PHY_PAD_VREF_CTRL_DQ_0:RW:8:12:=0x0100 PHY_LOW_FREQ_SEL:RW:0:1:=0x00
    rgDENALI_PHY_530(base) = DENALI_PHY_530_DATA  ; // PHY_PAD_VREF_CTRL_DQ_2:RW:16:12:=0x0100 PHY_PAD_VREF_CTRL_DQ_1:RW:0:12:=0x0100
    rgDENALI_PHY_531(base) = DENALI_PHY_531_DATA  ; // PHY_PAD_VREF_CTRL_AC:RW:16:12:=0x0100 PHY_PAD_VREF_CTRL_DQ_3:RW:0:12:=0x0100
    rgDENALI_PHY_532(base) = DENALI_PHY_532_DATA  ; // PHY_ADRCTL_MASTER_DELAY_STEP:RW:24:6:=0x08 PHY_ADRCTL_MASTER_DELAY_START:RW:8:10:=0x0010 PHY_ADRCTL_SW_MASTER_MODE:RW:0:4:=0x00
    rgDENALI_PHY_533(base) = DENALI_PHY_533_DATA  ; // PHY_SET_DFI_INPUT_RST_PAD:RW:16:1:=0x00 PHY_ADRCTL_MASTER_DELAY_HALF_MEASURE:RW:8:8:=0x3e PHY_ADRCTL_MASTER_DELAY_WAIT:RW:0:8:=0x42
    rgDENALI_PHY_534(base) = DENALI_PHY_534_DATA  ; // PHY_GRP_SLAVE_DELAY_1:RW+:16:10:=0x0100 PHY_GRP_SLAVE_DELAY_0:RW+:0:10:=0x0100
    rgDENALI_PHY_535(base) = DENALI_PHY_535_DATA  ; // PHY_GRP_SLAVE_DELAY_3:RW+:16:10:=0x0100 PHY_GRP_SLAVE_DELAY_2:RW+:0:10:=0x0100
    rgDENALI_PHY_536(base) = DENALI_PHY_536_DATA  ; // PHY_GRP_SLAVE_DELAY_5:RW+:16:10:=0x0100 PHY_GRP_SLAVE_DELAY_4:RW+:0:10:=0x0100
    rgDENALI_PHY_537(base) = DENALI_PHY_537_DATA  ; // PHY_PLL_CTRL_OVERRIDE:RW:16:16:=0x0924 PHY_GRP_SLAVE_DELAY_6:RW+:0:10:=0x0100
    rgDENALI_PHY_538(base) = DENALI_PHY_538_DATA  ; // PHY_PLL_OBS_1:RD:16:16:=0x0000 PHY_PLL_OBS_0:RD:0:16:=0x0000
    rgDENALI_PHY_539(base) = DENALI_PHY_539_DATA  ; // PHY_PLL_OBS_3:RD:16:16:=0x0000 PHY_PLL_OBS_2:RD:0:16:=0x0000
    rgDENALI_PHY_540(base) = DENALI_PHY_540_DATA  ; // PHY_LS_IDLE_EN:RW:24:1:=0x00 PHY_LP_WAKEUP:RW:16:8:=0x00 PHY_TCKSRE_WAIT:RW:8:4:=0x03 PHY_PLL_TESTOUT_SEL:RW:0:2:=0x02
    rgDENALI_PHY_541(base) = DENALI_PHY_541_DATA  ; // PHY_TDFI_PHY_WRDELAY:RW:8:1:=0x00 PHY_LP_CTRLUPD_CNTR_CFG:RW:0:5:=0x14
    rgDENALI_PHY_542(base) = DENALI_PHY_542_DATA  ; // PHY_PAD_FDBK_DRIVE:RW+:0:23:=0x000011
    rgDENALI_PHY_543(base) = DENALI_PHY_543_DATA  ; // PHY_PAD_FDBK_DRIVE2:RW+:0:16:=0x0011
    rgDENALI_PHY_544(base) = DENALI_PHY_544_DATA  ; // PHY_PAD_DATA_DRIVE:RW+:0:21:=0x000400
    rgDENALI_PHY_545(base) = DENALI_PHY_545_DATA  ; // PHY_PAD_DQS_DRIVE:RW+:0:23:=0x000000
    rgDENALI_PHY_546(base) = DENALI_PHY_546_DATA  ; // PHY_PAD_ADDR_DRIVE:RW+:0:29:=0x00000011
    rgDENALI_PHY_547(base) = DENALI_PHY_547_DATA  ; // PHY_PAD_CLK_DRIVE:RW+:0:31:=0x00000011
    rgDENALI_PHY_548(base) = DENALI_PHY_548_DATA  ; // PHY_PAD_FDBK_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_549(base) = DENALI_PHY_549_DATA  ; // PHY_PAD_DATA_TERM:RW+:0:17:=0x004410
    rgDENALI_PHY_550(base) = DENALI_PHY_550_DATA  ; // PHY_PAD_DQS_TERM:RW+:0:17:=0x004410
    rgDENALI_PHY_551(base) = DENALI_PHY_551_DATA  ; // PHY_PAD_ADDR_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_552(base) = DENALI_PHY_552_DATA  ; // PHY_PAD_CLK_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_553(base) = DENALI_PHY_553_DATA  ; // PHY_PAD_CKE_DRIVE:RW+:0:29:=0x00000011
    rgDENALI_PHY_554(base) = DENALI_PHY_554_DATA  ; // PHY_PAD_CKE_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_555(base) = DENALI_PHY_555_DATA  ; // PHY_PAD_RST_DRIVE:RW+:0:29:=0x00000011
    rgDENALI_PHY_556(base) = DENALI_PHY_556_DATA  ; // PHY_PAD_RST_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_557(base) = DENALI_PHY_557_DATA  ; // PHY_PAD_CS_DRIVE:RW+:0:29:=0x00000011
    rgDENALI_PHY_558(base) = DENALI_PHY_558_DATA  ; // PHY_PAD_CS_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_559(base) = DENALI_PHY_559_DATA  ; // PHY_PAD_ODT_DRIVE:RW+:0:29:=0x00000011
    rgDENALI_PHY_560(base) = DENALI_PHY_560_DATA  ; // PHY_PAD_ODT_TERM:RW+:0:18:=0x004410
    rgDENALI_PHY_561(base) = DENALI_PHY_561_DATA  ; // PHY_ADRCTL_RX_CAL:RW:0:14:=0x0000
    rgDENALI_PHY_562(base) = DENALI_PHY_562_DATA  ; // PHY_TST_CLK_PAD_CTRL:RW:0:32:=0x00000000
    rgDENALI_PHY_563(base) = DENALI_PHY_563_DATA  ; // PHY_TST_CLK_PAD_CTRL2:RW:0:23:=0x000000
    rgDENALI_PHY_564(base) = DENALI_PHY_564_DATA  ; // PHY_TST_CLK_PAD_CTRL3:RW:0:21:=0x000000
    rgDENALI_PHY_565(base) = DENALI_PHY_565_DATA  ; // PHY_CAL_START_0:WR:24:1:=0x00 PHY_CAL_CLEAR_0:WR:16:1:=0x00 PHY_CAL_MODE_0:RW:0:9:=0x0004
    rgDENALI_PHY_566(base) = DENALI_PHY_566_DATA  ; // PHY_CAL_INTERVAL_COUNT_0:RW:0:32:=0x00000000
    rgDENALI_PHY_567(base) = DENALI_PHY_567_DATA  ; // PHY_CAL_CLK_SELECT_0:RW:8:3:=0x01 PHY_CAL_SAMPLE_WAIT_0:RW:0:8:=0x08
    rgDENALI_PHY_568(base) = DENALI_PHY_568_DATA  ; // PHY_CAL_RESULT_OBS_0:RD:0:24:=0x000000
    rgDENALI_PHY_569(base) = DENALI_PHY_569_DATA  ; // PHY_AC_LPBK_ERR_CLEAR:WR:24:1:=0x00 PHY_ADRCTL_MANUAL_UPDATE:WR:16:1:=0x00 PHY_PAD_ATB_CTRL:RW:0:16:=0x0000
    rgDENALI_PHY_570(base) = DENALI_PHY_570_DATA  ; // PHY_AC_LPBK_CONTROL:RW:16:9:=0x0000 PHY_AC_LPBK_ENABLE:RW:8:7:=0x00 PHY_AC_LPBK_OBS_SELECT:RW:0:3:=0x00
    rgDENALI_PHY_571(base) = DENALI_PHY_571_DATA  ; // PHY_AC_PRBS_PATTERN_MASK:RW:8:4:=0x00 PHY_AC_PRBS_PATTERN_START:RW_D:0:7:=0x01
    rgDENALI_PHY_572(base) = DENALI_PHY_572_DATA  ; // PHY_AC_LPBK_RESULT_OBS:RD:0:32:=0x00000000
    rgDENALI_PHY_573(base) = DENALI_PHY_573_DATA  ; // PHY_AC_CLK_LPBK_CONTROL:RW:16:6:=0x00 PHY_AC_CLK_LPBK_ENABLE:RW:8:1:=0x00 PHY_AC_CLK_LPBK_OBS_SELECT:RW:0:1:=0x00
    rgDENALI_PHY_574(base) = DENALI_PHY_574_DATA  ; // PHY_AC_PWR_RDC_DISABLE:RW:16:1:=0x00 PHY_AC_CLK_LPBK_RESULT_OBS:RD:0:16:=0x0000
    rgDENALI_PHY_575(base) = DENALI_PHY_575_DATA  ; // PHY_DDL_AC_ENABLE:RW:0:32:=0x00000000
    rgDENALI_PHY_576(base) = DENALI_PHY_576_DATA  ; // PHY_DDL_AC_MODE:RW:0:11:=0x0000
    rgDENALI_PHY_577(base) = DENALI_PHY_577_DATA  ; // PHY_DDL_AC_TEST_OBS:RD:0:32:=0x00000000
    rgDENALI_PHY_578(base) = DENALI_PHY_578_DATA  ; // PHY_DDL_TRACK_UPD_THRESHOLD_AC:RW:24:8:=0x04 PHY_INIT_UPDATE_CONFIG:RW:16:3:=0x07 PHY_PAD_BACKGROUND_CAL:RW:8:1:=0x01 PHY_DDL_AC_TEST_INDEX:RW:0:2:=0x00
    rgDENALI_PHY_579(base) = DENALI_PHY_579_DATA  ; // PHY_DS_INIT_COMPLETE_OBS:RD:24:4:=0x00 PHY_AC_INIT_COMPLETE_OBS:RD:8:15:=0x0000 PHY_DLL_RST_EN:RW_D:0:2:=0x02
    rgDENALI_PHY_580(base) = DENALI_PHY_580_DATA  ; // PHY_UPDATE_MASK:RW:0:1:=0x00

    asm("DMB":::"memory");

    rgDENALI_CTL_00(base) |= 0x1; // start EMIC

    asm("DMB":::"memory");
    
    while (!(rgDENALI_CTL_45(base) & 0x1000)) {};
    
    rgDENALI_CTL_46(base) = 0x10; // clear interruption flag
    asm("DMB":::"memory");
}
