OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_reset)

MEMORY
{
	MB : ORIGIN = 0x00060000, LENGTH = 0x00020000
}

SECTIONS
{
	. = ORIGIN(MB);

	.libload ORIGIN(MB) (NOLOAD) :
	{
		. = ALIGN(4);
		__ll_table_start = .;

		KEEP( *(.ll_table) )

		. = ALIGN(4);
		__ll_table_end = .;

		. = 0x00002000;
	} > MB

	. = ALIGN(4);
	__exec_begin = .;

	.text : ALIGN(4)
	{
		. = ALIGN(32);
		__ll_vectors_start = .;

		KEEP( *(.text.vectors) )

		. = ALIGN(4);
		__ll_vectors_end = .;

		KEEP( *(.text.startup .text.startup.*) )
		*(.text .text.*)
		*(.rodata .rodata.*)
	} > MB

	.plt : { *(.plt) *(.iplt) } > MB

	. = .;

	.got : { *(.got.plt) *(.igot.plt) *(.got) *(.igot) } > MB

	.data : ALIGN(4)
	{
		*(.data .data.*)
	} > MB

	. = ALIGN(4);
	__exec_limit = .;
	
	.bss (NOLOAD) :
	{
		. = ALIGN(4);
		__bss_start = .;

		*(.bss COMMON .bss.*)

		. = ALIGN(4);
		__bss_end = .;
	} > MB

	. = .;

	.stack (NOLOAD) : ALIGN(8)
	{
		__stack_end = .;
		. = . + 0x200;
		__stack_mon = .;
		. = . + 0x400;
		__stack_irq = .;
		. = . + 0x200;
		__stack_fiq = .;
		. = . + 0x200;
		__stack_abt = .;
		. = . + 0x200;
		__stack_und = .;
		. = . + 0x800;
		__stack_usr = .;
		. = . + 0x800;
		__stack_svc = .;
		 __stack_start = .;
	} > MB

	. = ORIGIN(MB) + 0x8000;

	.heap (ORIGIN(MB) + 0x8000) (NOLOAD) : ALIGN(8)
	{
		__heap_begin = .;
		. = . + 0x00007000;
		__heap_end = .;

		__reserved_base = .;
		KEEP( *(.heap.reserved) )
		__reserved_limit = .;

		. = 0x00008000;
	} > MB

	/DISCARD/ :
	{
		*(*)
	}
}
