extern void cli_loop(void *arg);
extern void EMIC_init(unsigned int base);

extern int __ll_vectors_start;
extern int __ll_vectors_end;

extern int __ll_table_start;
extern int __ll_table_end;

extern int __reserved_base;
extern int __reserved_limit;

#include "init_code.h"
#include "libload_def.h"

#ifndef INIT_CODE_VERSION_MAJOR
#define INIT_CODE_VERSION_MAJOR		2
#endif

#ifndef INIT_CODE_VERSION_MINOR
#define INIT_CODE_VERSION_MINOR		1
#endif

#ifndef BUILD_Y
#define BUILD_Y 0
#endif

#ifndef BUILD_M
#define BUILD_M 0
#endif

#ifndef BUILD_D
#define BUILD_D 0
#endif

#ifndef BUILD_N
#define BUILD_N 0
#endif

#define INIT_CODE_MAJOR_MINOR	((INIT_CODE_VERSION_MAJOR << 16) | (INIT_CODE_VERSION_MINOR & 0xFFFF))
#define INIT_CODE_DATE_REVID	((((BUILD_Y << 9) | (BUILD_M << 5) | (BUILD_D << 0)) << 16) | (BUILD_N & 0xFFFF))

int main(void) asm("_main");
int main(void)
{
	struct libload_table	*ll_tbl;
	struct libload_ext	*ll_ext;

#ifndef USE_EDCL
	struct nm6408_magic	*magic;
#endif

	unsigned int		*start;
	unsigned int		*end;

	unsigned long		value;
	int			i;

#ifndef USE_EDCL
	asm("MOV %0, R9":"=r" (value)::"memory");
	magic = (struct nm6408_magic *)value;

#if defined(MC12705)
	if (magic->magic_code != 0x64080001) {
		*((volatile unsigned int *)0x000CC010) |= 0x1;
		*((volatile unsigned int *)0x000CC000) &= ~0x1;
#elif defined(NM_CARD)
	if (magic->magic_code != 0x64080002) {
#elif defined(NM_MEZZO)
	if (magic->magic_code != 0x64080003) {
#elif defined(NM_QUAD)
	if (magic->magic_code != 0x64080004) {
#elif defined(NEURO_MEZZANINE)
	if (magic->magic_code != 0x64080005) {
#else
	#error Unknown board!
#endif
		while (1) {};
	}
#endif

	value = (unsigned long)&__ll_table_start;
	if (LIBLOAD_DATA_ADDR != (value + CCPU_INBOUND_AXI_BASE)) {
#ifdef MC12705
		*((volatile unsigned int *)0x000CC010) |= 0x1;
		*((volatile unsigned int *)0x000CC000) &= ~0x1;
#endif
		while (1) {};
	}

	start = &__ll_table_start;
	end = &__ll_table_end;

	while (start < end)
		*start++ = 0;

	ll_tbl = (void *)((unsigned long)&__ll_table_start);

#ifndef USE_EDCL
	ll_tbl->top.arm.serial[0] = magic->serial[0];
	ll_tbl->top.arm.serial[1] = magic->serial[1];

	ll_tbl->top.arm.version[0] = magic->version[0];
	ll_tbl->top.arm.version[1] = magic->version[1];

	ll_tbl->top.arm.post_status = magic->post_test;
#else
	ll_tbl->top.arm.serial[0] = -1;
	ll_tbl->top.arm.serial[1] = -1;

	ll_tbl->top.arm.version[0] = INIT_CODE_MAJOR_MINOR;
	ll_tbl->top.arm.version[1] = INIT_CODE_DATE_REVID;

	ll_tbl->top.arm.post_status = 0;
#endif

	ll_tbl->ptr = (unsigned long)&__reserved_base;
	if (ll_tbl->ptr != LIBLOAD_DATA_READY) {
#ifdef MC12705
		*((volatile unsigned int *)0x000CC010) |= 0x1;
		*((volatile unsigned int *)0x000CC000) &= ~0x1;
#endif
		while (1) {};
	}
	ll_tbl->ptr |= CCPU_INBOUND_AXI_BASE;

	ll_ext = (void *)((unsigned long)&__reserved_base);

	ll_ext->info_max_size = (
		((unsigned long)&__reserved_limit - (unsigned long)&__reserved_base)
		- (sizeof(struct libload_ext) + 32)
	);

	ll_ext->info.invalid = ~0;
#ifndef USE_EDCL
	ll_ext->info.board_addr = *((volatile unsigned int *)0x000D922C);
#else
	ll_ext->info.board_addr = *((volatile unsigned int *)0x000D001C);
#endif
	ll_ext->info.board_indx = -1;

	for (i = 0; i < NM6408_CCPU; i++)
		ll_ext->info.cluster_rdy[i] = 0;

	ll_ext->info.board_cnt = 0;

	value = (unsigned long)&ll_tbl->irq_table[0];
	asm("MOV R9, %0"::"r" (value):"memory");

	*(((unsigned long *)&__ll_vectors_start) + 5) = value;

	value = (unsigned long)&__ll_vectors_start;
	asm("MCR p15, 0, %0, c12, c0, 0"::"r" (value):"memory");

#ifndef USE_EDCL

	*((volatile unsigned int *)0x000B0000) = 0x00000000;
	*((volatile unsigned int *)0x000B1000) = 0x00000000;

	asm("DMB":::"memory");

	*((volatile unsigned int *)0x000B0080) = 0x00000000;
	*((volatile unsigned int *)0x000B0084) = 0x00000000;
	*((volatile unsigned int *)0x000B0088) = 0x00000000;

	*((volatile unsigned int *)0x000B0184) = 0xFFFFFFFF;
	*((volatile unsigned int *)0x000B0188) = 0xFFFFFFFF;

	value = *((volatile unsigned int *)0x000B0C08);
	value &= ~0x00002000;
	*((volatile unsigned int *)0x000B0C08) = value;

	value = *((volatile unsigned int *)0x000B0C10);
	value &= ~0x0AAA0000;
	*((volatile unsigned int *)0x000B0C10) = value;

	value = *((volatile unsigned int *)0x000B0424);
	value &= ~0x00F80000;
	value |= 0x00780000;
	*((volatile unsigned int *)0x000B0424) = value;

	value = *((volatile unsigned int *)0x000B0448);
	value &= ~0xF8F8F8F8;
	value |= 0x78787878;
	*((volatile unsigned int *)0x000B0448) = value;

	value = *((volatile unsigned int *)0x000B044C);
	value &= ~0x0000F8F8;
	value |= 0x00007878;
	*((volatile unsigned int *)0x000B044C) = value;

	*((volatile unsigned int *)0x000B0104) = 0x00000040;
	*((volatile unsigned int *)0x000B0108) = 0x00003F00;

	asm("DMB":::"memory");

	*((volatile unsigned int *)0x000B1004) = 0x000000FF;
	*((volatile unsigned int *)0x000B1000) = 0x00000001;

	asm("DMB":::"memory");

	*((volatile unsigned int *)0x000B1008) = 0x00000002;
	*((volatile unsigned int *)0x000B0000) = 0x00000001;

#endif /* USE_EDCL */

	/* In SVC mode (IRQ, ABORT - enable; FIQ - disable) */
	asm volatile ("MRS %0, CPSR":"=r" (value)::"memory");
	value &= ~0x1DF;
	value |= 0x0053;
	asm volatile ("MSR CPSR_fxc, %0"::"r" (value):"memory");

	EMIC_init(PC0_INBOUND_AXI_BASE);
	EMIC_init(PC1_INBOUND_AXI_BASE);
	EMIC_init(PC2_INBOUND_AXI_BASE);
	EMIC_init(PC3_INBOUND_AXI_BASE);

	cli_loop(ll_tbl);
}
