.global CRC32_F
CRC32_F: //-----------------------------------

    PUSH  {R1-R7, LR}
/*
 * Input:
 *    R0 - Memory Bgn
 *    R1 - Memory Lng
 *    
 * Output:
 *    R0 - crc32
 *
 * R1 - Memory Bgn
 * R2 - Memory End
 * R3 - CRC
 * R4 - CRC polynom
 * R5 - Bit in word number
 * R7 - work
 *
 */
    ADD R2, R1, R0
    MOV R1, R0

    MOV R3, #0
    SUB R3, #1          // CRC32 initial value
    LDR R4, =0x04C11DB7 // CRC32 polynom
3:
    CMP R1, R2
    BGE 1f // CRC32 ready
    LDR R7, [R1], #4
    EOR R3, R7
    MOV R5, #32
2:
    TST    R3, #0x80000000
    LSLNE  R3, #1 // CRC32[31] == 1
    EORNE  R3, R4 // CRC32[31] == 1
    LSLEQ  R3, #1 // CRC32[31] == 0
    SUBS R5, #1
    BNE  2b
    B    3b
1:
    MOV  R0, #0
    SUB  R0, #1
    EOR  R0, R3
    POP  {R1-R7, PC} // return

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^ END ^^^^^^^^^^^^^^^^^^^^^^^^^    

