OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)

SECTIONS
{
	__rel_base = 0x00070000; /* 0x0006F000 */

	__rel_start = 0x00000000;
	. = __rel_start;

	.text : ALIGN(4)
	{	. = 0;
		KEEP( *(.text.reset) )

		. = 0x800;
		KEEP( *(.rodata.magic) )

		. = 0x1000;
		KEEP( *(.text.init) )
		*(.text .text.*)
		*(.rodata .rodata.*)
	}

	.plt : { *(.plt) *(.iplt) }

	. = .;

	.got : { *(.got.plt) *(.igot.plt) *(.got) *(.igot) }

	.data : ALIGN(4)
	{
		__abs_desc = ABSOLUTE(.) - __rel_start + __rel_base;
		KEEP( *(.data.desc) )

		*(.data .data.*)
	}

	. = ALIGN(4);
	__rel_end = .;

	 __bss_start = .;

	.bss (NOLOAD) :
	{
		*(.bss .bss.* COMMON)
	}

	. = ALIGN(4);
	__bss_end = .;

	.stack 0x00078000 (NOLOAD) : ALIGN(8)
	{
		__stack_limit = .;
		*(.stack)

		. = 0x00007000;
		__stack_default = .;
	}

	/DISCARD/ :
	{
		*(*)
	}
}
