extern char __buf_head;
extern char __buf_tail;

static char *head_buf = &__buf_head;
static char *tail_buf = &__buf_tail;

extern int SIMPLE_ERASE(int, long, long);
extern int SIMPLE_WRITE(int, long, long, char *);
extern int SIMPLE_READ(int, long, long, char *);

int do_copy(int disp, int lng, char *data)
{
    int ret = 0;

    long head_disp; /* points to first modifyed flash block */
    long data_disp; /* points to first modifyed flash byte */
    long tail_disp; /* points to next after last modifyed flash byte */
    long end_disp;  /* points to next after last modifyed flash block */

    char *head_ptr = (void *)0; 
    char *data_ptr = (void *)0;
    char *tail_ptr = (void *)0;

    long head_lng; /* data_disp - head_disp */
    long data_lng; /* tail_disp - data_disp */
    long tail_lng; /* end_disp  - tail_disp */

    int d;
    int dd;
    int i;

    if ((disp < 0) || (lng <= 0) || (data == (void *)0))
        return -1;

    head_disp = disp & 0xFFFF0000; /* 64K block size */
    data_disp = disp;
    tail_disp = disp + lng;
    end_disp  = (tail_disp + 0xFFFF) & 0xFFFF0000;

    data_ptr = data;
    head_ptr = head_buf;
    tail_ptr = tail_buf;

    head_lng = data_disp - head_disp;
    data_lng = lng;
    tail_lng = end_disp - tail_disp;

    if (head_lng > 0) {
        SIMPLE_READ (0, head_disp, head_lng, head_ptr);

        d = head_lng & 0xFF;
        if (d > 0) {
            d = 256 - d;
            dd = d > data_lng ? data_lng : d;

            /* cp  from data to head */
            for (i = 0; i < dd; i++)
                *(head_ptr + head_lng + i) = *(data_ptr + i);

            data_lng  -= dd;
            data_ptr  += dd;
            data_disp += dd;
            head_lng  += dd;
        }
    }

    if (data_lng == 0) {
        if (tail_lng > 0) {
            SIMPLE_READ (0, tail_disp, tail_lng, tail_ptr);

            d = head_lng & 0xFF;
            if (d > 0) {
                d = 256 - d;
                dd = d > tail_lng ? tail_lng : d;

                /* cp  from tail to head */
                for (i = 0; i < dd; i++)
                    *(head_ptr + head_lng + i) = *(tail_ptr + i);

                tail_lng  -= dd;
                tail_ptr  += dd;
                tail_disp += dd;
                head_lng  += dd;
            }
        }
    }
    else {
        if (tail_lng > 0) {
            dd = 0;

            d = tail_lng & 0xFF;
            if (d > 0) {
                d = 256 - d;
                dd = d > data_lng ? data_lng : d;

                /* cp from data to tail */
                for (i = 0; i < dd; i++)
                    *(tail_ptr + i) = *(data_ptr + (data_lng - dd) + i);
            }

            SIMPLE_READ (0, tail_disp, tail_lng, tail_ptr + dd);

            tail_lng  += dd;
            tail_disp -= dd;
            data_lng  -= dd;
        }
    }

    SIMPLE_ERASE (0, head_disp, end_disp - head_disp);
    SIMPLE_WRITE (0, head_disp, head_lng, head_ptr);
    SIMPLE_WRITE (0, data_disp, data_lng, data_ptr);
    SIMPLE_WRITE (0, tail_disp, tail_lng, tail_ptr);

exit:
    return ret;
}

