OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)

MEMORY
{
	IMB0	: ORIGIN = 0x00000000, LENGTH = 0x00020000
	IMB1	: ORIGIN = 0x00020000, LENGTH = 0x00040000
	IMB2	: ORIGIN = 0x00060000, LENGTH = 0x00020000
}

ENTRY(_start)

SECTIONS
{
	.text :
	{
		KEEP ( *(.text_vectors) )

		. = ALIGN(8);
		*(.text .text.*)

		. = ALIGN(8);
		*(.rodata .rodata.*)
	} > IMB0

	.data :
	{
		. = ALIGN(8);
		*(.data .data.*)
	} > IMB0

	.bss (NOLOAD) :
	{
		. = ALIGN(8);
		_noload_start = .;

		_bss_start = .;
		*(.bss COMMON .bss.*)
		_bss_end = .;

		. = ALIGN(8);
		_stack_start = .;
		*(.stack)
		_stack_end = .;

		_noload_end = .;
	} > IMB0

	.data.image_array :
	{
		_image_start = .;
		. = . + 0x8;
		./build/main.o(.image_array)
		. = ALIGN(4) + 0x4;
		_image_end = .;
	} > IMB1

	.bss.buf (NOLOAD) :
	{
		_buf_head = .;
		. = . + 0x10000;
		_buf_tail = .;
		. = . + 0x10000;
	} > IMB2
}
