extern int _image_start;
extern int _image_end;

extern int crc32_calc(int *, int);
extern int do_copy(int, int, char *);

extern int SIMPLE_READ(int, long, long, char *);

#include "flash_image_array.h"

static int *start_image = &_image_start;
static int *end_image = &_image_end;

int main (void)
{
	int image_size = (int)((char *)end_image - (char *)start_image);
	int crc, ret;
	int i;

	// LED control
	*((unsigned long *)0x000CC010) |= 0x9;
	*((unsigned long *)0x000CC000) |= 0x9;

	if ((image_size - 8) > 0x30000) {
		ret = -1;
		goto test_exit;
	}

	*(start_image + 0) = 0x12345678;
	*(start_image + 1) = (image_size - 8) & 0xFFFFFF;
	crc = crc32_calc(start_image + 2, image_size - 12);
	*(end_image - 1) = crc;

	if (do_copy(0x0, image_size, (char *)start_image)) {
		ret = -2;
		goto test_exit;
	}

	SIMPLE_READ (0, 0x0, 4, (char *)&ret);
	if (ret != 0x12345678) {
		ret = -3;
		goto test_exit;
	}

	SIMPLE_READ (0, image_size - 4, 4, (char *)&ret);
	if (ret != crc) {
		ret = -4;
		goto test_exit;
	}

	for (i = 0; i < image_size / 4; i++)
		*(start_image + i) = 0;

	SIMPLE_READ (0, 0x4, 4, (char *)&i);
	SIMPLE_READ (0, 0x8, i - 4, (char *)(start_image + 2));
	ret = crc32_calc(start_image + 2, i - 4);
	if (ret != crc) {
		ret = -5;
		goto test_exit;
	}

	ret = 0;

test_exit:

	if (!ret)
		*((unsigned long *)0x000CC000) &= ~0x8;
	else
		*((unsigned long *)0x000CC000) &= ~0x1;

	return ret;
}
