#include "defs.h"
#include "CP.h"



void config_CP(CP_reg_config *reg_config) // Configuration of CP's registers, the CP itself is specified in variable "numb"" of structure reg_config
{
	switch (reg_config ->numb) {
		case 0: 
			rgCP0_TR_MainCounter	= reg_config ->TR_MainCounter;
			rgCP0_TR_Address	= (u32)reg_config ->TR_Address;
			rgCP0_TR_Bias	= reg_config ->TR_Bias;
			rgCP0_TR_RowCounter	= reg_config ->TR_RowCounter;
			rgCP0_TR_AddressMode	= reg_config ->TR_AddressMode;
			rgCP0_TR_InterruptMask	= reg_config ->TR_InterruptMask;
 
			rgCP0_RC_MainCounter	= reg_config ->RC_MainCounter;
			rgCP0_RC_Address	=(u32) reg_config ->RC_Address;
			rgCP0_RC_Bias	= reg_config ->RC_Bias;
			rgCP0_RC_RowCounter	= reg_config ->RC_RowCounter;
			rgCP0_RC_AddressMode	= reg_config ->RC_AddressMode;
			rgCP0_RC_InterruptMask	= reg_config ->RC_InterruptMask;
		break;
		case 1: 
			rgCP1_TR_MainCounter	= reg_config ->TR_MainCounter;
			rgCP1_TR_Address	=(u32) reg_config ->TR_Address;
			rgCP1_TR_Bias	= reg_config ->TR_Bias;
			rgCP1_TR_RowCounter	= reg_config ->TR_RowCounter;
			rgCP1_TR_AddressMode	= reg_config ->TR_AddressMode;
			rgCP1_TR_InterruptMask	= reg_config ->TR_InterruptMask;
 
			rgCP1_RC_MainCounter	= reg_config ->RC_MainCounter;
			rgCP1_RC_Address	=(u32) reg_config ->RC_Address;
			rgCP1_RC_Bias	= reg_config ->RC_Bias;
			rgCP1_RC_RowCounter	= reg_config ->RC_RowCounter;
			rgCP1_RC_AddressMode	= reg_config ->RC_AddressMode;
			rgCP1_RC_InterruptMask	= reg_config ->RC_InterruptMask;
		break;
		case 2: 
			rgCP2_TR_MainCounter	= reg_config -> TR_MainCounter;
			rgCP2_TR_Address	= (u32)reg_config -> TR_Address;
			rgCP2_TR_Bias	= reg_config -> TR_Bias;
			rgCP2_TR_RowCounter	= reg_config -> TR_RowCounter;
			rgCP2_TR_AddressMode	= reg_config -> TR_AddressMode;
			rgCP2_TR_InterruptMask	= reg_config -> TR_InterruptMask;
 
			rgCP2_RC_MainCounter	= reg_config -> RC_MainCounter;
			rgCP2_RC_Address	= (u32)reg_config -> RC_Address;
			rgCP2_RC_Bias	= reg_config -> RC_Bias;
			rgCP2_RC_RowCounter	= reg_config -> RC_RowCounter;
			rgCP2_RC_AddressMode	= reg_config -> RC_AddressMode;
			rgCP2_RC_InterruptMask	= reg_config -> RC_InterruptMask;
		break;
		case 3: 
			rgCP3_TR_MainCounter	= reg_config -> TR_MainCounter;
			rgCP3_TR_Address	= (u32)reg_config -> TR_Address;
			rgCP3_TR_Bias	= reg_config -> TR_Bias;
			rgCP3_TR_RowCounter	= reg_config -> TR_RowCounter;
			rgCP3_TR_AddressMode	= reg_config -> TR_AddressMode;
			rgCP3_TR_InterruptMask	= reg_config -> TR_InterruptMask;
 
			rgCP3_RC_MainCounter	= reg_config -> RC_MainCounter;
			rgCP3_RC_Address	=(u32) reg_config -> RC_Address;
			rgCP3_RC_Bias	= reg_config -> RC_Bias;
			rgCP3_RC_RowCounter	= reg_config -> RC_RowCounter;
			rgCP3_RC_AddressMode	= reg_config -> RC_AddressMode;
			rgCP3_RC_InterruptMask	= reg_config -> RC_InterruptMask;
		break;

		default: 
			rgCP0_TR_MainCounter	= reg_config -> TR_MainCounter;
			rgCP0_TR_Address	= (u32)reg_config -> TR_Address;
			rgCP0_TR_Bias	= reg_config -> TR_Bias;
			rgCP0_TR_RowCounter	= reg_config -> TR_RowCounter;
			rgCP0_TR_AddressMode	= reg_config -> TR_AddressMode;
			rgCP0_TR_InterruptMask	= reg_config -> TR_InterruptMask;
 
			rgCP0_RC_MainCounter	= reg_config -> RC_MainCounter;
			rgCP0_RC_Address	= (u32)reg_config -> RC_Address;
			rgCP0_RC_Bias	= reg_config -> RC_Bias;
			rgCP0_RC_RowCounter	= reg_config -> RC_RowCounter;
			rgCP0_RC_AddressMode	= reg_config -> RC_AddressMode;
			rgCP0_RC_InterruptMask	= reg_config -> RC_InterruptMask;
		break;
	}
}

void write_start_CP(CP_reg_config *reg_config) // This function starts the receive channel of CP, CP is specified as in config_CP 
{
	switch (reg_config ->numb) {
		case 0: 
			rgCP0_RC_Control	= reg_config ->RC_Control;
		break;
		case 1: 
			rgCP1_RC_Control	= reg_config ->RC_Control;
		break;
		case 2: 
			rgCP2_RC_Control	= reg_config ->RC_Control;
		break;
		case 3: 
			rgCP3_RC_Control	= reg_config ->RC_Control;
		break;
		default: 
			rgCP0_RC_Control	= reg_config ->TR_Control;
		break;
	}	
}

void read_start_CP(CP_reg_config *reg_config)  // This function starts the transmit channel of CP, CP is specified as in config_CP 
{
	switch (reg_config ->numb) {
		case 0: 
			rgCP0_TR_Control	= reg_config ->TR_Control;
		break;
		case 1: 
			rgCP1_TR_Control	= reg_config ->TR_Control;
		break;
		case 2: 
			rgCP2_TR_Control	= reg_config ->TR_Control;
		break;
		case 3: 
			rgCP3_TR_Control	= reg_config ->TR_Control;
		break;
		default: 
			rgCP0_TR_Control	= reg_config ->TR_Control;
		break;
	}	
}

void read_status_CP(CP_reg_config *reg_config) // Read both status registers from CP
{
	switch (reg_config ->numb) {
		case 0: 
			reg_config ->TR_State = rgCP0_TR_State;
			reg_config ->RC_State = rgCP0_RC_State;
		break;
		case 1: 
			reg_config ->TR_State = rgCP1_TR_State;
			reg_config ->RC_State = rgCP1_RC_State;
		break;
		case 2: 
			reg_config ->TR_State = rgCP2_TR_State;
			reg_config ->RC_State = rgCP2_RC_State;
		break;
		case 3: 
			reg_config ->TR_State = rgCP3_TR_State;
			reg_config ->RC_State = rgCP3_RC_State;
		break;
		default: 
			reg_config ->TR_State = rgCP0_TR_State;
			reg_config ->RC_State = rgCP0_RC_State;
		break;
	}		
}

int read_TR_ctrl_CP(int numb) // Read  TR channel control register 
{
	switch (numb) {
		case 0: 
			return rgCP0_TR_Control;
		break;
		case 1: 
			return rgCP1_TR_Control;
		break;
		case 2: 
			return rgCP2_TR_Control;
		break;
		case 3: 
			return rgCP3_TR_Control;
		break;
		default: 
			return rgCP0_TR_Control;
		break;
	}		
}

int read_RC_ctrl_CP(int numb) // Read  RC channel control register 
{
	switch (numb) {
		case 0: 
			return rgCP0_RC_Control;
		break;
		case 1: 
			return rgCP1_RC_Control;
		break;
		case 2: 
			return rgCP2_RC_Control;
		break;
		case 3: 
			return rgCP3_RC_Control;
		break;
		default: 
			return rgCP0_RC_Control;
		break;
	}		
}







