
//-----------------------------------------------------------------------------
//  This program is for ELC.MAC initialisation from cluster ARM
//    Here used ELC.MAC default settings
//    ELC.Phy initialisation TODO (probably not needed)
//-----------------------------------------------------------------------------

#include "tube_print.h"
#include "defs.h"

void ELC_Phy_Netlist_Sim_SpeedUp ()
{
    //-----------------------------------------------------------------------------
    //  Netlist simulation speedup settings for PHY
    //    Must be removed for RTL simulation or real programm
    //-----------------------------------------------------------------------------
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_TX_RCVDET_CTRL                )) = 0b0000000011111010 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_BANDGAP_TMR                  )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_BIAS_TMR                     )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_PLLEN_TMR                    )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_PLLPRE_TMR                   )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_PLLVREF_TMR                  )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_PLLLOCK_TMR                  )) = 0b0000000000000010 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_PLLCLKDIS_TMR                )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_LANECAL_TMR                  )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_A0IN_TMR                     )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_A1IN_TMR                     )) = 0b0000000000000100 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_A2IN_TMR                     )) = 0b0000000000000100 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_SSM_A3IN_TMR                     )) = 0b0000000000000100 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_BGCAL_OVRD                       )) = 0b1000000000000000 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_PLL_CPI_OVRD                     )) = 0b1000000000000000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_CMN_SDCAL0_OVRD               )) = 0b1000000000000000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_CMN_SDCAL1_OVRD               )) = 0b1000000000000000 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_PLL_VCOCAL_OVRD                  )) = 0b1000000000010010 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_PLL_VCOCAL_CNT_START             )) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_PLL_LOCK_CNT_START               )) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_IQPI_ILL_CAL_OVRD          )) = 0b1000000000000010 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_IQPI_ILL_LOCK_REFCNT_START )) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_IQPI_ILL_LOCK_CALCNT_START0)) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_IQPI_ILL_LOCK_CALCNT_START1)) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_EPI_ILL_CAL_OVRD           )) = 0b1000000000000010 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_EPI_ILL_LOCK_REFCNT_START  )) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_EPI_ILL_LOCK_CALCNT_START0 )) = 0b0000000000010000 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_EPI_ILL_LOCK_CALCNT_START1 )) = 0b0000000000010000 ;
    // *((u32*)(ELPHY_Base + ELPHY_LANE_CAL_RESET_TIME_VALUE         )) = 0b00_0000_1000     ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_TXPUCAL_OVRD                     )) = 0b1000000000100010 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_TXPDCAL_OVRD                     )) = 0b1000000000100010 ;
    *((u32*)(ELPHY_Base + ELPHY_CMN_RXCAL_OVRD                       )) = 0b1000000000000011 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_SLC_INIT_TMR               )) = 0b0000000000000001 ;
    *((u32*)(ELPHY_Base + ELPHY_MASSWR_RX_SLC_RUN_TMR                )) = 0b0000000000000001 ;
    // *((u32*)(ELPHY_Base + ELPHY_CMN_PRPLL_LOCK_CNT_START          )) = 0b0000000000010000 ;
    //-----------------------------------------------------------------------------
}

void ELC_init ()
{
    tubef_str ("ELC initialisation 2.5 Gbs started");
    
    //ELC_Phy_Netlist_Sim_SpeedUp ();
    
    //----------------------- remove Phy reset-----------------------
    rgELC_CTRL_0 = 0x00000004;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;
    //----------------------- power mode P1 -> P0--------------------
    rgELC_CTRL_0 = 0x00000000;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;
    //----------------------- wait link ready------------------------
    while ((rgELC_STATE_0 & 0x2) == 0)
    {
        // TODO emergency exit by counter
    }
    tubef_str ("ELC initialisation 2.5 Gbs passed");
}

void ELC_init_5Gbs ()
{
    tubef_str ("ELC initialisation 5.0 Gbs started");
    
    //ELC_Phy_Netlist_Sim_SpeedUp ();

    *((volatile unsigned int *)0xE0790) |= (1 << 6);
    
    //----------------------- remove Phy reset-----------------------
    rgELC_CTRL_0 = 0x0000000C;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;

    //----------------------- power mode P1 -> P0--------------------
    rgELC_CTRL_0 = 0x00000008;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;

    //----------------------- wait link ready------------------------
    while ((rgELC_STATE_0 & 0x2) == 0)
    {
        // TODO emergency exit by counter
    }
    tubef_str ("ELC initialisation 5.0 Gbs passed");
}

void ELC_power_off ()
{
    //----------------------- power mode P0 -> P1--------------------
    rgELC_CTRL_0 = rgELC_CTRL_0 | 0x00000004;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;
    tubef_str ("ELC power off");
}

void ELC_power_on ()
{
    //----------------------- power mode P0 -> P1--------------------
    rgELC_CTRL_0 = rgELC_CTRL_0 & 0xFFFFFFF9;
    while ((rgELC_CTRL_0 & 0x20) == 0)
    {
        // TODO emergency exit by counter
    }
    rgELC_STATE_0 = 0x00000001;
    //----------------------- wait link ready------------------------
    while ((rgELC_STATE_0 & 0x2) == 0)
    {
        // TODO emergency exit by counter
    }
    tubef_str ("ELC power on");
}

