#include "GERA.h"
#include "defs.h"

// This section contains a low level of abstraction functions that allow you to read and write each register of the GERA block

void write_PDR0(int a )
{
	rgGPIO_PDR0 = a;
}

int read_PDR0()
{
	return rgGPIO_PDR0;
}

void write_DDR0(int a )
{
	rgGPIO_DDR0 = a;
}

int read_DDR0()
{
	return rgGPIO_DDR0;
}




void write_EXTIRC_EIENB(int a )
{
	rgEXTIRC_EIENB = a;
}

int read_EXTIRC_EIENB()
{
	return rgEXTIRC_EIENB;
}

void write_EXTIRC_EIREQ(int a )
{
	rgEXTIRC_EIREQ = a;
}

int read_EXTIRC_EIREQ()
{
	return rgEXTIRC_EIREQ;
}

void write_EXTIRC_EILVL(int a )
{
	rgEXTIRC_EILVL = a;
}

int read_EXTIRC_EILVL()
{
	return rgEXTIRC_EILVL;
}



void write_RA_CONTR(int a)
{
	rgRA_CONTR = a;
}

int read_RA_CONTR()
{
	return rgRA_CONTR;
}

void write_RA_VAL(int a)
{
	rgRA_VAL = a;
}

int read_RA_VAL()
{
	return rgRA_VAL;
}

void write_REGIME(int a)
{
	rgREGIME = a;
}

int read_REGIME()
{
	return rgREGIME;
}



// This section contains a



void GPIO0_1_config(int c, Ports GPIO ) // Output/Input GPIO Port configuration c = 2'b00 : Input,Input  2'b01 : Input,Output         2'b10 : Output,Input  2'b11 : Output,Output
{
	int a = 0;
	a = GPIO.Port0;
	a = a&3;
	int b = 0;
	b = read_DDR0();
	
	b  = b &(!(3<<(a<<1)));
	c = c <<(a<<1)  ;
	b = b | c;	 	
	write_DDR0(b);
}

void GPIO2_3_config(int c, Ports GPIO ) //////////////////////
{
	int a = 0;
	a = GPIO.Port1;
	a = a&3;
	int b = 0;
	b = read_DDR0();
	switch(a){
		case 1 :
			b = b&0xF3;
		break;
		case 2 :
			b = b&0xCF;
		break;
		case 3 :
			b = b&0x3F;
		break;
		default:
			b = b&0xFC;
	}
	b = b | c;	 	
	write_DDR0(b);
}

void GPIO4_5_config(int c, Ports GPIO )
{
	int a = 0;
	a = GPIO.Port2;
	a = a&3;
	int b = 0;
	b = read_DDR0();
	switch(a){
		case 2 :
			b = b&0xCF;
		break;
		case 3 :
			b = b&0x3F;
		break;
		default:
			b = b&0xFC;
	}
	b = b | c;	 	
	write_DDR0(b);
}

void GPIO6_7_config(int c, Ports GPIO )
{
	int a = 0;
	a = GPIO.Port3;
	a = a&3;
	int b = 0;
	b = read_DDR0();
	switch(a){
		case 3 :
			b = b&0x3F;
		break;
		default:
			b = b&0xFC;
	}
	b = b | c;	 	
	write_DDR0(b);
}




void GPIO0_send(int c , Ports GPIO)   //  C - input data to be sent through GPIOx Port
{
	int a = 0;
	a = GPIO.Port0;
	a = a&1;
	int b = 0;
	b = read_PDR0();	

	b  = b &(!(5<<(a<<1)));
	c = c <<(a<<1)  ;

	b = b | c;	 	
	write_PDR0(b);	
	
}

void GPIO1_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port0;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 0 :
			b = b&0xFD;
			c = c <<1;
		break;
		case 1 :
			b = b&0xF7;
			c = c <<3;
		break;
		case 2 :
			b = b&0xDF;
			c = c <<5;
		break;
		case 3 :
			b = b&0x7F;
			c = c <<7;
		break;
		default:
			b = b&0xFD;	
			c = c <<1;
	}
	b = b | c;	 	
	write_PDR0(b);	
	
}

void GPIO2_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port1;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 1 :
			b = b&0xFB;
			c = c <<2;
		break;
		case 2 :
			b = b&0xEF;
			c = c <<4;
		break;
		case 3 :
			b = b&0xBF;
			c = c <<6;
		break;
		default:
			b = b&0xFB;
			c = c <<2;
	}
	b = b | c;	 	
	write_PDR0(b);	
	
}

void GPIO3_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port1;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 1 :
			b = b&0xF8;
			c = c <<3;
		break;
		case 2 :
			b = b&0xDF;
			c = c <<5;
		break;
		case 3 :
			b = b&0x8F;
			c = c <<7;
		break;
		default:
			b = b&0xF8;
			c = c <<3;
	}
	b = b | c;	 	
	write_PDR0(b);	
	
}

void GPIO4_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port2;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 2 :
			b = b&0xEF;
			c = c <<4;
		break;
		case 3 :
			b = b&0xBF;
			c = c <<6;
		break;
		default:
			b = b&0xEF;
			c = c <<4;
	}
	b = b | c;	 	
	write_PDR0(b);	
}	

void GPIO5_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port2;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 2 :
			b = b&0xDF;
			c = c <<5;
		break;
		case 3 :
			b = b&0x8F;
			c = c <<7;
		break;
		default:
			b = b&0xDF;
			c = c <<5;
	}
	b = b | c;	 	
	write_PDR0(b);	
	
}

void GPIO6_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port3;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	// switch(a){
		// case 3 :
			b = b&0xBF;
			c = c <<6;
		// break;
		// default:
			// b = b&0xBF;
			// c = c <<6;
	// }
	b = b | c;	 	
	write_PDR0(b);	
}	

void GPIO7_send(int c , Ports GPIO)
{
	int a = 0;
	a = GPIO.Port3;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	// switch(a){

		// case 3 :
			b = b&0x8F;
			c = c <<7;
		// break;

	// }
	b = b | c;	 	
	write_PDR0(b);	
	
}




int GPIO0_receive(Ports GPIO)  // Receive data from GPIO Port 
{
	int a = 0;
	a = GPIO.Port0;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 0 :
			b = b&1;
		break;
		case 1 :
			b = b&4;
			b = b >>2;
		break;
		case 2 :
			b = b&16;
			b = b >>4;
		break;
		case 3 :
			b = b&64;
			b = b >>6;
		break;
		default:
			b = b&1;	
	}	
	return b;
}

int GPIO1_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port0;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 0 :
			b = b&2;
			b = b >>1;
		break;
		case 1 :
			b = b&8;
			b = b >>3;
		break;
		case 2 :
			b = b&32;
			b = b >>5;
		break;
		case 3 :
			b = b&128;
			b = b >>7;
		break;
		default:
			b = b&2;
			b = b >>1;	
	}	
	return b;
}

int GPIO2_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port1;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 1 :
			b = b&4;
			b = b >>2;
		break;
		case 2 :
			b = b&16;
			b = b >>4;
		break;
		case 3 :
			b = b&64;
			b = b >>6;
		break;
		default:
			b = b&4;	
			b = b >>2;
	}	
	return b;
}

int GPIO3_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port1;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 1 :
			b = b&8;
			b = b >>3;
		break;
		case 2 :
			b = b&32;
			b = b >>5;
		break;
		case 3 :
			b = b&128;
			b = b >>7;
		break;
		default:
			b = b&8;
			b = b >>3;
	}	
	return b;
}

int GPIO4_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port2;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 2 :
			b = b&16;
			b = b >>4;
		break;
		case 3 :
			b = b&64;
			b = b >>6;
		break;
		default:
			b = b&16;
			b = b >>4;
	}	
	return b;
}

int GPIO5_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port2;
	a = a&1;
	int b = 0;
	b = read_PDR0();	
	switch(a){
		case 2 :
			b = b&32;
			b = b >>5;
		break;
		case 3 :
			b = b&128;
			b = b >>7;
		break;
		default:
			b = b&32;
			b = b >>5;
	}	
	return b;
}

int GPIO6_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port3;
	a = a&1;
	int b = 0;
	b = read_PDR0();	

	b = b&64;
	b = b >>6;

	return b;
}

int GPIO7_receive(Ports GPIO)
{
	int a = 0;
	a = GPIO.Port3;
	a = a&1;
	int b = 0;
	b = read_PDR0();	

	b = b&128;
	b = b >>7;
	
	return b;
}



void RA0_config(int c, Ports RA )  // Slave/Driver R/A configuration c = 2'b00 : SA,SR  2'b01 : SR,SA         2'b10 : DA,DR  2'b11 : DR,DA
{
	int a = 0;
	a = RA.Port0;
	a = a&3;
	int b = 0;
	b = read_RA_CONTR();
	switch(a){
		case 0 :
			b = b&0xFC;
		break;
		case 1 :
			b = b&0xF3;
			c = c <<2;
		break;
		case 2 :
			b = b&0xCF;
			c = c <<4;
		break;
		case 3 :
			b = b&0x3F;
			c = c <<6;
		break;
		default:
			b = b&0xFC;
	}
	b = b | c;	 	
	write_RA_CONTR(b);
}

void RA1_config(int c, Ports RA )
{
	int a = 0;
	a = RA.Port1;
	a = a&3;
	int b = 0;
	b = read_RA_CONTR();
	switch(a){
		case 1 :
			b = b&0xF3;
			c = c <<2;
		break;
		case 2 :
			b = b&0xCF;
			c = c <<4;
		break;
		case 3 :
			b = b&0x3F;
			c = c <<6;
		break;
		default:
			b = b&0xF3;
			c = c <<2;
	}
	b = b | c;	 	
	write_RA_CONTR(b);
}

void RA2_config(int c, Ports RA )
{
	int a = 0;
	a = RA.Port2;
	a = a&3;
	int b = 0;
	b = read_RA_CONTR();
	switch(a){
		case 2 :
			b = b&0xCF;
			c = c <<4;
		break;
		case 3 :
			b = b&0x3F;
			c = c <<6;
		break;
		default:
			b = b&0xCF;
			c = c <<4;
	}
	b = b | c;	 	
	write_RA_CONTR(b);
}

void RA3_config(int c, Ports RA )
{
	int a = 0;
	a = RA.Port3;
	a = a&3;
	int b = 0;
	b = read_RA_CONTR();
		b = b&0x3F;
		c = c <<6;
	b = b | c;	 	
	write_RA_CONTR(b);
}


void RA0_send(Ports RA)  // Send request via R port 
{
	int a = 0;
	a = RA.Port0;
	a = a&3;	
	int b = 0;
	b = read_RA_VAL();					//
	switch(a){
		case 0 :	
			b = b | 0x10000;	
		break;
		case 1 :	
			b = b | 0x20000;	
		break;	
		case 2 :	
			b = b | 0x40000;	
		break;
		case 3 :	
			b = b | 0x80000;	
		break;		
		default:
			b = b | 0x10000;			
	}
	write_RA_VAL( b);						// Writing 1 to the Driver Request bit - start of RA process
	
}

void RA1_send(Ports RA)
{
	int a = 0;
	a = RA.Port1;
	a = a&3;	
	int b = 0;
	b = read_RA_VAL();					//
	switch(a){
		case 1 :	
			b = b | 0x20000;	
		break;	
		case 2 :	
			b = b | 0x40000;	
		break;
		case 3 :	
			b = b | 0x80000;	
		break;		
		default:
			b = b | 0x20000;			
	}
	write_RA_VAL( b);						// Writing 1 to the Driver Request bit - start of RA process
	
}

void RA2_send(Ports RA)
{
	int a = 0;
	a = RA.Port2;
	a = a&3;	
	int b = 0;
	b = read_RA_VAL();					//
	switch(a){
		case 2 :	
			b = b | 0x40000;	
		break;
		case 3 :	
			b = b | 0x80000;	
		break;		
		default:
			b = b | 0x40000;			
	}
	write_RA_VAL( b);						// Writing 1 to the Driver Request bit - start of RA process
	
}

void RA3_send(Ports RA)
{
	int a = 0;
	a = RA.Port3;
	a = a&3;	
	int b = 0;
	b = read_RA_VAL();					//
	b = b | 0x80000;	

	write_RA_VAL( b);						// Writing 1 to the Driver Request bit - start of RA process
	
}



void EXTIRC0_config(int c ,int f, Ports EXTIRC)   //// Enable, interrupt triggering lvl
{
	int a = 0;
	a = EXTIRC.Port0;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 0 :
			b = b&0xFE;
			d = d&0xFFFC;
		break;
		case 1 :
			b = b&0xFB;
			d = d&0xFFCF;
			c = c <<2;
			f = f <<4;
		break;
		case 2 :
			b = b&0xEF;
			d = d&0xFCFF;
			c = c <<4;
			f = f <<8;
		break;
		case 3 :
			b = b&0xBF;
			d = d&0xCFFF;
			c = c <<6;
			f = f <<12;
		break;
		default:
			b = b&0xFE;
			d = d&0xFFFC;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}

void EXTIRC1_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port0;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 0 :
			b = b&0xFD;
			d = d&0xFFF3;
			c = c <<1;
			f = f <<2;
		break;
		case 1 :
			b = b&0xF7;
			d = d&0xFF3F;
			c = c <<3;
			f = f <<6;
		break;
		case 2 :
			b = b&0xDF;
			d = d&0xF3FF;
			c = c <<5;
			f = f <<10;
		break;
		case 3 :
			b = b&0x7F;
			d = d&0x3FFF;
			c = c <<7;
			f = f <<14;
		break;
		default:
			b = b&0xFD;
			d = d&0xFFF3;
			c = c <<1;
			f = f <<2;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}

void EXTIRC2_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port1;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 1 :
			b = b&0xFB;
			d = d&0xFFCF;
			c = c <<2;
			f = f <<4;
		break;
		case 2 :
			b = b&0xEF;
			d = d&0xFCFF;
			c = c <<4;
			f = f <<8;
		break;
		case 3 :
			b = b&0xBF;
			d = d&0xCFFF;
			c = c <<6;
			f = f <<12;
		break;
		default:
			b = b&0xFB;
			d = d&0xFFCF;
			c = c <<2;
			f = f <<4;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}

void EXTIRC3_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port1;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 1 :
			b = b&0xF7;
			d = d&0xFF3F;
			c = c <<3;
			f = f <<6;
		break;
		case 2 :
			b = b&0xDF;
			d = d&0xF3FF;
			c = c <<5;
			f = f <<10;
		break;
		case 3 :
			b = b&0x7F;
			d = d&0x3FFF;
			c = c <<7;
			f = f <<14;
		break;
		default:
			b = b&0xF7;
			d = d&0xFF3F;
			c = c <<3;
			f = f <<6;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);		

}

void EXTIRC4_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port2;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 2 :
			b = b&0xEF;
			d = d&0xFCFF;
			c = c <<4;
			f = f <<8;
		break;
		case 3 :
			b = b&0xBF;
			d = d&0xCFFF;
			c = c <<6;
			f = f <<12;
		break;
		default:
			b = b&0xEF;
			d = d&0xFCFF;
			c = c <<4;
			f = f <<8;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);			

}

void EXTIRC5_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port2;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	switch(a){
		case 2 :
			b = b&0xDF;
			d = d&0xF3FF;
			c = c <<5;
			f = f <<10;
		break;
		case 3 :
			b = b&0x7F;
			d = d&0x3FFF;
			c = c <<7;
			f = f <<14;
		break;
		default:
			b = b&0xDF;
			d = d&0xF3FF;
			c = c <<5;
			f = f <<10;
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}

void EXTIRC6_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port3;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
		b = b&0xBF;
		d = d&0xCFFF;
		c = c <<6;
		f = f <<12;
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}

void EXTIRC7_config(int c ,int f, Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port3;
	a = a&3;
	int b = 0;
	int d = 0;
	int l = 0;
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
		b = b&0x7F;
		d = d&0x3FFF;
		c = c <<7;
		f = f <<14;
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	

}



void EXTIRC0_clear( Ports EXTIRC)   ////  Clear interrupt corresponding to EXTIRC Port
{
	int a = 0;
	a = EXTIRC.Port0;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 0 :
			b = b&0xFE;
		break;
		case 1 :
			b = b&0xFB;
		break;
		case 2 :
			b = b&0xEF;
		break;
		case 3 :
			b = b&0xBF;
		break;
		default:
			b = b&0xFE;

	}
	write_EXTIRC_EIREQ(b);
}

void EXTIRC1_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port0;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 0 :
			b = b&0xFD;
		break;
		case 1 :
			b = b&0xF7;
		break;
		case 2 :
			b = b&0xDF;
		break;
		case 3 :
			b = b&0x7F;
		break;
		default:
			b = b&0xFD;
	}
	write_EXTIRC_EIREQ(b);	

}

void EXTIRC2_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port1;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 1 :
			b = b&0xFB;
		break;
		case 2 :
			b = b&0xEF;
		break;
		case 3 :
			b = b&0xBF;
		break;
		default:
			b = b&0xFB;
	}
	write_EXTIRC_EIREQ(b);

}

void EXTIRC3_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port1;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 1 :
			b = b&0xF7;
		break;
		case 2 :
			b = b&0xDF;
		break;
		case 3 :
			b = b&0x7F;
		break;
		default:
			b = b&0xF7;
	}
	write_EXTIRC_EIREQ(b);

}

void EXTIRC4_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port2;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 2 :
			b = b&0xEF;
		break;
		case 3 :
			b = b&0xBF;
		break;
		default:
			b = b&0xEF;
	}
	write_EXTIRC_EIREQ(b);		
}

void EXTIRC5_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port2;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	switch(a){
		case 2 :
			b = b&0xDF;
		break;
		case 3 :
			b = b&0x7F;
		break;
		default:
			b = b&0xDF;
	}
	write_EXTIRC_EIREQ(b);

}

void EXTIRC6_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port3;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
	b = b&0xBF;
	write_EXTIRC_EIREQ(b);

}

void EXTIRC7_clear(  Ports EXTIRC)
{
	int a = 0;
	a = EXTIRC.Port3;
	a = a&3;
	int b = 0;
	b = read_EXTIRC_EIENB();
		b = b&0x7F;
	write_EXTIRC_EIREQ(b);

}


// void GPIO0_int_config(int c ,int f, Ports GPIO)   //// Enable, interrupt triggering lvl
// {
	// int a = 0;
	// a = GPIO.Port0;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 0 :
			// b = b&0xFE;
			// d = d&0xFFFC;
		// break;
		// case 1 :
			// b = b&0xFB;
			// d = d&0xFFCF;
			// c = c <<2;
			// f = f <<4;
		// break;
		// case 2 :
			// b = b&0xEF;
			// d = d&0xFCFF;
			// c = c <<4;
			// f = f <<8;
		// break;
		// case 3 :
			// b = b&0xBF;
			// d = d&0xCFFF;
			// c = c <<6;
			// f = f <<12;
		// break;
		// default:
			// b = b&0xFE;
			// d = d&0xFFFC;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void GPIO1_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port0;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 0 :
			// b = b&0xFD;
			// d = d&0xFFF3;
			// c = c <<1;
			// f = f <<2;
		// break;
		// case 1 :
			// b = b&0xF7;
			// d = d&0xFF3F;
			// c = c <<3;
			// f = f <<6;
		// break;
		// case 2 :
			// b = b&0xDF;
			// d = d&0xF3FF;
			// c = c <<5;
			// f = f <<10;
		// break;
		// case 3 :
			// b = b&0x7F;
			// d = d&0x3FFF;
			// c = c <<7;
			// f = f <<14;
		// break;
		// default:
			// b = b&0xFD;
			// d = d&0xFFF3;
			// c = c <<1;
			// f = f <<2;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	

// }

// void GPIO2_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port1;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 1 :
			// b = b&0xFB;
			// d = d&0xFFCF;
			// c = c <<2;
			// f = f <<4;
		// break;
		// case 2 :
			// b = b&0xEF;
			// d = d&0xFCFF;
			// c = c <<4;
			// f = f <<8;
		// break;
		// case 3 :
			// b = b&0xBF;
			// d = d&0xCFFF;
			// c = c <<6;
			// f = f <<12;
		// break;
		// default:
			// b = b&0xFB;
			// d = d&0xFFCF;
			// c = c <<2;
			// f = f <<4;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void GPIO3_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port1;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 1 :
			// b = b&0xF7;
			// d = d&0xFF3F;
			// c = c <<3;
			// f = f <<6;
		// break;
		// case 2 :
			// b = b&0xDF;
			// d = d&0xF3FF;
			// c = c <<5;
			// f = f <<10;
		// break;
		// case 3 :
			// b = b&0x7F;
			// d = d&0x3FFF;
			// c = c <<7;
			// f = f <<14;
		// break;
		// default:
			// b = b&0xF7;
			// d = d&0xFF3F;
			// c = c <<3;
			// f = f <<6;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void GPIO4_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port2;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 2 :
			// b = b&0xEF;
			// d = d&0xFCFF;
			// c = c <<4;
			// f = f <<8;
		// break;
		// case 3 :
			// b = b&0xBF;
			// d = d&0xCFFF;
			// c = c <<6;
			// f = f <<12;
		// break;
		// default:
			// b = b&0xEF;
			// d = d&0xFCFF;
			// c = c <<4;
			// f = f <<8;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);		

// }

// void GPIO5_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port2;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// switch(a){
		// case 2 :
			// b = b&0xDF;
			// d = d&0xF3FF;
			// c = c <<5;
			// f = f <<10;
		// break;
		// case 3 :
			// b = b&0x7F;
			// d = d&0x3FFF;
			// c = c <<7;
			// f = f <<14;
		// break;
		// default:
			// b = b&0xDF;
			// d = d&0xF3FF;
			// c = c <<5;
			// f = f <<10;
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	

// }

// void GPIO6_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port3;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
		// b = b&0xBF;
		// d = d&0xCFFF;
		// c = c <<6;
		// f = f <<12;
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	

// }

// void GPIO7_int_config(int c ,int f, Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port3;
	// a = a&3;
	// int b = 0;
	// int d = 0;
	// int l = 0;
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
		// b = b&0x7F;
		// d = d&0x3FFF;
		// c = c <<7;
		// f = f <<14;
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	

// }




// void R0_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port0;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();

	// switch(a){
		// case 0 :
			// z = z&1;
			// if(!z)
				// {
					// b = b&0xFE;
					// d = d&0xFFFC;
		
				// }
			// else
				// {
					// b = b&0xFD;
					// d = d&0xFFF3;
					// f = f <<2;
					// c = c <<1;
				// }
		// break;
		// case 1 :
			// z = z&4;
			// z = z>>2;
			// if(!z)
				// {
					// b = b&0xFB;
					// d = d&0xFFCF;
					// c = c <<2;
					// f = f <<4;		
				// }
			// else
				// {
					// b = b&0xF7;
					// d = d&0xFF3F;
					// c = c <<3;
					// f = f <<6;
				// }
		// break;
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
		// break;
		// default:
			// z = z&1;
			// if(!z)
				// {
					// b = b&0xFE;
					// d = d&0xFFFC;
				// }
			// else
				// {
					// b = b&0xFD;
					// d = d&0xFFF3;
					// f = f <<2;
					// c = c <<1;
				// }
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

void R1_int_config(int c,int f, Ports RA )
{
	int a = 0;
	a = RA.Port1;
	a = a&3; 										// Pair #
	int b = 0; 										// ENABLE
	int d = 0; 										// LVL
	int l = 0; 										// ENABLE 2 ZERO
	int z = 0; 										// CONTROL
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	z = read_RA_CONTR();

	switch(a){
		case 1 :
			z = z&4;
			z = z>>2;
			if(!z)
				{
					b = b&0xFB;
					d = d&0xFFCF;
					c = c <<2;
					f = f <<4;		
				}
			else
				{
					b = b&0xF7;
					d = d&0xFF3F;
					c = c <<3;
					f = f <<6;
				}
		break;
		case 2 :
			z = z&16;
			z = z>>4;
			if(!z)
				{
					b = b&0xEF;
					d = d&0xFCFF;
					c = c <<4;
					f = f <<8;
				}
			else
				{
					b = b&0xDF;
					d = d&0xF3FF;
					c = c <<5;
					f = f <<10;
				}
		break;
		case 3 :
			z = z&64;
			z = z>>6;		
			if(!z)
				{
					b = b&0xBF;
					d = d&0xCFFF;
					c = c <<6;
					f = f <<12;		
				}
			else
				{
					b = b&0x7F;
					d = d&0x3FFF;
					c = c <<7;
					f = f <<14;
				}		
		break;
		default:
			z = z&4;
			z = z>>2;
			if(!z)
				{
					b = b&0xFB;
					d = d&0xFFCF;
					c = c <<2;
					f = f <<4;		
				}
			else
				{
					b = b&0xF7;
					d = d&0xFF3F;
					c = c <<3;
					f = f <<6;
				}
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	
}

// void R2_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port2;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();

	// switch(a){
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
		// break;
		// default:
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void R3_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port3;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }



void A0_int_config(int c,int f, Ports RA )
{
	int a = 0;
	a = RA.Port0;
	a = a&3; 										// Pair #
	int b = 0; 										// ENABLE
	int d = 0; 										// LVL
	int l = 0; 										// ENABLE 2 ZERO
	int z = 0; 										// CONTROL
	b = read_EXTIRC_EIENB();
	d = read_EXTIRC_EILVL();
	z = read_RA_CONTR();

	switch(a){
		case 0 :
			z = z&1;
			if(z)
				{
					b = b&0xFE;
					d = d&0xFFFC;
		
				}
			else
				{
					b = b&0xFD;
					d = d&0xFFF3;
					f = f <<2;
					c = c <<1;
				}
		break;
		case 1 :
			z = z&4;
			z = z>>2;
			if(z)
				{
					b = b&0xFB;
					d = d&0xFFCF;
					c = c <<2;
					f = f <<4;		
				}
			else
				{
					b = b&0xF7;
					d = d&0xFF3F;
					c = c <<3;
					f = f <<6;
				}
		break;
		case 2 :
			z = z&16;
			z = z>>4;
			if(z)
				{
					b = b&0xEF;
					d = d&0xFCFF;
					c = c <<4;
					f = f <<8;
				}
			else
				{
					b = b&0xDF;
					d = d&0xF3FF;
					c = c <<5;
					f = f <<10;
				}
		break;
		case 3 :
			z = z&64;
			z = z>>6;		
			if(z)
				{
					b = b&0xBF;
					d = d&0xCFFF;
					c = c <<6;
					f = f <<12;		
				}
			else
				{
					b = b&0x7F;
					d = d&0x3FFF;
					c = c <<7;
					f = f <<14;
				}		
		break;
		default:
			z = z&1;
			if(z)
				{
					b = b&0xFE;
					d = d&0xFFFC;
				}
			else
				{
					b = b&0xFD;
					d = d&0xFFF3;
					f = f <<2;
					c = c <<1;
				}
	}
	l  = b;
	b = b | c;	 	
	d = d | f;
	write_EXTIRC_EIENB(l);	
	write_EXTIRC_EILVL(d);
	write_EXTIRC_EIREQ(l);
	write_EXTIRC_EIENB(b);	
}

// void A1_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port1;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();

	// switch(a){
		// case 1 :
			// z = z&4;
			// z = z>>2;
			// if(z)
				// {
					// b = b&0xFB;
					// d = d&0xFFCF;
					// c = c <<2;
					// f = f <<4;		
				// }
			// else
				// {
					// b = b&0xF7;
					// d = d&0xFF3F;
					// c = c <<3;
					// f = f <<6;
				// }
		// break;
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
		// break;
		// default:
			// z = z&4;
			// z = z>>2;
			// if(z)
				// {
					// b = b&0xFB;
					// d = d&0xFFCF;
					// c = c <<2;
					// f = f <<4;		
				// }
			// else
				// {
					// b = b&0xF7;
					// d = d&0xFF3F;
					// c = c <<3;
					// f = f <<6;
				// }
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void A2_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port2;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();

	// switch(a){
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
		// break;
		// default:
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
					// d = d&0xFCFF;
					// c = c <<4;
					// f = f <<8;
				// }
			// else
				// {
					// b = b&0xDF;
					// d = d&0xF3FF;
					// c = c <<5;
					// f = f <<10;
				// }
	// }
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }

// void A3_int_config(int c,int f, Ports RA )
// {
	// int a = 0;
	// a = RA.Port3;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int d = 0; 										// LVL
	// int l = 0; 										// ENABLE 2 ZERO
	// int z = 0; 										// CONTROL
	// b = read_EXTIRC_EIENB();
	// d = read_EXTIRC_EILVL();
	// z = read_RA_CONTR();
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
					// d = d&0xCFFF;
					// c = c <<6;
					// f = f <<12;		
				// }
			// else
				// {
					// b = b&0x7F;
					// d = d&0x3FFF;
					// c = c <<7;
					// f = f <<14;
				// }		
	// l  = b;
	// b = b | c;	 	
	// d = d | f;
	// write_EXTIRC_EIENB(l);	
	// write_EXTIRC_EILVL(d);
	// write_EXTIRC_EIREQ(l);
	// write_EXTIRC_EIENB(b);	
// }




// void GPIO0_int_clear( Ports GPIO)   //// 
// {
	// int a = 0;
	// a = GPIO.Port0;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 0 :
			// b = b&0xFE;
		// break;
		// case 1 :
			// b = b&0xFB;
		// break;
		// case 2 :
			// b = b&0xEF;
		// break;
		// case 3 :
			// b = b&0xBF;
		// break;
		// default:
			// b = b&0xFE;
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void GPIO1_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port0;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 0 :
			// b = b&0xFD;
		// break;
		// case 1 :
			// b = b&0xF7;
		// break;
		// case 2 :
			// b = b&0xDF;
		// break;
		// case 3 :
			// b = b&0x7F;
		// break;
		// default:
			// b = b&0xFD;
	// }
	// write_EXTIRC_EIREQ(b);

// }

// void GPIO2_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port1;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 1 :
			// b = b&0xFB;
		// break;
		// case 2 :
			// b = b&0xEF;
		// break;
		// case 3 :
			// b = b&0xBF;
		// break;
		// default:
			// b = b&0xFB;
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void GPIO3_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port1;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 1 :
			// b = b&0xF7;
		// break;
		// case 2 :
			// b = b&0xDF;
		// break;
		// case 3 :
			// b = b&0x7F;
		// break;
		// default:
			// b = b&0xF7;
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void GPIO4_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port2;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 2 :
			// b = b&0xEF;
		// break;
		// case 3 :
			// b = b&0xBF;
		// break;
		// default:
			// b = b&0xEF;
	// }
	// write_EXTIRC_EIREQ(b);

// }

// void GPIO5_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port2;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
	// switch(a){
		// case 2 :
			// b = b&0xDF;
		// break;
		// case 3 :
			// b = b&0x7F;
		// break;
		// default:
			// b = b&0xDF;
	// }
	// write_EXTIRC_EIREQ(b);

// }

// void GPIO6_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port3;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
		// b = b&0xBF;
	// write_EXTIRC_EIREQ(b);

// }

// void GPIO7_int_clear( Ports GPIO)
// {
	// int a = 0;
	// a = GPIO.Port3;
	// a = a&3;
	// int b = 0;
	// b = read_EXTIRC_EIENB();
		// b = b&0x7F;
	// write_EXTIRC_EIREQ(b);

// }





// void R0_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port0;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();

	// switch(a){
		// case 0 :
			// z = z&1;
			// if(!z)
				// {
					// b = b&0xFE;
				// }
			// else
				// {
					// b = b&0xFD;
				// }
		// break;
		// case 1 :
			// z = z&4;
			// z = z>>2;
			// if(!z)
				// {
					// b = b&0xFB;		
				// }
			// else
				// {
					// b = b&0xF7;
				// }
		// break;
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;	
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
		// break;
		// default:
			// z = z&1;
			// if(!z)
				// {
					// b = b&0xFE;
				// }
			// else
				// {
					// b = b&0xFD;
				// }
	// }
	// write_EXTIRC_EIREQ(b);
// }

void R1_int_clear(Ports RA )
{
	int a = 0;
	a = RA.Port1;
	a = a&3; 										// Pair #
	int b = 0; 										// ENABLE
	int z = 0;
	b = read_EXTIRC_EIENB();
	z = read_RA_CONTR();
	switch(a){
		case 1 :
			z = z&4;
			z = z>>2;
			if(!z)
				{
					b = b&0xFB;
				}
			else
				{
					b = b&0xF7;
				}
		break;
		case 2 :
			z = z&16;
			z = z>>4;
			if(!z)
				{
					b = b&0xEF;
				}
			else
				{
					b = b&0xDF;
				}
		break;
		case 3 :
			z = z&64;
			z = z>>6;		
			if(!z)
				{
					b = b&0xBF;	
				}
			else
				{
					b = b&0x7F;
				}		
		break;
		default:
			z = z&4;
			z = z>>2;
			if(!z)
				{
					b = b&0xFB;	
				}
			else
				{
					b = b&0xF7;
				}
	}
	write_EXTIRC_EIREQ(b);
}

// void R2_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port2;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();

	// switch(a){
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
		// break;
		// default:
			// z = z&16;
			// z = z>>4;
			// if(!z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void R3_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port3;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();
			// z = z&64;
			// z = z>>6;		
			// if(!z)
				// {
					// b = b&0xBF;
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
	// write_EXTIRC_EIREQ(b);
// }



void A0_int_clear(Ports RA )
{
	int a = 0;
	a = RA.Port0;
	a = a&3; 										// Pair #
	int b = 0; 										// ENABLE
	int z = 0;
	b = read_EXTIRC_EIENB();
	// z = read_RA_CONTR();

	switch(a){
		case 0 :
			z = z&1;
			if(z)
				{
					b = b&0xFE;
		
				}
			else
				{
					b = b&0xFD;
				}
		break;
		case 1 :
			z = z&4;
			z = z>>2;
			if(z)
				{
					b = b&0xFB;	
				}
			else
				{
					b = b&0xF7;
				}
		break;
		case 2 :
			z = z&16;
			z = z>>4;
			if(z)
				{
					b = b&0xEF;
				}
			else
				{
					b = b&0xDF;
				}
		break;
		case 3 :
			z = z&64;
			z = z>>6;		
			if(z)
				{
					b = b&0xBF;	
				}
			else
				{
					b = b&0x7F;
				}		
		break;
		default:
			z = z&1;
			if(z)
				{
					b = b&0xFE;
				}
			else
				{
					b = b&0xFD;
				}
	}
	write_EXTIRC_EIREQ(b);
}

// void A1_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port1;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();

	// switch(a){
		// case 1 :
			// z = z&4;
			// z = z>>2;
			// if(z)
				// {
					// b = b&0xFB;
				// }
			// else
				// {
					// b = b&0xF7;
				// }
		// break;
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
		// break;
		// default:
			// z = z&4;
			// z = z>>2;
			// if(z)
				// {
					// b = b&0xFB;
				// }
			// else
				// {
					// b = b&0xF7;
				// }
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void A2_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port2;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();

	// switch(a){
		// case 2 :
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
		// break;
		// case 3 :
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
		// break;
		// default:
			// z = z&16;
			// z = z>>4;
			// if(z)
				// {
					// b = b&0xEF;
				// }
			// else
				// {
					// b = b&0xDF;
				// }
	// }
	// write_EXTIRC_EIREQ(b);
// }

// void A3_int_clear(Ports RA )
// {
	// int a = 0;
	// a = RA.Port3;
	// a = a&3; 										// Pair #
	// int b = 0; 										// ENABLE
	// int z = 0;
	// b = read_EXTIRC_EIENB();
			// z = z&64;
			// z = z>>6;		
			// if(z)
				// {
					// b = b&0xBF;
				// }
			// else
				// {
					// b = b&0x7F;
				// }		
	// write_EXTIRC_EIREQ(b);
// }




























