#include "MPU.h"
#include "defs.h"
#include "tube_print.h"



int protectmem_seg( u32 addr, u8 rw) // rw: 1 - to protect on read, 2 - to protect on write, 3 - to protect both read and write
{
u32 segm = 0x1;
    addr = ((addr&0x1f000000) >> 24);
    if (addr > 0x1F) {tubef_hex(addr);return 0;};
    
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_SET = segm << addr;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_SET = segm << addr;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}

int unprotectmem_seg( u32 addr, u8 rw) // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write
{
u32 segm = 0x1;
    addr = ((addr&0x1f000000) >> 24);
    if (addr > 0x1F) {tubef_hex(addr);return 0;};
    
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_CLEAR = segm << addr;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_CLEAR = segm << addr;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}

int protectmem_all(u8 rw) // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write
{
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_SET = 0xffffffff;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_SET = 0xffffffff;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}


int unprotectmem_all(u8 rw) // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write
{
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_NULL = 0x0;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_NULL = 0x0;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}

int protectmem_ft_seg( u32 addr1, u32 addr2, u8 rw) // rw: 1 - to protect on read, 2 - to protect on write, 3 - to protect both read and write
{
u32 segm = 0xffffffff;
u32 segm1 = 0;
u32 segm2 = 0;
    addr1 = ((addr1&0x1f000000) >> 24);
    addr2 = ((addr2&0x1f000000) >> 24);
    if ((addr1 > 0x1F) || (addr2 > 0x1F)) {tubef_hex(addr1);tubef_hex(addr2);;return 0;};
    if (addr1 > addr2) 
        {segm1 = segm >> (31-addr1);
         segm2 = segm << addr2;}
    else 
        {segm1 = segm >> (31-addr2);
         segm2 = segm << addr1;};
    segm = segm1 & segm2;
    
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_SET = segm;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_SET = segm;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}

int unprotectmem_ft_seg( u32 addr1, u32 addr2, u8 rw) // rw: 1 - to unprotect on read, 2 - to unprotect on write, 3 - to unprotect both read and write
{
u32 segm = 0xffffffff;
u32 segm1 = 0;
u32 segm2 = 0;
    addr1 = ((addr1&0x1f000000) >> 24);
    addr2 = ((addr2&0x1f000000) >> 24);
    if ((addr1 > 0x1F) || (addr2 > 0x1F)) {tubef_hex(addr1);tubef_hex(addr2);return 0;};
    if (addr1 > addr2) 
        {segm1 = segm >> (31-addr1);
         segm2 = segm << addr2;}
    else 
        {segm1 = segm >> (31-addr2);
         segm2 = segm << addr1;};
    segm = segm1 & segm2;
    
    if ((rw & 0x1) != 0) 
        {rgMPU_RD_MASK_CLEAR = segm;};
    if ((rw & 0x2) != 0) 
        {rgMPU_WR_MASK_CLEAR = segm;};
    if (rw > 3)
        {tubef_hex(rw);return 0;};
    return -1;
}