// /********************************************************************
    // This library is for PCIE module in NM6408 project
    // must be run only on TOP ARM CPU
// ********************************************************************/

#include "tube_print.h"
#include "defs.h"

void PCIe_setting_ ()
{
    /***************************************************/
    /*    this PHY settings are only for simulation    */
    /*    and must be removed for real programm        */
    /***************************************************/
    rgELPHY_PCS_COM_LOCK_CFG1        = 0x4010;
    rgELPHY_PCS_COM_LOCK_CFG2        = 0x0810;
    rgELPHY_PCS_GEN3_EIE_LOCK_CFG    = 0x0101;
    rgELPHY_PCS_RCV_DET_INH          = 0x000A;
    /***************************************************/
    
    rgARMSC_PCIE_RST = 0x1;
    while ((rgARMSC_PCIE_RST & 0x1) == 0)
    {
        // TODO emergency exit by counter
    }
    
    /***************************************************************/
    /*     Enable access through controller                        */
    /***************************************************************/
    rgPCIe_EP_i_command_status = 0x07;
    /***************************************************************/
    /*     BAR 1 - what high bits of inbound address to mask       */
    /***************************************************************/
    rgPCIe_EP_i_base_addr_1 = 0x80000000;
    /***************************************************************/
    /* enable BAR 0 and BAR 1 for inbound transactions             */
    /*   - maximum BAR size selected - 2 GB                        */
    /*   - two BARs cover all memory space                         */
    /***************************************************************/
    rgPCIe_LocMgmt_i_pf_0_BAR_config_0_reg = 0x00009898;
    /***************************************************************/
    /*     BAR 1 - what to put instead of masked bits              */
    /***************************************************************/
    rgPCIe_AXI_inregion_ep_bar_1_addr_translation = 0x80000000;
    /***************************************************************/
    /*     AXI outbound addr translation setup                     */
    /*       - pass 32 bits to bridge, zero none bits              */
    /***************************************************************/
    rgPCIe_AXI_outregion_0_addr_translation_0 = 0x0000001F;
    /***************************************************************/
    /*     AXI outbound PCIe header descriptor                     */
    /*       - configure for memory RW                             */
    /***************************************************************/
    rgPCIe_AXI_outregion_0_header_descriptor_0 = 0x00000002;
    /***************************************************************/
    /*     AXI Outbound Region 0 AXI Region Base Address 0         */
    /*       - none of bits choose region                          */
    /***************************************************************/
    rgPCIe_AXI_outregion_0_region_base_addr = 0x0000001F;
        
    while ((rgPCIe_LocMgmt_i_pl_config_0_reg & 0x1) == 0)
    {
        // TODO emergency exit by counter
    }
    
}
