
#include "defs.h"
#include "gic.h"
#include "tube_print.h"

void gic_config(const T_gic_configuration gic_configuration)
{
  rgGICD_CTLR = 0;
  rgGICC_CTLR = 0;
  tubef_hex(rgGICD_TYPER);
  rgGICD_ICFGR2 = rgGICD_ICFGR2 | 0x00008000;  // WKUPINT is Edge-Sensitive
  rgGICD_IGROUPR0  = 0u;  //  ~       (gic_configuration .SGI_Type);   // FIQs Not Implemented
  rgGICD_IGROUPR1  = 0u;  //  ~((u32) (gic_configuration .SPI_Type));
  rgGICD_IGROUPR2  = 0u;  //  ~((u32) (gic_configuration .SPI_Type >> 32));
  rgGICD_ISENABLER1=   (u32) (gic_configuration .SPI_Enable);
  rgGICD_ISENABLER2=   (u32) (gic_configuration .SPI_Enable >> 32);
  rgGICC_PMR = 0xFF;
  rgGICC_CTLR = 1;
  rgGICD_CTLR = 1;
  tubef_str("gic_config end");
  tubef_hex(rgGICC_CTLR);
  tubef_hex(rgGICD_CTLR);
  tubef_hex(rgGICD_IGROUPR0);
}
