/* Copyright 2014
 * RC Module <www.module.ru>
 *  Gennadiy Kurtsman <gkurtsman@module.ru>
 *
 *  functions descriptors definitions and macros
 *
 */

#ifndef __FUNC_DESC_H__
#define __FUNC_DESC_H__

extern void wdog_isr (void);

struct __test_operation {
	char* device_name;
	int (*func_init) (unsigned long parms);
	int (*func_start) (unsigned long parms);
	int interrupts_n;	/* device uses interrupts_n VIC levels */
	char irq [64];
	char* isr_name [64];
	int (*func_finish) (unsigned long parms);
	int op_state;		/* state of last operation accomplishment:
				   0, if it works at the moment,
				   >0, if it is completed successfully,
				   <0, if it failed */
	int cont;		/* sign of at least 1 finishing */
	int i_loop;		/* number of repeat at interrupt routine */
	unsigned long prv;	/* user's private field */
};

#endif /* __FUNC_DESC_H__ */
