
#include "defs_s.h"
#include "macro.incl"

.global IRQ_Handler_Wrapper


.code 32
.section .text

IRQ_Handler_Wrapper:
  PUSH {R0-R3, LR}
  
  LDR R2, =GICC_Base
   /* Read the Interrupt Acknowledge Register - Get The InterruptID */
   /* InterruptID Is Simply IRQ Number Because CPUID Field Tied To 0 */
   /* GIC Changes A Status Of Given Interrupt To Active */
  LDR R0, [R2, #GICC_IAR]
  
  //tube_msg "IRQ. ID:"
  //tube_hex R0
  
    /* Calculate The Address Of ISR: Base = InterruptVector[0], Offset = InterruptID*4 (Each Address Is 32-bit) */
  LDR R1, =InterruptVector
  ADD R1, R1, R0, LSL #2
  
    /* Branch To ISR Which Address Lies In InterruptVector[InterruptID] */
  push {R0,R2}
  LDR R0, [R1]
  BLX R0
  
    /* Finish Routine: Write To End-Of-Interrupt Register Resets An Interrupt Status */
  pop {R0,R2}
  STR R0, [R2, #GICC_EOIR]
  POP {R0-R3, LR}
  

    /* Return From Interrupt, Mode Change Made Automatically */
  SUBS    PC, LR, #4
  NOP
