
/* This File Contain Default Stack Definitions (All Stacks Are Linked!)*/

#define Dummy_Stack_Size 256

#define FIQ_Size              Dummy_Stack_Size*2
#define IRQ_Size              Dummy_Stack_Size*2
#define SVC_Size              Dummy_Stack_Size*2
#define ABT_Size              Dummy_Stack_Size*1
#define UND_Size              Dummy_Stack_Size*1
#define USR_Size              Dummy_Stack_Size*2

/* --- USR and SYS mode stack shared --- */

#define MON_Size              Dummy_Stack_Size*1
#define TotalStack_Size       FIQ_Size + IRQ_Size + SVC_Size + ABT_Size + UND_Size + USR_Size + MON_Size 
#define Heap_Size             0x400 /*  */

.global SVC_Stack
.global FIQ_Stack
.global IRQ_Stack
.global ABT_Stack
.global UND_Stack
.global MON_Stack
.global USR_Stack
.global Heap_Base

.section .stack

/* .comm  Directive Allocates An Uninitialized Variable */
/* ARM stack groes up!!! */

Heap_Base: .zero Heap_Size
SVC_Stack_Base: .zero SVC_Size
SVC_Stack: .zero FIQ_Size
FIQ_Stack: .zero IRQ_Size
IRQ_Stack: .zero ABT_Size
ABT_Stack: .zero UND_Size
UND_Stack: .zero MON_Size
MON_Stack: .zero USR_Size
USR_Stack: .zero 8
