#include <defs.h>
#include "tube_print.h"

// externs
int test_case_first = 0;
int test_case_last = 0;
int is_tnerrupted = 0;
int interrupts_info_index = 0;

//

char * test_name = "NOT SET TEST NAME";
int test_case_count = 0;
int started_case_count = 0;
int error_flag = 0;
int failed_count = 0;



void test_start (char* test_name, int check_nmb) {
}

void test_finish (void) {
}

void test_check_f (char* file, int line, int check_result){
}


void set_test_name (char * name) {

    test_name = name;
}

int test_case_start ( void ) {

    test_case_count ++;
    
    if ((test_case_first > 0) && (test_case_last > 0)) {
        if ((test_case_count < test_case_first) ||
            (test_case_count > test_case_last)) {
             return 0;
        }
    } else if (test_case_first > 0) { 
        if (test_case_count != test_case_first) {
            return 0;
        }
    }
    started_case_count++;
    iprint_dec(test_case_count, 2);
    iprint_str(" --- ");
    iprint_str(test_name);
    iprint_str(" started");
    buf_new();
    
    return 1;
}

void test_case_end ( void ) {

    int print_level_old = print_level;
    
    iprint_dec(test_case_count, 2);
    iprint_str(" --- ");
    iprint_str(test_name);
    if (error_flag) {
        error_flag = 0;
        failed_count++;
        print_level = PRINT_LEVEL_INFO;
        iprint_str(" finished (failed)");
    } else {       
        iprint_str(" finished (passed)");
    }
    buf_new();
    print_level = print_level_old;
}

void print_report ( int finished_nmb ) {
    
    int print_level_old = print_level;
    
    print_level = PRINT_LEVEL_INFO;
    iprint_line();
    iprint_str("ALL - ");
    iprint_dec(test_case_count, 1);
    iprint_str("  STARTED - ");
    iprint_dec(started_case_count, 1);
    iprint_str("  PASSED - ");
    iprint_dec(started_case_count - failed_count, 1);
    iprint_str("  FAILED - ");
    iprint_dec(failed_count, 1);
    buf_new();
    iprint_line();
    iprint_str("    finished_nmb=");
    iprint_dec(finished_nmb, 1);
    buf_new();
    iprint_str(test_name);
    if (failed_count > 0){
        iprint_str(" TEST failed");
	set_error();
    } else {
        iprint_str(" TEST passed");
    }
    buf_new();
    print_level = print_level_old;
}
