@
@ Interrupt Vectors for all tests
@
@    AREA must be in the file which includs this text
    
    .extern  Reset_Handler
    .extern  Undefined_Handler_Wrapper
    .extern  SWI_Handler_Wrapper
    .extern  Prefetch_Handler_Wrapper
    .extern  Abort_Handler_Wrapper
    .extern  IRQ_Handler_Wrapper
    .extern  FIQ_Handler_Wrapper

.code 32
.section .text_vectors
@ Store vectors in special section which is then linked to zero addresses, "x" means executable

.global Reset_Handler
.global _start

@ Note: LDR PC instructions are used here because branch (B)
@ instructions could not simply be copied (the branch offsets
@ would be wrong).  Also, a branch instruction might not reach
@ if the ROM is at an address >32MB).

@ ENTRY
_start:
    LDR  PC, Reset_Addr
    LDR  PC, Undefined_Addr
    LDR  PC, SWI_Addr
    LDR  PC, Prefetch_Addr
    LDR  PC, Abort_Addr
    NOP  @ Reserved vector
    LDR  PC, IRQ_Addr
    LDR  PC, FIQ_Addr
    
m11:  NOP            @ this dead loop always has constant address - 0x00000020 (and 0xc0000020)
    B    m11      @ set breakpoint to this address to break when test is finished
        
Reset_Addr:      .word  Reset_Handler
Undefined_Addr:  .word Undefined_Handler_Wrapper
SWI_Addr:        .word SWI_Handler_Wrapper
Prefetch_Addr:   .word Prefetch_Handler_Wrapper
Abort_Addr:      .word Abort_Handler_Wrapper
                 .word 0  @Reserved vector_Wrapper
IRQ_Addr:        .word IRQ_Handler_Wrapper
FIQ_Addr:        .word FIQ_Handler_Wrapper

.section .text
