#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <limits.h>
#include <unistd.h>
#include <string.h>

int main (int argc, char *argv[])
{
	int		fd, ret;
	unsigned char	flags[4];
	unsigned char	format, endian;
	char		str_name[PATH_MAX];

	if (argc != 2)
		errx(EXIT_FAILURE, "usage: %s file-name", argv[0]);

	sprintf(str_name, "%s", argv[1]);

	if ((fd = open(str_name, O_RDWR, 0)) < 0)
		errx(EXIT_FAILURE, "open \"%s\" failed" , str_name);

	if (lseek(fd, 0x4, SEEK_SET) < 0)
		errx(EXIT_FAILURE, "lseek \"%s\" failed" , str_name);

	if (read(fd, &format, 1) != 1)
		errx(EXIT_FAILURE, "read format \"%s\" failed" , str_name);

	if (read(fd, &endian, 1) != 1)
		errx(EXIT_FAILURE, "read endian \"%s\" failed" , str_name);

	if (format == 1)
		ret = lseek(fd, 0x24, SEEK_SET);
	else
		ret = lseek(fd, 0x30, SEEK_SET);

	if (ret < 0)
		errx(EXIT_FAILURE, "lseek \"%s\" failed" , str_name);

	if (read(fd, flags, 4) != 4)
		errx(EXIT_FAILURE, "read flags \"%s\" failed" , str_name);

	if (endian == 2)
		*(unsigned int *)flags |= (1 << 25);
	else
		*(unsigned int *)flags |= (1 << 1);

	if (format == 1)
		ret = lseek(fd, 0x24, SEEK_SET);
	else
		ret = lseek(fd, 0x30, SEEK_SET);

	if (ret < 0)
		errx(EXIT_FAILURE, "lseek \"%s\" failed" , str_name);

	if (write(fd, &flags, 4) != 4)
		errx(EXIT_FAILURE, "write flags \"%s\" failed" , str_name);

	close(fd);

	exit (EXIT_SUCCESS);
}
