#ifndef __HOST_H__
#define __HOST_H__

#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <stdio.h>
#include <stddef.h>
#include <stdint.h>
#include <errno.h>
#include <getopt.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define FLASH_NAME_SIZE	256

typedef struct {
	char flash_name[FLASH_NAME_SIZE];
	int flash_disp;
	int flash_lng;
	unsigned char * buffer;
} flash_t;
                                                                                     
#define FLASH_MAP_LINE	10

extern unsigned char * flash_buf;
extern flash_t map_buf[];
extern int map_size;

extern flash_t * spl_map;
extern int spl_ind;

#define MAX_FLASH_SIZE	0x1000000
#define MAX_FILE_LNG	0x30000
                                                                                                                      
extern int fd;
extern unsigned char * file_buf;
extern int file_lng;

#define NM6408_BRD_NUM	32

#define MC12705_DEVICE	"/dev/MC12705_XX"
#define MC12705_MAGIC	0x64080001

#define NM_CARD_DEVICE	"/dev/NM-Card_XX"
#define NM_CARD_MAGIC	0x64080002

#define NM_MEZZO_DEVICE "/dev/NM-Mezzo_XX"
#define NM_MEZZO_MAGIC	0x64080003

#define NM_QUAD_DEVICE "/dev/NM-Quad_XX"
#define NM_QUAD_MAGIC  0x64080004

#define NEURO_MEZZANINE_DEVICE "/dev/NeuroMezzanine_XX"
#define NEURO_MEZZANINE_MAGIC 0x64080005

extern int nm6408_fd[];
extern int nm6408_index[];
extern int nm6408_count;

//#define DEBUG
#undef DEBUG

#define err(fmt, args...)\
	printf("ERROR : %s#%d: " fmt ".\n",\
		__FILE__,__LINE__, ##args)

#ifdef DEBUG
#define dbg(fmt, args...)\
	printf("%s:%d: " fmt ".\n",\
		__FILE__,__LINE__, ##args)
#else
#define dbg(fmt, args...)
#endif

#endif

