OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)

MEMORY
{
	IMB0	: ORIGIN = 0x00020000, LENGTH = 0x00010000
	IMB1	: ORIGIN = 0x00030000, LENGTH = 0x00010000
	IMB2	: ORIGIN = 0x00040000, LENGTH = 0x00020000
}

ENTRY(_reset)

SECTIONS
{
	__exec_begin = ORIGIN(IMB0);
	. = __exec_begin;

	.text :
	{
		. = 0;
		KEEP( *(.vectors) )

		. = 0x800;
		KEEP( *(.desc) )

		__entry_start = ABSOLUTE (.);
		KEEP( *(.startup) )

		*(.text .text.*)
		*(.rodata .rodata.*)
	} > IMB0

	.plt : { *(.plt) *(.iplt) } > IMB0

	. = .;

	.got : { *(.got.plt) *(.igot.plt) *(.got) *(.igot) } > IMB0

	.data :
	{
		*(.data .data.*)
	} > IMB0

	. = ALIGN(4);
	__exec_limit = .;

	__exec_size = __exec_limit - __exec_begin;

	.bss (NOLOAD) :
	{
		. = ALIGN(4);
		__bss_start = .;

		*(.bss COMMON .bss.*)

		. = ALIGN(4);
		__bss_end = .;
	} > IMB0

	.stack (NOLOAD) :
	{
		. = ALIGN(8);
		__stack_end = .;

		KEEP ( *(.stack) )

		. = ALIGN(8);
		__stack_start = .;
	} > IMB0

	.heap.image (NOLOAD) :
	{
		__image_start = .;
		. = LENGTH(IMB1);
		__image_end = .;
	} > IMB1

	.heap.buf (NOLOAD) :
	{
		__buf_head = .;
		. = . + 0x10000;
		__buf_tail = .;
		. = . + 0x10000;

		. = LENGTH(IMB2);
	} > IMB2
}
