.global _reset
.global _start

.weak __stack_end
.weak __stack_start

.extern __exec_begin
.extern __exec_limit

.extern __bss_start
.extern __bss_end

.code 32

.section .vectors,"ax",%progbits
.align 5
_reset:
	B jump_reset
	B dead_loop
	B dead_loop
	B dead_loop
	B dead_loop
nop_0:	.word 0x10ADC0DE
	B dead_loop
	B dead_loop

jump_reset:
	MOV R0, PC
	LDR R1, =check_pc
check_pc:
	SUBS R2, R0, R1
	BEQ copy_done

	LDR R0, =__exec_begin
	ADDS R1, R0, R2
	LDR R2, =__exec_limit

copy_loop:
	CMP R0, R2
	BEQ copy_done
	LDR R3, [R1], #4
	STR R3, [R0], #4
	B copy_loop

copy_done:
	LDR PC, reset_addr

dead_loop:
	B dead_loop

reset_addr:	.word reset_handler

.section .startup,"ax",%progbits
.align 2
_start:
reset_handler:
	MOVW R0, #0x01D3
	MOVT R0, #0x0000
	MSR CPSR_xc, R0
	LDR SP, =__stack_start

	LDR R0, =__bss_start
	LDR R1, =__bss_end
	MOV R2, #0

zero_loop:
	CMP R1, R0
	BEQ call_main
	STR R2, [R0], #4
	B zero_loop

call_main:
	BL _main

	LDR R1, =_reset
	STR R0, [R1, #0x14]

finish_loop:
	NOP
	B finish_loop

.section .stack, "wa",%nobits
.align 3
__stack_end:
.skip 0x4000
__stack_start:
