//--------------------------------------------------------------------------//
//                                                                                                        //
///       STUDIO           //
//          nm6408                             //
//                  destructor error     IO_SERV_PROG_RUN                //
//					 than attribute Att_Forse_Destruct                               //
//-------------------------------------------------------------------------//
//#include <iostream>
//#include <stdlib.h>

#include <common_board_tc.h>
#include <io_host.h>

#define	Pass		0
#define	Fail		1
#define	UnTested	2

#define one_sec	1000

int main(int argc, char* argv[]) 
{
    int res;
    #define test_cnt	100000
    unsigned int count = test_cnt;
	
    int test_res = Pass;
    PL_Board *board = (PL_Board *)0;
    PL_Access *access=NULL;
	FILE *F=NULL; 
    const char *trg_prog =  "part";
	char trg_name[16];
	char prog [40];
    struct PL_CoreNo No = {-1,-1};
	PL_Access *servAccess=NULL;
	IO_Service *nms=NULL;
	PL_Word loop=0;
	int wait_time = one_sec*8; // 8 sec
	DWORD  funct,funct_error;
	DWORD attr=0, default_attr=0;
	int err=0;
								
	printf("Test  case - destructor error IO_SERV_PROG_RUN than attribute Att_Forse_Destruct\n");
	if(argc <2) {
		printf("Unknown test or target argc=%d\n",argc);
		return -1;
	}
	 // define core
	No.nm_id = strtoul(argv[1], NULL, 0);  
	if (argc == 4){
		No.cluster_id = strtoul(argv[2], NULL, 0);
	}else{
		No.cluster_id = 2;
	}
	//define nmc or arm and target program
	if(No.nm_id < 0) { // ARM prog
		sprintf(trg_name,"%s","arm");
		sprintf_s(prog,"../bin_trg/arm_%s.elf", trg_prog);
	}else{ // NMC prog
		sprintf(trg_name,"%s","nmc");
		sprintf_s(prog,"../bin_trg/nmc_%s_%d.abs", trg_prog,No.nm_id);
	}
	printf("Target {%d,%d}  prog %s\n",No.nm_id,No.cluster_id,prog);
	
	PL_SetTimeout(wait_time);
	PL_GetBoardCount(&count);
	if((count == 0) || (count == test_cnt)) {
		printf("count = %d\n",count);
		test_res = UnTested;
	} else if ((res = PL_GetBoardDesc(0, &board)) != PL_OK) {
		printf("PL_GetBoardDesc returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res =  PL_ResetBoard(board)) != PL_OK) {
		printf("PL_ResetBoard returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res = PL_LoadInitCode(board)) != PL_OK) {
		printf("PL_LoadInitCode returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if((res = PL_GetAccess(board, &(No), &(access))) != PL_OK) {
			printf("PL_GetAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} else if((res = PL_LoadProgramFile(access, prog)) != PL_OK) {
			printf("PL_LoadProgramFile returns %s prog=%s\n",
				sp_error_name[res],prog);
			test_res = Fail;
	} else if(PL_GetAccess(board, &(No), &(servAccess)) != PL_OK){
			printf("servAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} 

	if(test_res !=Pass){
		goto finish;
	}
//	sleep(1); //1secc
	
	try	{
		if( (nms = IO_ServiceStart(servAccess,F,NULL,NULL)) == NULL ){
			printf("IO_ServiceStart   Fail\n");
			test_res = Fail;
			goto finish;
		}
	}
	catch (...) {
			printf("ERROR: IO_Service \n");
			test_res = Fail;
			goto finish;
	} 

	if(test_res !=Pass){
		goto finish;
	}
	printf("IO_ServiceStart  PASS\n");
	
	IO_ServiceStop(&nms,&err); 
	if(nms ==NULL){
		printf("IO_ServiceStop must have error but nms==NULL.  Fail\n");
		test_res = Fail;
		goto finish;
	}else{
		Get_IO_Serv_Error(nms,&funct,&funct_error);
		if((err == IO_SERV_PROG_RUN) &&(funct_error ==0)) {
				printf("IO_ServiceStop err == IO_SERV_PROG_RUN  Pass\n");
		}else if(funct_error ==0){
				printf("IO_ServiceStop err=%d  expect %d Fail\n",
						err,IO_SERV_PROG_RUN);
				test_res = Fail;
				goto finish;
		}else{
				printf("IO_ServiceStop error with LLC function=%d  error=%d  Fail\n",
						funct,funct_error);
				test_res = Fail;
				goto finish;
		}
	}
	
	Get_IO_Serv_attribute(nms,Att_Forse_Destruct,&default_attr);
	Set_IO_Serv_attribute(nms,Att_Forse_Destruct,1);
	Get_IO_Serv_attribute(nms,Att_Forse_Destruct,&attr);
	if((attr == 1) && (default_attr == 0)){
		printf("New Att_Forse_Destruct=%d default_attr=%d Pass\n",
				attr,default_attr);
	}else{
		printf("New Att_Forse_Destruct=%d default_attr=%d expect 1  and 0 Fail\n",
				attr,default_attr);
		test_res = Fail;
		goto finish;
	}
/*
	if((res = PL_Sync(access,1,&loop)) != PL_OK) {
			printf("PL_Sync returns %s\n",sp_error_name[res]);
			test_res = Fail;
	}


	if(test_res ==Pass){
		PL_Word status = 9999;
		for(int w=0; w<1; w++) {
			sleep(1); //1sec
			if ((res = PL_GetStatus(access, &status)) != PL_OK) {
				printf( "PL_GetStatus returns %s\n", sp_error_name[res]);
				test_res = Fail;
				break;
			}
			if (status == PROGRAM_FINISHED) { 
				break;
			}
		}
		if(status != PROGRAM_FINISHED){
			printf("%s doesn't finish status=%d PROGRAM_FINISHED=%d\n",
					prog,status,PROGRAM_FINISHED);
			test_res = Fail;
		}
	}
*/
	if(test_res ==Pass){
		int err=0;
		IO_ServiceStop(&nms,&err); 
		if(nms ==NULL){
			printf("IO_ServiceStop must have success nms==NULL.  PASS\n");
		}else{
			printf("With Att_Forse_Destruc IO_ServiceStop must have success, but nms!=NULL.err=%d  FAL\n",err);
			test_res = Fail;
		}
	}
finish:
	if (nms != NULL) IO_ServiceStop(&nms,NULL); 
	if (servAccess != NULL) PL_CloseAccess(servAccess);
	if (access != NULL) PL_CloseAccess(access);
	if (F != NULL) fclose(F); 
	
	PL_ResetBoard(board);
	PL_LoadInitCode(board);
    PL_CloseBoardDesc(board);

	if(test_res !=Pass) printf("STDIO ATTR TEST FAIL\n");
	else printf("STDIO ATTR TEST PASS\n");
    return(test_res);
}


