//----------------------------------------------------------------------------//
//                                                                                                          //
//       STUDIO               //
//          nm6408                                //
//                          constructor error     IO_SERV_SECOND               //
//                          destructor error     IO_SERV_PROG_RUN            //
//							 than attribute Att_Forse_Destruct                           //
//----------------------------------------------------------------------------//
#include <iostream>
#include <stdlib.h>

#include <common_board_tc.h>
#include <io_host.h>

#define	Pass		0
#define	Fail		1
#define	UnTested	2

#define one_sec	1000

int main(int argc, char* argv[]) 
{
    int res;
    #define test_cnt	100000
    unsigned int count = test_cnt;
	
    int test_res = Pass;
    PL_Board *board = (PL_Board *)0;
    PL_Access *access=NULL;
	FILE *F=NULL; 
    const char *trg_prog =  "part";
	char trg_name[16];
	char prog [40];
    struct PL_CoreNo No = {-1,-1};
	PL_Access *servAccess=NULL;
	IO_Service *nms=NULL;
	IO_Service *nms_2=NULL;
	PL_Word loop=0;
	int wait_time = one_sec*8; // 8 sec
	DWORD attr, funct,funct_error;

	printf("Test case - complex test constructor error IO_SERV_SECOND\n"\
			  "                         destructor error IO_SERV_PROG_RUN\n"\
			  "                         attribute Att_Forse_Destruct\n");

	if(argc <2) {
		printf("Unknown test or target argc=%d\n",argc);
		return -1;
	}
	 // define core
	No.nm_id = strtoul(argv[1], NULL, 0);  
	if (argc == 4){
		No.cluster_id = strtoul(argv[2], NULL, 0);
	}else{
		No.cluster_id = 2;
	}
	//define nmc or arm and target program
	if(No.nm_id < 0) { // ARM prog
		sprintf(trg_name,"%s","arm");
		sprintf_s(prog,"../bin_trg/arm_%s.elf", trg_prog);
	}else{ // NMC prog
		sprintf(trg_name,"%s","nmc");
		sprintf_s(prog,"../bin_trg/nmc_%s_%d.abs", trg_prog,No.nm_id);
	}

	printf("Target {%d,%d}  prog %s\n",No.nm_id,No.cluster_id,prog);
	
	PL_SetTimeout(wait_time);
	PL_GetBoardCount(&count);
	if((count == 0) || (count == test_cnt)) {
		printf("count = %d\n",count);
		test_res = UnTested;
	} else if ((res = PL_GetBoardDesc(0, &board)) != PL_OK) {
		printf("PL_GetBoardDesc returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res =  PL_ResetBoard(board)) != PL_OK) {
		printf("PL_ResetBoard returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res = PL_LoadInitCode(board)) != PL_OK) {
		printf("PL_LoadInitCode returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if((res = PL_GetAccess(board, &(No), &(access))) != PL_OK) {
			printf("PL_GetAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} else if((res = PL_LoadProgramFile(access, prog)) != PL_OK) {
			printf("PL_LoadProgramFile returns %s prog=%s\n",
				sp_error_name[res],prog);
			test_res = Fail;
	} else if(PL_GetAccess(board, &(No), &(servAccess)) != PL_OK){
			printf("servAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} 

	if(test_res !=Pass){
		goto finish;
	}
////////////////////////////////////////////////////////////////
	printf("First IO_ServiceStart\n");
	try	{
		if( (nms = IO_ServiceStart(
				servAccess,
				F
				,NULL
				,NULL)) == NULL ){
			printf("IO_Service Fail\n");
			test_res = Fail;
			goto err_finish;
		}
	}
	catch (...) {
			printf("ERROR: IO_Service \n");
			test_res = Fail;
			goto err_finish;
	} 
////////////////////////////////////////////////////////////////////
	printf("Second IO_ServiceStart\n"); 
	try	{
		int err_2=0;
		if( (nms_2 = IO_ServiceStart(
				servAccess,
				F,
				NULL,
				&err_2)) != NULL ){
			printf("Second IO_ServiceStart must have error   Fail\n");
			test_res = Fail;
		}else{
			if((err_2 != IO_SERV_SECOND) ) {
				printf("Second IO_ServiceStart err =%d expect %d  Fail\n",err_2,IO_SERV_SECOND);
				test_res = Fail;
			}else {
				printf("Second IO_ServiceStart err == IO_SERV_SECOND  PASS\n");
			}
		}
	}
	catch (...) {
			printf("ERROR: Second IO_Service \n");
			test_res = Fail;
//			goto finish;
	} 
	
	
//	if((res = PL_Sync(access,1,&loop)) != PL_OK) {
//			printf("PL_Sync returns %s\n",sp_error_name[res]);
//			test_res = Fail;
//	}
//	sleep(1);
	
finish:
	if (nms != NULL){
		int err=0;
		IO_ServiceStop(&nms,&err); 
		if(nms == NULL){
			printf("After first IO_ServiceStop nms == NULL FAIL\n");
			test_res = Fail;
		}else{
			Get_IO_Serv_Error(nms,&funct,&funct_error);
			if((err == IO_SERV_PROG_RUN) &&(funct_error ==0)) {
				printf("After first IO_ServiceStop err == IO_SERV_PROG_RUN  PASS\n");
			}else {
				printf("After first IO_ServiceStop err != IO_SERV_PROG_RUN  FAIL\n");
				test_res = Fail;
			}
			printf("After first IO_ServiceStop set attribute Att_Forse_Destruct\n");
			Set_IO_Serv_attribute(nms,Att_Forse_Destruct,1);
			printf("New Att_Forse_Destruct=%d \n",
					Get_IO_Serv_attribute(nms,Att_Forse_Destruct,NULL));
			printf("Call  second IO_ServiceStop \n");
			IO_ServiceStop(&nms,NULL);
			if(nms != NULL){
				printf("After second IO_ServiceStop nms != NULL FAIL\n");
				test_res = Fail;
			}else{
				printf("After second IO_ServiceStop nms == NULL PASS\n");
			}
		}
	}
err_finish:	
	if (servAccess != NULL) PL_CloseAccess(servAccess);
	if (access != NULL) PL_CloseAccess(access);
	if (F != NULL) fclose(F); 
	
	PL_ResetBoard(board);
	PL_LoadInitCode(board);
    PL_CloseBoardDesc(board);
	if(test_res !=Pass) printf("STDIO ATTR TEST FAIL\n");
	else printf("STDIO ATTR TEST PASS\n");
    return(test_res);
}


