//----------------------------------------------------------------------------//
//                                                                                                         //
//            STUDIO         //
//               nm6408                         //
//          diagnostic of LLC error IO_SERV_SIGSEGV for Linux     //
//----------------------------------------------------------------------------//
#include <iostream>
#include <stdlib.h>

#include <common_board_tc.h>
#include <io_host.h>

#define	Pass		0
#define	Fail		1
#define	UnTested	2

#define one_sec	1000

int main(int argc, char* argv[]) 
{
    int res;
    int test_res = Pass;
	FILE *F=(FILE *)100; 
	int err=0;
 	PL_Access *servAccess=(PL_Access *)200;
	IO_Service *nms=(IO_Service *)300;


	printf("Test  case - diagnostic of LLC error IO_SERV_SIGSEGV for Linux\n");
	
	try	{
		if( (nms = IO_ServiceStart(/*prog*/	servAccess ,F,(void *)400,&err)) != NULL ){
			printf("IO_ServiceStart must have error   Fail\n");
			test_res = Fail;
//			goto finish;
		}else{
			if((err != IO_SERV_SIGSEGV) ) {
				printf("IO_ServiceStart err =%d expect %d  Fail\n",err,IO_SERV_SIGSEGV);
				test_res = Fail;
//				goto finish;
			}else {
				printf("IO_ServiceStart err == IO_SERV_SIGSEGV  Pass\n");
			}
		}
	}
	catch (...) {
			printf("ERROR in catch: IO_Service  Fail\n");
			test_res = Fail;
//			goto finish;
	} 
	err = IO_ServiceStop(&nms,NULL); 
	if((err != IO_SERV_SIGSEGV) ) {
		printf("IO_ServiceStop err =%d expect %d  Fail\n",err,IO_SERV_SIGSEGV);
		test_res = Fail;
//		goto finish;
	}else {
		printf("IO_ServiceStop err == IO_SERV_SIGSEGV  Pass\n");
	}
	err = Set_IO_Serv_attribute(nms,0,0); 
	if((err != -1) ) {
		printf("Set_IO_Serv_attribute err =%d expect -1  Fail\n",err);
		test_res = Fail;
//		goto finish;
	}else {
		printf("Set_IO_Serv_attribute err == %d  Pass\n",-1);
	}
	err = Get_IO_Serv_attribute(nms,0,NULL); 
	if((err != -1) ) {
		printf("Get_IO_Serv_attribute err =%d expect -1  Fail\n",err);
		test_res = Fail;
//		goto finish;
	}else {
		printf("Get_IO_Serv_attribute err == %d  Pass\n",-1);
	}
	err = Get_IO_Serv_Error(nms,NULL,NULL); 
	if((err != -1) ) {
		printf("Get_IO_Serv_Error err =%d expect -1  Fail\n",err);
		test_res = Fail;
//		goto finish;
	}else {
		printf("Get_IO_Serv_Error err == %d  Pass\n",-1);
	}
finish:
	if(test_res !=Pass) printf("STDIO ATTR TEST FAIL\n");
	else printf("STDIO ATTR TEST PASS\n");
    return(test_res);
}


