#!/bin/bash -e

LIB="lib"
INC="include"

rm -rf ${INC}/*
rm -rf ${LIB}/*

mkdir -p ${INC}/
mkdir -p ${LIB}/



if [[ "$1" != "mc12705" ]] && [[ "$1" != "nm_card" ]] && [[ "$1" != "nm_mezzo" ]] && [[ "$1" != "nm_quad" ]] && [[ "$1" != "neuro_mezzanine" ]]; then
	echo "ERROR: Unknown board!"
	exit -1
fi

if [[ "$1" == "nm_card" ]]; then
	DNAME="nm_card"
	LNAME="libnm_card_load.so"
	INAME="nm_card_load.h"
elif [[ "$1" == "nm_mezzo" ]]; then
	DNAME="nm_mezzo"
	LNAME="libnm_mezzo_load.so"
	INAME="nm_mezzo_load.h"
elif [[ "$1" == "nm_quad" ]]; then
	DNAME="nm_quad"
	LNAME="libnm_quad_load.so"
	INAME="nm_quad_load.h"
elif [[ "$1" == "neuro_mezzanine" ]]; then
	DNAME="NeuroMezzanine"
	LNAME="libneuro_mezzanine_load.so"
	INAME="neuro_mezzanine_load.h"
else
	DNAME="mc12705"
	LNAME="libmc12705load.so"
	INAME="mc12705load.h"
fi

# LIBS

#host
# ./libload/${1}/${LNAME}
# ./io_service/host/libio_host.a
mkdir -p ${LIB}/${1}/
cp ../../../libload/${DNAME}/${LNAME}*   ${LIB}/${1}/.
cp ../../../io_service/host/libio_host.a   ${LIB}/.

#arm
# ./io_service/target/libarm_io.a
# ./libload/arm/libnm6408load_arm.a
cp ../../../io_service/target/libarm_io.a   ${LIB}/.
cp ../../../libload/arm/libnm6408load_arm.a   ${LIB}/.

#nmc
# ./io_service/target/libnmc_io.a
# ./libload/nmc/libnm6408load_nmc.a
cp ../../../io_service/target/libnmc_io.a   ${LIB}/.
cp ../../../libload/nmc/libnm6408load_nmc.a   ${LIB}/.

# INCLUDES

#host
# ./io_service/include/io_host.h
# ./io_service/include/nm6408wrap.h - not needed
# ./libload/${1}/${INAME}
cp ../../../io_service/include/io_host.h   ${INC}/.
cp ../../../libload/${DNAME}/${INAME}   ${INC}/.

#arm
# ./io_service/target/arm_printf.h  - not needed
# ./libload/arm/nm6408load_arm.h
cp ../../../libload/arm/nm6408load_arm.h   ${INC}/.

#nmc
# ./io_service/target/nmc_printf.h   - not needed
# ./libload/nmc/nm6408load_nmc.h
cp ../../../libload/nmc/nm6408load_nmc.h   ${INC}/.

