/*
   Пример реализации STUDIO с ранним связыванием библиотеки БЗО для плат серии nm6408     
	           Пример печати для arm, nmc
*/
#include <stdlib.h>
#include <common_board_tc.h>
#include "io_host.h"

int main(int argc, char* argv[]) {

    const char *ASSERTION="Simple printf for arm, nm.";	
    const char *TC="printf arm nm";
    int res, i;
    #define test_cnt	100000
    unsigned int count = test_cnt;
	#define cnt_pr	21
	
    int test_res = Pass;
    PL_Board *board = (PL_Board *)0;
    PL_Access *access[cnt_pr];
	FILE *F[cnt_pr]; 
    const char *trg_prog = "print";
	char cope_prog[32];
	char *prg;
	char trg_name[16];
	char *prog[cnt_pr];
	char *f_name[cnt_pr];
	
    struct PL_CoreNo No[cnt_pr];
	PL_Access *servAccess[cnt_pr];
	IO_Service *nms[cnt_pr];
	PL_Word syncValue=0, cnt_loop=0, loop=0;
	int Value_trg=0;
	int wait_time = 6000; // 6 sec
	int nm_id, arm_id, trg=0;
	int err=0;
	DWORD  funct,funct_error;
								
   tc_id(TC, ASSERTION);

	printf("Target list");
	for(i=1; argc>1; argc-=2, i+=2, trg++){ //define nm's and arm's
		nm_id = strtoul(argv[i], NULL, 0);
		arm_id = strtoul(argv[i+1], NULL, 0);
		No[i/2].nm_id = nm_id;
		No[i/2].cluster_id = arm_id;
		printf("{%d,%d} ",nm_id,arm_id);
		f_name[i/2]=(char*)malloc(50);
		memset(f_name[i/2],0,50);
		sprintf(f_name[i/2],"out_%d_%d_prog",nm_id,arm_id);
		printf("f_name[%d]= %s \n",i/2,f_name[i/2]);
	}
	printf("f_name[0]= %s \n",f_name[0]);
	if(trg > 1){
		printf("\n Out %d Files\n",trg);
		for(i=0;i<trg; i++){
			printf(" %s \n",f_name[i]);
		}
	}
	PL_SetTimeout(wait_time);
	PL_GetBoardCount(&count);
	if((count == 0) || (count == test_cnt)) {
		printf("count = %d\n",count);
		test_res = UnTested;
	} else if ((res = PL_GetBoardDesc(0, &board)) != PL_OK) {
		printf("PL_GetBoardDesc returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res =  PL_ResetBoard(board)) != PL_OK) {
		printf("PL_ResetBoard returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res = PL_LoadInitCode(board)) != PL_OK) {
		printf("PL_LoadInitCode returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}
	if(test_res !=Pass){
		printf("ERROR:BoardDesc\n");
		PL_CloseBoardDesc(board);
		return(test_res);
	}
	
	for(i=0; i<cnt_pr; i++){
		nms[i]=NULL;
		access[i]=NULL;
		servAccess[i]=NULL;
		F[i] = NULL;
	}
	for(i=0; i<trg; i++){
		prg = (char*)malloc(32);
		memset(prg,0,32);
		if((No[i]).nm_id < 0) { // ARM prog
			sprintf(trg_name,"%s","arm");
			sprintf(cope_prog,"../bin_trg/arm_%s.elf", trg_prog);
			strcpy(prg,cope_prog);
			prog[i]=prg;
			printf("ARM LoadProgram i=%d %s\n",i,prog[i]);
		}else{  // NMC prog
			sprintf(trg_name,"%s","nmc");
			sprintf(cope_prog,"../bin_trg/nmc_%s_%d.abs", trg_prog,(No[i]).nm_id);
			strcpy(prg,cope_prog);
			prog[i]=prg;
			printf("NMC LoadProgram i=%d %s\n",i,prog[i]);
		}
		if((res = PL_GetAccess(board, &(No[i]), &(access[i]))) != PL_OK) {
			printf("PL_GetAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
		} else if((res = PL_LoadProgramFile(access[i], prog[i])) != PL_OK) {
			printf("PL_LoadProgramFile returns %s\n",sp_error_name[res]);
			test_res = Fail;
		} else if(PL_GetAccess(board, &(No[i]), &(servAccess[i])) != PL_OK){
			printf("servAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
		} 
		if (test_res !=Pass){printf("ERROR:i=%d \n",i); break;}
	}
	if(test_res !=Pass){
		goto finish;
	}
	sleep(1); //1sec
	
	for(i=0; i<trg; i++){
		if (test_res !=Pass){
			printf("ERROR: test i=%d \n",i);
			goto finish;
		}

		try	{
			if(trg > 1){
				if( (F[i] = fopen( f_name[i], "w+t" )) == NULL ){
					printf("ERROR fopen \n");
					throw "fopen";
				}
			}

			if( (nms[i] = IO_ServiceStart(
	//								prog[i],
									servAccess[i], 
									F[i],
									NULL,
									NULL) ) == NULL ){
				printf("ERROR IO_Service \n");
				throw "IO_Service";
			}
		}
		catch (...) {
			printf("ERROR: IO_Service i=%d\n",i);
			test_res = Fail;
			goto finish;
		} // Try to work without service	
	}

	for(i=0; i<trg; i++){
		if((res = PL_Sync(access[i],syncValue,&loop)) != PL_OK) {
			printf("PL_Sync returns %s\n",sp_error_name[res]);
			test_res = Fail;
			goto finish;
		}
	}

	for(i=0; i<trg; i++){
		if(test_res !=Pass)break;
		if((res = WaitEndProgram(access[i], one_sec*3)) != PL_OK) {
			printf("nm_prog doesn't finish\n");
			test_res = Fail;
		}
	}
finish:
	for(i=0; i<trg; i++){
	printf("FINISH test trg=%d i=%d prog=%s \n",trg,i,prog[i]);
		if (nms[i] != NULL){ IO_ServiceStop(&nms[i],&err); }
		if(nms[i] != NULL){
			printf("loop=%d IO_ServiceStop nms != NULL err=%d FAIL\n",i,err);
			test_res = Fail;
			Get_IO_Serv_Error(nms[i],&funct,&funct_error);
			printf("Get_IO_Serv_Error funct=%d funct_error=%d\n",funct,funct_error);
		}
		if (servAccess[i] != NULL)PL_CloseAccess(servAccess[i]);
		if (access[i] != NULL)PL_CloseAccess(access[i]);
		if (F[i] != NULL){ fclose(F[i]); }
	    PL_CloseAccess(access[i]);
		if(prog[i] != NULL) free(prog[i]);
	}
	PL_ResetBoard(board);
	PL_LoadInitCode(board);
    PL_CloseBoardDesc(board);
	if (test_res !=Pass) printf("FAIL \n"); else printf("PASS \n");
    return(test_res);
}


