/*
    Тестовый набор STDIO  БЗО  nm6408
*/
#include <common_board_tc.h>
#include <io_host.h>

int main(int argc, char* argv[]) {
	
    const char *TC="Stdio Test Collection for arm & nmc";
    int res;
	PL_Word result, loop=0;
    #define test_cnt	100000
    unsigned int count = test_cnt;

    int test_res = Pass;
    PL_Board *board = (PL_Board *)0;
	PL_Access *access=NULL;	
    const char *trg_prog[24] = {
				"prog_t1", // open, close	+
				"prog_t2", // fopen, fclose		+
				"prog_t3", // write, read		+
				"prog_t4", // fwrite, fread		+
				"prog_t5", // lseek, fseek		+
				"prog_t6", //L? W-  cout << endl	+ can't be any stream 
				"prog_t7", // putchar, puts		+
				"prog_t8", // fputc, fputs, putc	+
				"prog_t9", // getchar, gets			+
				"prog_t10", // fgetc, fgets, getc, + ungetc+
				"prog_t11", // fflush +
				"prog_t12", // fseek+, fsetpos+, rewind+, fgetpos+, ftell+
				"prog_t13", // stat, fstat		+
				"prog_t14" ,//link, unlink	+
				"prog_t15",//remove			+
				"prog_t16", // rename		+
				"prog_t17", // isatty			+
				"prog_t18", // fileno,  feof, ferror, clearerr +
				"prog_t19", // printf	 sprintf fprintf
				"prog_t20",
				"prog_t3_1", // 21 write, read	with array offset	+
				"prog_t4_1", // 22 fwrite, fread with array offset +
				0,
				0
				};


	struct PL_CoreNo No  = {-1,-1};
	PL_Access *servAccess=NULL;
	IO_Service *nms=NULL;
	FILE *F=NULL; 
	char f_name[32];
	char prog [40];
	char trg_name[16];
	int  test_inx;
	int  trg=0, file_out=0;
	int wait_time = 6000; // 6 sec
	DWORD  funct,funct_error;
	int stop_err=0;
								
 //   tc_id(TC, ASSERTION);
	if(argc <3) {
		printf("Unknown test number or target\n");
		return -1;
	}
	test_inx = strtoul(argv[1], NULL, 0);
	test_inx--;
	// define core
	No.nm_id = strtoul(argv[2], NULL, 0);  
	if (argc == 4){
		No.cluster_id = strtoul(argv[3], NULL, 0);
	}else{
		No.cluster_id = 2;
	}
	//define nmc or arm and target program
	if(No.nm_id < 0) { // ARM prog
		sprintf(trg_name,"%s","arm");
		sprintf(prog,"../bin_trg/arm_%s.elf", trg_prog[test_inx]);
	}else{ // NMC prog
		sprintf(trg_name,"%s","nmc");
		sprintf(prog,"../bin_trg/nmc_%s_%d.abs", trg_prog[test_inx],No.nm_id);
	}
	if (argc == 5){ // need separate file for stdout value >0
		file_out= strtoul(argv[4], NULL, 0);
		sprintf(f_name,"out_%d_%d_%s_prog",No.nm_id,No.cluster_id,trg_name);
		printf("f_name = %s \n",f_name);
	}
	
	PL_SetTimeout(wait_time);
	PL_GetBoardCount(&count);
	if((count == 0) || (count == test_cnt)) {
		printf("count = %d\n",count);
		test_res = UnTested;
	} else if ((res = PL_GetBoardDesc(0, &board)) != PL_OK) {
		printf("PL_GetBoardDesc returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res =  PL_ResetBoard(board)) != PL_OK) {
		printf("PL_ResetBoard returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}else if ((res = PL_LoadInitCode(board)) != PL_OK) {
		printf("PL_LoadInitCode returns %s\n",sp_error_name[res]);
		test_res = Fail;
	}
	if(test_res !=Pass){
		printf("ERROR:BoardDesc\n");
		PL_CloseBoardDesc(board);
		return(test_res);
	}

/////////////////////////////////////////////////////////////////

	printf("Target list{%d,%d}\n",No.nm_id,No.cluster_id);
	printf("%s LoadProgram  %s\n",trg_name,prog);
		
	if((res = PL_GetAccess(board, &(No), &(access))) != PL_OK) {
			printf("PL_GetAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} else if((res = PL_LoadProgramFile(access, prog)) != PL_OK) {
			printf("PL_LoadProgramFile returns %s prog=%s\n",
				sp_error_name[res],prog);
			test_res = Fail;
	} else if(PL_GetAccess(board, &(No), &(servAccess)) != PL_OK){
			printf("servAccess returns %s\n",sp_error_name[res]);
			test_res = Fail;
	} 
	
	if(test_res !=Pass){
		goto finish;
	}
	sleep(1); //1sec

	try	{
	printf("IO_ServiceStart\n");
		if(file_out){
			if( (F = fopen( f_name, "w+t" )) == NULL ){
				printf("ERROR fopen \n");
				throw "fopen";
			}
		}
		if( (nms = IO_ServiceStart(
					//in linux argument prog is't needed
					servAccess
					,F
					,NULL
					,NULL)) == NULL ){
			printf("ERROR IO_Service \n");
			throw "IO_Service";
		}
	}
	catch (...) {
			printf("ERROR: IO_Service go to finish\n");
			test_res = Fail;
			goto finish;
	} // Try to work without service	
	
printf("Sync LOOP\n");
	for(int k=0; k<5; k++){ 
		if((res = PL_Sync(access,k,&loop)) != PL_OK) {
			printf("%d PL_Sync returns %s\n",k,sp_error_name[res]);
			test_res = Fail;
			goto finish;
		}
		printf("STEP %d  PL_Sync recive=0x%x\n",k, loop);
		if((loop > 0x11) &&(loop < 0x20)) {
			PL_SetTimeout(wait_time*(loop- 0x10));
			printf("Timeout increased in %d times\n",loop- 0x10);
		}
	}
printf("Sync LOOP END\n");
	if(test_res ==Pass){
		if((res = WaitEndProgram(access, one_sec*3)) != PL_OK) {
			printf("%s doesn't finish\n",prog);
			test_res = Fail;
		}else if((res = PL_GetResult(access, &result)) != PL_OK) {
			printf("PL_GetResult returns %s\n",sp_error_name[res]);
			test_res = Fail;
		}else if(result != 0) {
			printf( "PL_GetResult result %u\n",result);
			test_res = Fail;
		}
	}
finish:
printf("HOST FINISH\n");
	for(int r=0; r<3; r++){
		if (nms != NULL) res=IO_ServiceStop(&nms,&stop_err);
		if(res) {
			funct=101; funct_error=101;
			Get_IO_Serv_Error(nms,&funct,&funct_error);
			printf("Repide IO_ServiceStop res=%d stop_err=%d funct_error=%d\n",
				res,stop_err,funct_error);
		}else break;
		sleep(1);
	}
		if (servAccess != NULL) PL_CloseAccess(servAccess);
		if (access != NULL) PL_CloseAccess(access);
		if (F != NULL) fclose(F); 
	    PL_CloseAccess(access);
	
	PL_ResetBoard(board);
	PL_LoadInitCode(board);
    PL_CloseBoardDesc(board);
	if (test_res !=Pass) printf("FAIL \n"); else printf("PASS \n");
    return(test_res);
}


