/*
     %s_stdio test
	+	int fgetc(FILE *stream);
	+	char *fgets(char *s, int size, FILE *stream);
	+	int getc(FILE *stream);
	+	int ungetc(int c, FILE *stream);
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	FILE *fd = NULL;
	char mode_1[8];
	char mode_2[8];
	char arr_in[32], arr_out[32];
	char *buf;
	fpos_t pos;
	
	strcpy(mode_1,"w+");

	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode_1);
	fd=fopen("F_1",mode_1);
	if(fd == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d \n",CORE_TYPE,mode_1,errno);
		printf("FAIL\n",CORE_TYPE);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode_1);
	}

	trg_hostSync( 0x20);
	printf("%s STDIO FPUTS START\n",CORE_TYPE);
//		int fgetc(FILE *stream);
//		char *fgets(char *s, int size, FILE *stream);
//		int getc(FILE *stream);
//		int ungetc(int c, FILE *stream);
	strcpy(arr_out,"123456789\n");
	printf("%s STDIO FPUTS to fd  arr_in=%s\n",CORE_TYPE,arr_out);
	st=fputs(arr_out,fd);
	if(st < 0){
		printf("%s STDIO FPUTS ERROR errno=%d \n",CORE_TYPE,errno);
		printf("FAIL\n",CORE_TYPE);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FPUTS PASS st=%d \n",CORE_TYPE,st);
	}
	printf("%s STDIO UNGETC pos=%ld\n",CORE_TYPE,ftell(fd));
	st=ungetc('d', fd);
	if(st <0){
		printf("%s STDIO UNGETC ERROR  st=0x%x errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO UNGETC st=%c PASS \n",CORE_TYPE,st);
	}
	printf("%s STDIO  CHECK UNGETC\n",CORE_TYPE);
	st=getc(fd);
	if(st != 'd'){
		printf("%s STDIO UNGETC ERROR: getc(fd)=%c != d\n",CORE_TYPE,st);
		FAIL=1;
	}else{
		printf("%s STDIO UNGETC PASS \n",CORE_TYPE);
	}
	fclose(fd);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,"r+");
	fd=fopen("F_1","r+");
	rewind(fd);
	printf("%s STDIO fgetc from fd \n",CORE_TYPE);
	st=fgetc(fd); // 1
	if(st != arr_out[0]){
		printf("%s STDIO FGETC ERROR  st=0x%x  errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FGETC  st=%c expect=%c PASS\n",CORE_TYPE,st,arr_out[ftell(fd)-1]);
	}
	trg_hostSync(0x30);
	memset(arr_in,0,32);
	printf("%s STDIO FGETS from fd  pos=%ld\n",CORE_TYPE,ftell(fd));
//	memset(buf,0,5);
	buf=fgets(arr_in,3,fd); // 23  read size -1 bytes
	if(buf == NULL){
		printf("%s STDIO FGETS ERROR  buf=0x%x errno=%d \n",CORE_TYPE,buf,errno);
		FAIL=1;
	}else if((strncmp(buf, (char *)(&arr_out[1]), 3-1)) != 0){
		printf("%s STDIO FGETS ERROR: Not eqaul buf and arr_in. FAIL\n",CORE_TYPE);
		printf("%s STDIO FGETS  buf=%s  \n",CORE_TYPE,buf);
		FAIL=1;
	}else{
		printf("%s STDIO FGETS  buf=%s  PASS\n",CORE_TYPE,buf);
	}
	printf("%s STDIO GETC from fd  pos=%ld\n",CORE_TYPE,ftell(fd));
	st=getc(fd); // 4
	if(st != arr_out[3]){
		printf("%s STDIO GETC ERROR  st=%c  arr_out[3]=%c arr_out[ftell(fd)-1]=%c \n",CORE_TYPE,
				st,arr_out[3],arr_out[ftell(fd)-1]);
		FAIL=1;
	}else{
		printf("%s STDIO GETC  st=%c expect=%c PASS\n",CORE_TYPE,
			st, arr_out[ftell(fd)-1]);
	}
	
	trg_hostSync(0x40);
	printf("%s STDIO fclose(fd START\n",CORE_TYPE);
	if((st=fclose(fd)) != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d\n",CORE_TYPE,st);
	}

	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
