/*
    %s_stdio test fflush

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	FILE *fd = NULL;
	FILE *rf = NULL;
	char mode[8];
	char rmode[8];
	char arr_in[32], arr_out[32];
	int binary=0;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}

	if(binary){
		strcpy(mode,"w+b");
		strcpy(rmode,"rb");
	}else{
		strcpy(mode,"w+");
		strcpy(rmode,"r");
	}
	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode);
	fd=fopen("F_0",mode);
	if(fd == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d \n",CORE_TYPE,mode,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode);
	}
	printf("%s STDIO fopen START rmode=%s\n",CORE_TYPE,rmode);
	rf=fopen("F_0",rmode);
	if(rf == NULL){
		printf("%s STDIO fopen ERROR  rmode=%s errno=%d \n",CORE_TYPE,rmode,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen rmode=%s PASS \n",CORE_TYPE,rmode);
	}

	trg_hostSync( 0x20);
	printf("%s STDIO FWRITE START stream fd\n",CORE_TYPE);
	strcpy(arr_out,"1234567890123456");
	sz = strlen(arr_out);
	res=fwrite(arr_out,1,sz,fd);
	if(res != sz){
		printf("%s STDIO FWRITE ERROR sz=%d res=%d errno=%d \n",CORE_TYPE,sz,res,errno);
		printf("FAIL\n",CORE_TYPE);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FWRITE PASS res=%d errno=%d\n",CORE_TYPE,res,errno);
	}
	
	trg_hostSync(0x30);
	printf("%s STDIO FREAD  BEFORE FFLUSH stream rf pos=%ld\n",CORE_TYPE
			,ftell(rf));
	strcpy(arr_in,"ABCDEFGHI");
	printf("%s STDIO FREAD  arr_in=%s\n",CORE_TYPE,arr_in);
	st=fread(arr_in,1,9,rf);
	if(st != 0){
		printf("%s STDIO FREAD can something read st=%d  pos=%ld arr=%s\n",CORE_TYPE
				,st,ftell(rf),arr_in);
		if((strncmp(arr_in, arr_out, 9)) != 0){
			printf("%s STDIO FREAD ERROR: Not eqaul arr_out and arr_in. FAIL\n",CORE_TYPE);
			FAIL=1;
		}else {
			printf("%s STDIO FREAD BEFORE FFLUSH arr_in=%s  PASS\n",CORE_TYPE,arr_in);
		}
	}else{
		printf("%s STDIO FREAD EOF PASS st=%d  pos=%ld\n",CORE_TYPE,st,ftell(rf));
		printf("%s STDIO FREAD AFTER arr_in=%s  pos=%ld\n",CORE_TYPE,arr_in,ftell(rf));
	}
	rewind(rf);  // Needed because after last reading  the file point is set on  (EOF)
	printf("%s STDIO FFLUSH START stream fd \n",CORE_TYPE);
	st=fflush(fd);
	if(sz <0){
		printf("%s STDIO FFLUSH FAIL errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FFLUSH PASS \n",CORE_TYPE);
	}
	printf("%s STDIO FREAD START AFTER FFLUSH stream rf pos=%ld\n",CORE_TYPE,ftell(rf));
	strcpy(arr_in,"ABCDEFGHI");
	printf("%s STDIO FREAD  arr_in=%s\n",CORE_TYPE,arr_in);
	st=fread(arr_in,1,9,rf);
	if(st != 9){
		printf("%s STDIO FREAD ERROR st=%d errno=%d pos=%ld\n",CORE_TYPE
				,st,errno,ftell(rf));
	}else if((strncmp(arr_in, arr_out, 9)) != 0){
		printf("%s STDIO FREAD ERROR: Not eqaul arr_out and arr_in. FAIL\n",CORE_TYPE);
		printf("%s STDIO FREAD st=%d errno=%d pos=%ld\n",CORE_TYPE
				,st,errno,ftell(rf));
		FAIL=1;
	}else {
		printf("%s STDIO FREAD AFTER arr_in=%s  PASS\n",CORE_TYPE,arr_in);
	}
	
	trg_hostSync(0x40);
printf("%s STDIO fclose(fd) START\n",CORE_TYPE);
	st=fclose(fd);
	if(st != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d\n",CORE_TYPE,st);
	}
	printf("%s STDIO fclose(rf) START\n",CORE_TYPE);
	st=fclose(rf);
	if(st != 0){
		printf("%s STDIO fclose(rf) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(rf) PASS  st=%d\n",CORE_TYPE,st);
	}

	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
