/*
   %s_stdio test 
		int fseek(FILE *stream, long offset, int whence);
		long ftell(FILE *stream);
		void rewind(FILE *stream);
		int fgetpos(FILE *stream, fpos_t *pos);
		int fsetpos(FILE *stream, fpos_t *pos);  
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	long int cur;
	FILE *fd = NULL;
	FILE *rf = NULL;
	char mode[8];
	char rmode[8];
	char arr_in[32], arr_out[32];
	fpos_t pos;
	
	strcpy(mode,"w+");

	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode);
	if((fd=fopen("F_0",mode)) == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d FAIL \n",CORE_TYPE,
					mode,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO FWRITE START\n",CORE_TYPE);
	strcpy(arr_out,"1234567890123456");
	st=9999999;
	if((st=fwrite(arr_out,1,9,fd)) != 9){
		printf("%s STDIO FWRITE ERROR st=%d errno=%d FAIL\n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FWRITE PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	
	printf("%s STDIO SETTING POSITION START fpos_t=%d\n",CORE_TYPE,sizeof(fpos_t));
	pos=555;
	if((st=fgetpos(fd,&pos)) != 0){
		printf("%s STDIO FGETPOS ERROR st=%d errno=%d FAIL\n",CORE_TYPE,
				st,errno);
		FAIL=1;
		goto OUT;
	}else if(pos != 9){
		printf("%s STDIO FGETPOS ERROR pos=%d expect 9 FAIL\n",CORE_TYPE,pos);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FGETPOS = %ld PASS\n",CORE_TYPE,pos);
	cur=555;
	if((cur=ftell(fd)) != 9){
		printf("%s STDIO FTELL ERROR pos=%ld expect 9 FAIL\n",CORE_TYPE,cur);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FTELL = %ld PASS\n",CORE_TYPE,cur);
	printf("%s STDIO FSEEK TO 5\n",CORE_TYPE);
	st=1234567;
	if((st=fseek(fd,5,SEEK_SET)) != 0){
		printf("%s STDIO fseek(fd) ERROR  st=%d errno=%d FAIL\n",CORE_TYPE,
				st,errno);
		FAIL=1;
		goto OUT;
	}
	if((cur=ftell(fd)) != 5){
		printf("%s STDIO FTELL ERROR pos=%ld expect 5 FAIL\n",CORE_TYPE,cur);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FSEEK TO 5= %ld PASS \n",CORE_TYPE,cur);
	memset(arr_in,0,32);
	if((st=fread(arr_in,1,9,fd)) <=0){
		printf("%s STDIO FREAD ERROR st=%d errno=%d FAIL\n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}
	if((strncmp(arr_in,(char *)(&arr_out[cur]),9-cur)) != 0){
		printf("%s STDIO pos of start reading not 5 FAIL\n",CORE_TYPE);
		printf("st=%d  arr_in=%s\n arr_out=%s\n",st,arr_in,(char *)(&arr_out[cur]));
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO pos of start reading  5 PASS\n",CORE_TYPE);

	printf("%s STDIO FTELL = %ld\n",CORE_TYPE,ftell(fd));
	printf("%s STDIO FSEEK TO END+1\n",CORE_TYPE);
	if((st=fseek(fd,1,SEEK_END)) != 0){
		printf("%s STDIO fseek(fd) ERROR  st=%d errno=%d FAIL\n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}

	if((st=fgetpos(fd,&pos)) != 0){
		printf("%s STDIO FGETPOS ERROR st=%d errno=%d FAIL\n",CORE_TYPE,
				st,errno);
		FAIL=1;
		goto OUT;
	}else if(pos != 10){
		printf("%s STDIO FSEEK ERROR pos=%ld expect 10 FAIL\n",CORE_TYPE,pos);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FSEEK  pos=%d == 10 PASS\n",CORE_TYPE,(int)pos);

	printf("%s STDIO FSETPOS TO 0\n",CORE_TYPE);
	pos=0;
	if((st=fsetpos(fd,(&pos))) != 0){
		printf("%s STDIO fsetpos(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}

	if((st=fgetpos(fd,&pos)) != 0){
		printf("%s STDIO FGETPOS ERROR st=%d errno=%d FAIL\n",CORE_TYPE,
				st,errno);
		FAIL=1;
		goto OUT;
	}else if(pos != 0){
		printf("%s STDIO FSETPOS ERROR pos=%ld expect 0 FAIL\n",CORE_TYPE,pos);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FSETPOS  pos=%ld == 0 PASS\n",CORE_TYPE,pos);

	printf("%s STDIO FSETPOS TO 8\n",CORE_TYPE);
	pos=8;
	if((st=fsetpos(fd,&pos)) != 0){
		printf("%s STDIO fsetpos(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}

	if((st=fgetpos(fd,&pos)) != 0){
		printf("%s STDIO FGETPOS ERROR st=%d errno=%d FAIL\n",CORE_TYPE,
				st,errno);
		FAIL=1;
		goto OUT;
	}else if(pos != 8){
		printf("%s STDIO FSETPOS ERROR pos=%ld expect 8 FAIL\n",CORE_TYPE,pos);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO FSETPOS pos=%ld == 8 PASS\n",CORE_TYPE,pos);

	printf("%s STDIO REWIND TO 0\n",CORE_TYPE);
	rewind(fd);

	if((cur = ftell(fd)) != 0){
		printf("%s STDIO REWIND ERROR pos=%ld expect 0 FAIL\n",CORE_TYPE,cur);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO REWIND pos=%ld == 0 PASS\n",CORE_TYPE,cur);
	
	trg_hostSync(0x30);
	printf("%s STDIO FREAD START\n",CORE_TYPE);
	memset(arr_in,0,32);
	st=9999999;
	st=fread(arr_in,1,9,fd);
	if(st != 9){
		printf("%s STDIO FREAD ERROR st=%d errno=%d FAIL\n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}
	if((strncmp(arr_in,arr_out,9)) != 0){
		printf("%s STDIO pos of start reading not 0 FAIL\n",CORE_TYPE);
		printf("  arr_in=%s\n arr_out=%s\n",arr_in,arr_out);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO pos of start reading  0 PASS\n",CORE_TYPE);
	
	trg_hostSync(0x40);
	printf("%s STDIO fclose(fd) START\n",CORE_TYPE);
	st=1234567;
	st=fclose(fd);
	if(st != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d\n",CORE_TYPE,st);
	}

	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
