/*
    trg_stdio test stat, fstat
		int stat(const char *file_name, struct stat *buf);
		int fstat(int filedes, struct stat *buf);
		- int lstat(const char *file_name, struct stat *buf);   undefined reference to `lstat'
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	size_t stat_size, write_size;
	int fd, flag_d;
	char ch_flag_d[64];
	char arr_in[32], arr_out[32];
	struct stat *buf;
	struct stat *fbuf;
	struct stat *lbuf;
	const char *f_name = "F_000";
	int binary=0;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}
	errno=0;
	if(binary){
		flag_d = O_CREAT|O_TRUNC|O_RDWR|O_BINARY;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR|O_BINARY");
	}else{
		flag_d = O_CREAT|O_TRUNC|O_RDWR;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
	}
  
  trg_hostSync(0x10);
	printf("%s STDIO open START flags=%s %o\n",CORE_TYPE,ch_flag_d, flag_d);
	fd=open(f_name,flag_d,S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open ERROR  flags=%s errno=%d \n",CORE_TYPE,ch_flag_d,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open flags=%s PASS \n",CORE_TYPE,ch_flag_d);
	}
	printf("%s STDIO write START \n",CORE_TYPE);
	strcpy(arr_out,"1234567890123456");
	write_size=8;
	sz=write(fd, arr_out, write_size);
	if(sz != write_size){
		printf("%s STDIO write ERROR  sz=%d errno=%d \n",CORE_TYPE,sz,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO write PASS   sz=%d\n",CORE_TYPE,sz);
	}

	trg_hostSync( 0x20);

	buf = (struct stat *)malloc(sizeof(struct stat));
	memset((char *)buf, 0xF,sizeof(struct stat));
	fbuf = (struct stat *)malloc(sizeof(struct stat));
	memset((char *)fbuf, 0xE,sizeof(struct stat));
	lbuf = (struct stat *)malloc(sizeof(struct stat));
	memset((char *)lbuf, 0xF,sizeof(struct stat));

	printf("%s STDIO FSTAT(fd) START\n",CORE_TYPE);
	if((res = fstat(fd, fbuf))<0){
		printf("%s STDIO FSTAT ERROR  errno=%d FAIL\n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}
	sz=fbuf->st_size;

#if defined __NM__
	stat_size = (binary) ? ((sz + 3) / 4)  :  sz;
#else
	stat_size = sz;
#endif
	if(stat_size != write_size){
		printf("%s STDIO FSTAT st_size=%d expect %d FAIL\n",CORE_TYPE, 
				stat_size,write_size);
		FAIL=1;
		goto OUT;
	}	
	printf("%s STDIO FSTAT PASS st_size=%d = %d PASS\n",CORE_TYPE, 
			stat_size,write_size);
			
	trg_hostSync(0x30);
	printf("%s STDIO STAT(f_name) START\n",CORE_TYPE);
	if((res = stat(f_name, buf))<0){
		printf("%s STDIO STAT ERROR  errno=%d FAIL\n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}
	sz=buf->st_size;
#if defined __NM__
	stat_size = (binary) ? ((sz + 3) / 4)  :  sz;
#endif
	if(stat_size != write_size){
		printf("%s STDIO STAT st_size=%d expect %d FAIL\n",CORE_TYPE, 
				stat_size,write_size);
		FAIL=1;
		goto OUT;
	}	
	printf("%s STDIO STAT PASS st_size=%d = %d PASS\n",CORE_TYPE, 
			stat_size,write_size);

	trg_hostSync(0x40);
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	st=close(fd);
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
