/*
   trg_stdio test  
		int link(const char *oldpath, const char *newpath);  
		int unlink(const char *pathname); 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345, i;
	size_t sz=0, write_size, read_size, stat_size;
	char arr_in[32], arr_out[32];
	int fd, flag_d;
	int fr, flag_r;
	char ch_flag_d[64];
	char ch_flag_r[64];
	char *old = "F_OLD";
	char *new = "F_NEW";
	struct stat *buf;
	int binary=0;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}

	if(binary){
		flag_d = O_CREAT|O_TRUNC|O_RDWR|O_BINARY;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR|O_BINARY");
		flag_r = O_RDONLY|O_BINARY;
		strcpy(ch_flag_r,"O_RDONLY|O_BINARY");
	}else{
		flag_d = O_CREAT|O_TRUNC|O_RDWR;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
		flag_r = O_RDONLY;
		strcpy(ch_flag_r,"O_RDONLY|");
	}
	
	buf = (struct stat *)malloc(sizeof(struct stat));
	memset((char *)buf, 0xF,sizeof(struct stat));
	
	trg_hostSync(0x10);
	printf("%s STDIO remove START file %s\n",CORE_TYPE,new);
	remove(new);
	printf("%s STDIO open START file %s\n",CORE_TYPE,old);
	fd=open(old,flag_d,S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open file %s PASS \n",CORE_TYPE,old);
	}
	printf("%s STDIO WRITE START\n",CORE_TYPE);
	write_size=6;
#if defined __NM__
	if(binary){ // O_BINARY
		for( i=0; i<write_size; i++){ ((unsigned int *)arr_out)[i]=0x77FFFF0+i; }
		st=write(fd, arr_out,sizeof(int)*write_size);
	}else
#endif
	{ // O_TEXT
		strcpy(arr_out,"ABCDEFGHI");
		st=write(fd, arr_out,sizeof(char)*write_size);
	}
	if(st != write_size){
		printf("%s STDIO WRITE ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO WRITE PASS st=%d \n",CORE_TYPE,st);
	}
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	st=close(fd);
	if(st != 0){
		printf("%s STDIO close(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fd) PASS \n",CORE_TYPE);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO RENAME BY LINK, UNLINK\n",CORE_TYPE);
	printf("%s STDIO LINK START old=%s to new=%s\n",CORE_TYPE,old,new);
//	res = rename(old,new);
	printf("%s STDIO LINK\n",CORE_TYPE); res=9999;
	if((res=link(old,new)) != 0){
		printf("%s STDIO LINK ERROR res=%d errno=%d\n",CORE_TYPE,res,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO CHECK LINK BY STAT(NEW) \n",CORE_TYPE);
	if((res = stat(new, buf))<0){
		printf("%s STDIO STAT ERROR  errno=%d FAIL\n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}
	sz=buf->st_size;
#if defined __NM__
	stat_size = (binary) ? ((sz + 3) / 4)  :  sz;
#else
	stat_size = sz;
#endif
	if(stat_size != write_size){
		printf("%s STDIO STAT st_size=%d expect %d FAIL\n",CORE_TYPE, stat_size,write_size);
		FAIL=1;
		goto OUT;
	}	
	printf("%s STDIO LINK PASS st_size=%d = %d PASS\n",CORE_TYPE, stat_size,write_size);
	
	printf("%s STDIO UNLINK\n",CORE_TYPE); 
	res=77777;
	if((res=unlink(old)) != 0){
		printf("%s STDIO UNLINK res=%d errno=%d\n",CORE_TYPE,res,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO CHECK UNLINK BY STAT(OLD) \n",CORE_TYPE);
	if((res = stat(old, buf)) == 0){
		printf("%s STDIO UNLINK ERROR  STAT RESULT 0 FAIL\n",CORE_TYPE);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO UNLINK PASS\n",CORE_TYPE);
	trg_hostSync(0x30);
	printf("%s STDIO OPEN START file %s\n",CORE_TYPE,new);
	fr=open(new,flag_r);
	if(fr <0){
		printf("%s STDIO open ERROR  flags=%s errno=%d FAIL\n",CORE_TYPE,
				ch_flag_r,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open file=%s PASS\n",CORE_TYPE,new);
	}
	printf("%s STDIO CHECK RENAME BY READ START\n",CORE_TYPE);
	memset(arr_in,0,32);
	read_size=9;
#if defined __NM__
	if(binary){
		st=read(fr,arr_in,sizeof(int)*read_size);
	}else
#endif
	{
		st=read(fr,arr_in,sizeof(char)*read_size);
	}
	if(st != write_size){
		printf("%s STDIO READ ERROR st=%d errno=%s FAIL\n",CORE_TYPE,st,errno);
		FAIL=1;
	}	
	printf("%s STDIO READ PASS st=%d PASS\n",CORE_TYPE,st);
	
	/////////////////////////////////////////////////
#if defined __NM__
	if(binary){ // O_BINARY
		for( i=0; i<write_size; i++){ 
			if(arr_out[i] != arr_in[i]) break;
		}
		if( i != write_size) {
			printf("%s RENAME BY LINK, UNLINK FAIL\n",CORE_TYPE);
			FAIL=1;
			int j=0;
			for( i=0; i+j < write_size; i+=8){
				for( j=0;j<8; j++)
					printf("%x %x?%x  ",i+j, arr_out[i+j],arr_in[i+j]); 
				printf("\n");
			}
		}
	}else
#endif
	{ // O_TEXT
		if((st=strncmp(arr_in,arr_out,write_size)) != 0){
			printf("%s RENAME BY LINK, UNLINK FAIL\n",CORE_TYPE);
			printf("  arr_in=%s\n arr_out=%s\n",arr_in,arr_out);
			FAIL=1;
		}
	}
	printf("%s STDIO RENAME BY LINK, UNLINK PASS\n",CORE_TYPE);
	
	trg_hostSync(0x40);
	printf("%s STDIO close(fr) START\n",CORE_TYPE);
	st=close(fr);
	if(st != 0){
		printf("%s STDIO close(fr) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fr) PASS  st=%d\n",CORE_TYPE,st);
	}
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
