/*
   trg_stdio test  isatty
	int isatty(int fd);  
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	int fd, flag_d;
	char ch_flag_d[64];
	
	flag_d = O_CREAT|O_TRUNC|O_RDWR;
	strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
	
	trg_hostSync(0x10);
	printf("%s STDIO open START flags=%s %o\n",CORE_TYPE,ch_flag_d, flag_d);
	fd=open("F_000",flag_d,S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open ERROR  flags=%s errno=%d \n",CORE_TYPE,ch_flag_d,errno);
		FAIL=1;
		goto OUT;
	}
	printf("%s STDIO open flags=%s PASS \n",CORE_TYPE,ch_flag_d);
	
	trg_hostSync( 0x20);
	printf("%s STDIO ISATTY START %d not tty\n",CORE_TYPE,fd);
	if((res=isatty(fd)) != 0){
		printf("%s STDIO ISATTY res=%d expect 0 FAIL\n",CORE_TYPE,res);
		FAIL=1;
	}
	printf("%s STDIO ISATTY %d is not tty PASS \n",CORE_TYPE,fd);
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	if((st=close(fd)) != 0){
		printf("%s STDIO close(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fd) PASS  st=%d\n",CORE_TYPE,st);
	}
	if(FAIL) goto OUT;
	
	if((res=isatty(fd)) != 0){
		printf("%s STDIO ISATTY not existed file res=%d expect 0 FAIL\n",CORE_TYPE,res);
		FAIL=1;
	}
	printf("%s STDIO ISATTY not existed file PASS \n",CORE_TYPE,fd);
	
	trg_hostSync(0x30);
	printf("%s STDIO ISATTY START  fd==0 is tty \n",CORE_TYPE);
	fd = 0;
	if((res=isatty(fd)) != 1){
		printf("%s STDIO ISATTY fd=%d res=%d expect 1 errno=%d FAIL\n",CORE_TYPE,fd,res,errno);
		FAIL=1;
	}else
		printf("%s STDIO ISATTY res=%d  %d is tty PASS \n",CORE_TYPE,res,fd);
	
	printf("%s STDIO ISATTY START  fd==1 is tty \n",CORE_TYPE);
	fd = 1;
	if((res=isatty(fd)) != 1){
		printf("%s STDIO ISATTY fd=%d res=%d expect 1 errno=%d FAIL\n",CORE_TYPE,fd,res,errno);
		FAIL=1;
	}else
		printf("%s STDIO ISATTY res=%d  %d is tty PASS \n",CORE_TYPE,res,fd);
	
	printf("%s STDIO ISATTY START  fd==2 is tty \n",CORE_TYPE);
	fd = 2;
	if((res=isatty(fd)) != 1){
		printf("%s STDIO ISATTY fd=%d res=%d expect 1 errno=%d FAIL\n",CORE_TYPE,fd,res,errno);
		FAIL=1;
	}else
		printf("%s STDIO ISATTY res=%d  %d is tty PASS \n",CORE_TYPE,res,fd);
		
	trg_hostSync(0x40);
	trg_hostSync(0x5);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
}
