/*
   trg_stdio printf, sprintf, fprintf
   Binary stream
*/

#include <stddef.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int res, i;
	char *F1 = "F_WITH_MODE";
	FILE *fd = NULL;
	FILE *fr = NULL;
	char out[64];
	char arr[64];
	char *mode[]= {	"w+",       // for arm & nmc
								"w+b"};  // only for arm
	char *rmode[]= {	"r",     // for arm & nmc
								"rb"}; // only for arm
	int cnt_tests = 2;  // this is for arm

#if defined __NM__
	cnt_tests = 1; // there is no print for binary file on nmc
#endif
	trg_hostSync(0x10);
	printf("%s STDIO **************** START file %s\n",CORE_TYPE,F1);
	printf("%s STDIO ********************* \n",CORE_TYPE);
	
	trg_hostSync(0x20);
	printf("%s STDIO TEST SPRINTF\n",CORE_TYPE);
	sprintf(out,"%s STDIO *********  %s\n",CORE_TYPE,"SPRINTF");
	printf("%s",out);
	
	trg_hostSync( 0x30);
	for(i=0; i<cnt_tests; i++){
		printf("%s STDIO   **TEST FPRINTF**    mode=%s\n",CORE_TYPE,mode[i]);
		if((fd=fopen("F_0",mode[i])) == NULL){
			printf("%s STDIO fopen ERROR  errno=%d \n",CORE_TYPE,errno);
			FAIL=1;
			goto OUT;
		}
		printf("%s STDIO fopen F_0 mode=%s PASS \n",CORE_TYPE,mode[i]);
		strcpy(arr,"%s STDIO *********  FPRINTF");
		fprintf(fd,"%s",arr);
		fflush(fd);
		rewind(fd);
		memset(out,0,64);
		if((res=fread(out,1,64,fd)) <= 0){
			printf("%s STDIO fread ERROR res=%d  errno=%d \n",CORE_TYPE,res,errno);
			FAIL=1;
			goto OUT;
		}
		if((strcmp(out, arr)) != 0){
			printf("%s STDIO FPRINTF ERROR: Not eqaul out and arr_in. FAIL\n",CORE_TYPE);
			FAIL=1;
		}else{
			printf("%s STDIO FPRINTF   PASS\n",CORE_TYPE);
		}
		printf("out= %sWW\narr= %sWW\n",CORE_TYPE,out,arr);
		fclose(fd);
		
		printf("%s STDIO  PUTCHAR START\n",CORE_TYPE);
		for(int k=0; k<res; k++){
			putchar(out[k]);
		}
		printf("\n%s STDIO  PUTCHAR END\n",CORE_TYPE);
	}
	trg_hostSync(0x40);
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
	
    return 0;
}
