/*
   nmc_stdio  fopens and fclose
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	FILE *fd = NULL;
	FILE *rf = NULL;
	char mode[8];
	char rmode[8];
	int binary=0;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d  \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE  \n",CORE_TYPE);
	}
	errno=0;
	if(binary){ // O_BINARY
		strcpy(mode,"w+b"); //b");
		strcpy(rmode,"rb");
	}else{ // O_TEXT
		strcpy(mode,"w+");
		strcpy(rmode,"r");
	}

	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s \n",CORE_TYPE,mode);
	fd=fopen("F_0",mode);
	if(fd == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d  \n",CORE_TYPE,mode,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen mode=%s PASS  \n",CORE_TYPE,mode);
	}
	trg_hostSync( 0x20);
	printf("%s STDIO fopen START rmode=%s \n",CORE_TYPE,rmode);
	rf=fopen("F_0",rmode);
	if(rf == NULL){
		printf("%s STDIO fopen ERROR  rmode=%s errno=%d  \n",CORE_TYPE,rmode,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen rmode=%s PASS  \n",CORE_TYPE,rmode);
	}
	trg_hostSync( 0x30);
	printf("%s STDIO fclose(fd) START \n",CORE_TYPE);
	st=1234567;
	st=fclose(fd);
	if(st != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d \n",CORE_TYPE,st);
	}
	trg_hostSync(0x40);
	printf("%s STDIO fclose(rf) START \n",CORE_TYPE);
	st=1234567;
	st=fclose(rf);
	if(st != 0){
		printf("%s STDIO fclose(rf) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(rf) PASS  st=%d \n",CORE_TYPE,st);
	}

	trg_hostSync(0x5);
	if(FAIL) printf("%s STDIO TEST FAIL \n",CORE_TYPE);
	else printf("%s STDIO TEST PASS \n",CORE_TYPE);
	
    return 0;
}
