/*
    nmc_stdio test	open close
							write, read
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345, i;
	size_t sz=9, count;
	int fd = -1, flag_d;
	int fr = -1, flag_r;
	char ch_flag_d[64];
	char ch_flag_r[64];
	char arr_in[64], arr_out[64];
	char *F1 = "F_WITH_MODE";
	int binary=0;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}
	errno=0;
	sz=10;
	if(binary){ // O_BINARY
		flag_d = O_CREAT|O_TRUNC|O_RDWR|O_BINARY;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR|O_BINARY");
		flag_r = O_RDONLY|O_BINARY;
		strcpy(ch_flag_r,"O_RDONLY|O_BINARY");
		count=sz; //  words
	}else{ // O_TEXT
//	flag_d = O_CREAT|O_TRUNC|O_RDWR|O_TEXT;
		flag_d = O_CREAT|O_TRUNC|O_RDWR;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
		flag_r = O_RDONLY; 
		strcpy(ch_flag_r,"O_RDONLY"); 
		count=sz; //  bytes
	}
	trg_hostSync(0x10);
	printf("%s STDIO open START with flag %s\n",CORE_TYPE,ch_flag_d);
	fd=open(F1, flag_d, S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open with mode ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO open with mode file %s PASS \n",CORE_TYPE,F1);
	}
	printf("%s STDIO WRITE START\n",CORE_TYPE);
	printf("%s STDIO WRITE  int=%d char=%d long=%d\n",CORE_TYPE,
			sizeof(int),sizeof(char),sizeof(long int));
	st=9999999;
#if defined __NM__
	if(binary){ // O_BINARY
		for( i=0; i<sz; i++){ ((unsigned int *)arr_out)[i]=0x77FFFF0+i; }
		st=write(fd, arr_out,sizeof(int)*count);
	}else
#endif
	{ // O_TEXT
		strcpy(arr_out,"1234567890123456");
		st=write(fd, arr_out,sizeof(char)*count);
	}
	if(st != count){
		printf("%s STDIO WRITE ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO WRITE PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	st=1234567;
	if((st=close(fd)) != 0){
		printf("%s STDIO close(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PAASS  st=%d\n",CORE_TYPE,st);
	}
	
	trg_hostSync(0x20);
	printf("%s STDIO open START with flag %s\n",CORE_TYPE,ch_flag_r);
	fr=open(F1,flag_r);
	if(fr < 0){
		printf("%s STDIO open ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen  PASS \n",CORE_TYPE);
	}
	printf("%s STDIO READ START\n",CORE_TYPE);
#if defined __NM__
	if(binary){
		st=read(fr,arr_in,sizeof(int)*count);
	}else
#endif
	{
		st=read(fr,arr_in,sizeof(char)*count);
		arr_in[st]=0;
	}
	if(st>0){
		printf("%s STDIO READ PASS st=%d arr_in=%s\n",CORE_TYPE,st,arr_in);
	}else{		
		printf("%s STDIO READ ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}
	printf("%s STDIO close(fr) START\n",CORE_TYPE);
	st=1234567;
	if((st=close(fr)) != 0){
		printf("%s STDIO close(fr) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fr) PASS  st=%d\n",CORE_TYPE,st);
	}
	trg_hostSync(0x30);
	st=1234567;
#if defined __NM__
	if(binary){ // O_BINARY
		for( i=0; i<count; i++){ 
			if(arr_out[i] != arr_in[i]) break;
		}
		if( i == count) 
			printf("%s O_BINARY Arrays arr_in and arr_out  are equal. PASS\n",CORE_TYPE);
		else{
			printf("%s O_BINARY%d Arrays arr_in and arr_out  are different. FAIL\n",CORE_TYPE,i);
			FAIL=1;
			int j=0;
			for( i=0; i+j < count; i+=8){
				for( j=0;j<8; j++)
					printf("%x %x?%x  ",i+j, arr_out[i+j],arr_in[i+j]); 
				printf("\n");
			}
		}
	}else
#endif
	{ // O_TEXT
		if((st=strncmp(arr_in,arr_out,count)) == 0)
			printf("%s O_TEXT Arrays arr_in and arr_out  are equal. PASS\n",CORE_TYPE);
		else{
			printf("%s O_TEXT Arrays arr_in and arr_out  are different. FAIL\n",CORE_TYPE);
			FAIL=1;
		}
	}
	trg_hostSync(0x40);

	trg_hostSync(0x5);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
	
}
