/*
    nmc_stdio test	open close
							write, read
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345, off;
	int res=345, i;
	size_t sz=9, count;
	int fd = -1, flag_d;
	int fr = -1, flag_r;
	char ch_flag_d[64];
	char ch_flag_r[64];
	char arr_in[64], arr_out[64];
	char *F1 = "F_WITH_MODE";
	int binary=1;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}
	errno=0;
	sz=10;
	if(binary){ // O_BINARY
		flag_d = O_CREAT|O_TRUNC|O_RDWR|O_BINARY;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR|O_BINARY");
		flag_r = O_RDONLY|O_BINARY;
		strcpy(ch_flag_r,"O_RDONLY|O_BINARY");
		count=sz; //  words
	}else{ // O_TEXT
//	flag_d = O_CREAT|O_TRUNC|O_RDWR|O_TEXT;
		flag_d = O_CREAT|O_TRUNC|O_RDWR;
		strcpy(ch_flag_d,"O_CREAT|O_TRUNC|O_RDWR");
		flag_r = O_RDONLY; 
		strcpy(ch_flag_r,"O_RDONLY"); 
		count=sz; //  bytes
	}
	trg_hostSync(0x10);
	printf("%s STDIO open START with flag %s\n",CORE_TYPE,ch_flag_d);
	fd=open(F1, flag_d, S_IREAD | S_IWRITE);
	if(fd <0){
		printf("%s STDIO open with mode ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO open with mode file %s PASS \n",CORE_TYPE,F1);
	}
	
	printf("%s STDIO WRITE START\n",CORE_TYPE);
	printf("%s STDIO WRITE  int=%d char=%d long=%d\n",CORE_TYPE,
			sizeof(int),sizeof(char),sizeof(long int));
	st=9999999;
#if defined __NM__
	if(binary){ // O_BINARY
		for( i=0; i<sz+5; i++){ ((unsigned int *)arr_out)[i]=0x77FFFF0+i; }
		st=write(fd, &(arr_out[1]),sizeof(int)*count);
	}else
#endif
	{ // O_TEXT
		strcpy(arr_out,"1234567890123456");
		st=write(fd, &(arr_out[1]),sizeof(char)*count);  //arr_out  x234-5678-90xx
	}

	if(st != count){
		printf("%s STDIO WRITE ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO WRITE PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
		printf("%s STDIO LSEEK TO 0\n",CORE_TYPE);
		if((off=lseek(fd,0,SEEK_SET)) != 0){  
		printf("%s STDIO LSEEK ERROR  off=%d errno=%d \n",CORE_TYPE,off,errno);
		FAIL=1;
	}else{
		printf("%s STDIO LSEEK PASS off=%d errno=%d\n",CORE_TYPE,off,errno);
	}
#if defined __NM__
	if(binary){
		st=read(fd,&(arr_in),sizeof(int)*(count+2));  // 1234-567-89
	}else
#endif
	{                                                                   // 0123-456-7890
		st=read(fd,&(arr_in),sizeof(char)*(count+2));  //arr_in  2345-6789-012
	}                                                                              //            0123-4567-890
	if(st>0){
	printf("st=%d arr_in [0]=%x [1]=%x [2]=%x [3]=%x [7]=%x [8]=%x [9]=%x [10]=%x [11]=%x\n",
			st,arr_in[0], arr_in[1], arr_in[2], arr_in[3], arr_in[7], arr_in[8], arr_in[9], arr_in[10], arr_in[11]);
	}
	printf("%s STDIO close(fd) START\n",CORE_TYPE);
	st=1234567;
	if((st=close(fd)) != 0){
		printf("%s STDIO close(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PAASS  st=%d\n",CORE_TYPE,st);
	}
	
	trg_hostSync(0x20);
	printf("%s STDIO open START with flag %s\n",CORE_TYPE,ch_flag_r);
	fr=open(F1,flag_r);
	if(fr < 0){
		printf("%s STDIO open ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen  PASS \n",CORE_TYPE);
	}
	printf("%s STDIO LSEEK TO 3\n",CORE_TYPE);
		if((off=lseek(fr,3,SEEK_SET)) != 3){  // 234->5678-90
		printf("%s STDIO LSEEK ERROR  off=%d errno=%d \n",CORE_TYPE,off,errno);
		FAIL=1;
	}else{
		printf("%s STDIO LSEEK PASS off=%d errno=%d\n",CORE_TYPE,off,errno);
	}
	printf("%s STDIO READ START\n",CORE_TYPE);
	memset(arr_in,0,32);
#if defined __NM__
	if(binary){
		st=read(fr,&(arr_in[2]),sizeof(int)*count);
	}else
#endif
	{
		st=read(fr,&(arr_in[2]),sizeof(char)*count);  //arr_in  xx23-4567-890x
//		arr_in[st]=0;
	}
	if(st>0){
		printf("%s STDIO READ PASS st=%d arr_in=%s\n",CORE_TYPE,st,&(arr_in[2]));
	}else{		
		printf("%s STDIO READ ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}
	printf("%s STDIO close(fr) START\n",CORE_TYPE);
	st=1234567;
	if((st=close(fr)) != 0){
		printf("%s STDIO close(fr) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(fr) PASS  st=%d\n",CORE_TYPE,st);
	}
	trg_hostSync(0x30);
	st=1234567;
#if defined __NM__
	if(binary){ // O_BINARY
	printf("arr_out[i+off+1] != arr_in[i+2]\n");
		for( i=0; i<(count-off); i++){ 
		printf("arr_out[%d]=%x ? arr_in[%d]=%x \n",
				i+off+1,arr_out[i+off+1],i+2,arr_in[i+2]);
			if(arr_out[i+off+1] != arr_in[i+2]) break;
		}
		if( i == (count-off)) 
			printf("%s O_BINARY Arrays arr_in and arr_out  are equal. PASS\n",CORE_TYPE);
		else{
			printf("%s O_BINARY%d Arrays arr_in and arr_out  are different. FAIL\n",CORE_TYPE,i);
			FAIL=1;
			int j=0;
			for( i=0; i+j < count; i+=8){
				for( j=0;j<8; j++)
					printf("%x %x?%x  ",i+j, arr_out[i+j],arr_in[i+j]); 
				printf("\n");
			}
		}
	}else
#endif
	{ // O_TEXT
		if((st=strncmp(&(arr_out[1+off]),&(arr_in[2]),count-off)) == 0)
			printf("%s O_TEXT Arrays arr_in and arr_out  are equal. PASS\n",CORE_TYPE);
		else{
			printf("%s O_TEXT Arrays arr_in and arr_out  are different. FAIL\n",CORE_TYPE);
			FAIL=1;
		}
	}
	trg_hostSync(0x40);
printf("arr_out [1]=%x [2]=%x [3]=%x [4]=%x [8]=%x [9]=%x\n",
			arr_out[1], arr_out[2], arr_out[3], arr_out[4],arr_out[8], arr_out[9]);
printf("arr_in [2]=%x [3]=%x [4]=%x [7]=%x [8]=%x [9]=%x [10]=%x\n",
			arr_in[2], arr_in[3], arr_in[4], arr_in[7], arr_in[8], arr_in[9], arr_in[10]);
	trg_hostSync(0x5);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
	
}
