/*
    nmc_stdio test	fopen fclose
							fwrite, fread
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL = 0;
	int st=345;
	int res=345;
	size_t sz=0;
	FILE *fd = NULL;
	FILE *fr = NULL;
	char mode[8];
	char rmode[8];
	char arr_in[64];
	char arr_out[64];
	int binary=1;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d  \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE  \n",CORE_TYPE);
	}
	errno=0;
	sz=9;
	if(binary){
		strcpy(mode,"w+b");
		strcpy(rmode,"rb");
	}else{
		strcpy(mode,"w+");
		strcpy(rmode,"r");
	}
	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s \n",CORE_TYPE,mode);
	fd=fopen("F_0",mode);
	if(fd == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d  \n",CORE_TYPE,mode,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen mode=%s PASS  \n",CORE_TYPE,mode);
	}

	printf("%s STDIO FWRITE START \n",CORE_TYPE);
	st=9999999;
#if defined __NM__
	if(binary){ // O_BINARY
		for(int i=0; i<sz+5; i++){ ((unsigned int *)arr_out)[i]=0x77FFFF0+i; }
		st=fwrite( &(arr_out[1]), 1, sizeof(int)*sz, fd);
	}else
#endif
	{ // O_TEXT
		strcpy(arr_out,"1234567890123456");
		st=fwrite( &(arr_out[1]), 1, sizeof(char)*sz, fd);  //arr_out  x234-5678-90xx
	}
	if(st != sz){
		printf("%s STDIO FWRITE ERROR st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FWRITE PASS st=%d errno=%d \n",CORE_TYPE,st,errno);
	}

	printf("%s STDIO fclose(fd) START \n",CORE_TYPE);
	st=1234567;
	if((st=fclose(fd)) != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d \n",CORE_TYPE,st);
	}

	trg_hostSync(0x20);
	printf("%s STDIO fopen START mode=%s \n",CORE_TYPE,rmode);
	fr=fopen("F_0",rmode);
	if(fr == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d  \n",CORE_TYPE,rmode,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen mode=%s PASS  \n",CORE_TYPE,rmode);
	}
	
	printf("%s STDIO FREAD START \n",CORE_TYPE);
	memset(arr_in,0,64);
#if defined __NM__
	if(binary){
		st=fread(&(arr_in[2]), 1, sizeof(int)*sz, fr);
	}else
#endif
	{
		st=fread(&(arr_in[2]), 1, sizeof(char)*sz, fr);  //arr_in  xx23-4567-890x
	}
	if(st >0){
		printf("%s STDIO FREAD PASS st=%d arr_in=%s \n",CORE_TYPE,st,&(arr_in[2]));
	}else{		
		printf("%s STDIO FREAD ERROR st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}
	printf("%s STDIO fclose(fr) START \n",CORE_TYPE);
	st=1234567;
	if((st=fclose(fr)) != 0){
		printf("%s STDIO fclose(fr) ERROR  st=%d errno=%d  \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fr) PASS  st=%d \n",CORE_TYPE,st);
	}
	trg_hostSync(0x30);
	st=1234567;
	if((st=strncmp(&(arr_in[2]),&(arr_out[1]),9)) == 0){
		printf("Arrays arr_in and arr_out  are equal. PASS \n");
	}else{
		printf("Arrays arr_in and arr_out  are different. FAIL \n");
		FAIL = 1;
	}
	trg_hostSync(0x40);
printf("arr_out [1]=%x [2]=%x [3]=%x [4]=%x [8]=%x [9]=%x \n",
			arr_out[1], arr_out[2], arr_out[3], arr_out[4],arr_out[8], arr_out[9]);
printf("arr_in [2]=%x [3]=%x [4]=%x [7]=%x [8]=%x [9]=%x [10]=%x \n",
			arr_in[2], arr_in[3], arr_in[4], arr_in[7], arr_in[8], arr_in[9], arr_in[10]);
	trg_hostSync(0x5);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL \n",CORE_TYPE);
	else printf("%s STDIO TEST PASS \n",CORE_TYPE);
	
    return 0;
	
}
