/*
    %s_stdio test fopen, open 
							fwrite, write
							fseek, lseek
							fread, read
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	int res=345;
	size_t sz=0;
	FILE *fd = NULL;
	int findx=0;
	char mode[8];
	char ch_flag[32];
	int flag;
	char f_arr_in[32], f_arr_out[32];
	char arr_in[32], arr_out[32];
	int binary;
	char *f_arg = "BINARY_TEST";
	
	if((binary=open(f_arg, O_RDONLY))>0 ){
		printf("%s STDIO ------------- TEST WITH BINARY FILE %d \n",CORE_TYPE,binary);
		close(binary);
	}else{
		binary=0;
		printf("%s STDIO ------------- TEST WITH TEXT FILE \n",CORE_TYPE);
	}
	errno=0;
	if(binary)
			strcpy(mode,"w+b");
	else
			strcpy(mode,"w+");
	
	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode);
	fd=fopen("F_0",mode);
	if(fd == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d \n",CORE_TYPE,mode,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode);
	}
	strcpy(ch_flag,"O_RDWR|O_TRUNC|O_CREAT");
	flag = O_RDWR|O_CREAT;
	printf("%s STDIO open START flag=%s\n",CORE_TYPE,ch_flag);
	findx=open("F_1",flag,S_IREAD | S_IWRITE);
	if(findx < 0){
		printf("%s STDIO open ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO open PASS flag=%s\n",CORE_TYPE,ch_flag);
	}

	trg_hostSync( 0x20);
	printf("%s STDIO FWRITE START\n",CORE_TYPE);
	strcpy(f_arr_out,"1234567890123456");
	st=123;
	st=fwrite(f_arr_out,1,15,fd);
	if(st != 15){
		printf("%s STDIO FWRITE ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO FWRITE PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO ftell=%d\n",CORE_TYPE,ftell(fd));
	printf("%s STDIO WRITE START\n",CORE_TYPE);
	strcpy(arr_out,"ABCDEFGHI");
	st=write(findx, arr_out, 9);
	if(st != 9){
		printf("%s STDIO WRITE ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
		goto OUT;
	}else{
		printf("%s STDIO WRITE PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	trg_hostSync(0x30);
	printf("%s STDIO SETTING POSITION START\n",CORE_TYPE);
	printf("%s STDIO FSEEK TO 5\n",CORE_TYPE);
	st=1234567;
	if((st=fseek(fd,5,SEEK_SET)) != 0){
		printf("%s STDIO FSEEK ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FSEEK PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO LSEEK TO 3\n",CORE_TYPE);
	st=1234567;
	if((st=lseek(findx,3,SEEK_SET)) != 3){
		printf("%s STDIO LSEEK ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO LSEEK PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO FREAD START\n",CORE_TYPE);
	if((st=fread(f_arr_in,1,9,fd)) >0){
		f_arr_in[st]=0;
		printf("%s STDIO FREAD AFTER PASS st=%d arr_in=%s\n",CORE_TYPE,st,f_arr_in);
	}else{		
		printf("%s STDIO FREAD ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}
	printf("%s STDIO READ START\n",CORE_TYPE);
	if((st=read(findx, arr_in,9)) >0){
		arr_in[st]=0;
		printf("%s STDIO FREAD AFTER PASS st=%d arr_in=%s\n",CORE_TYPE,st,arr_in);
	}else{		
		printf("%s STDIO FREAD ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}	
	trg_hostSync(0x40);
	printf("%s STDIO fclose(fd) START\n",CORE_TYPE);
	st=1234567;
	if((st=fclose(fd)) != 0){
		printf("%s STDIO fclose(fd) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd) PASS  st=%d\n",CORE_TYPE,st);
	}
	printf("%s STDIO close(findx) START\n",CORE_TYPE);
	st=1234567;
	if((st=close(findx)) != 0){
		printf("%s STDIO close(findx) ERROR  st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO close(findx) PASS  st=%d\n",CORE_TYPE,st);
	}

	printf("%s STDIO check result\n",CORE_TYPE);
	st=1234567;
	if((st=strncmp(f_arr_in, (char *)(&f_arr_out[5]) ,9)) == 0)
		printf("%s FSEEK PASS\n",CORE_TYPE);
	else{
		printf("%s FSEEK FAIL f_arr_in=%s  &f_arr_out[5]=%s\n",CORE_TYPE,
				f_arr_in, (char *)(&f_arr_out[5]));
		FAIL=1;
	}
	st=1234567;
	if((st=strncmp(arr_in, (char *)(&arr_out[3]) ,9-3)) == 0)
		printf("%s LSEEK PASS\n",CORE_TYPE);
	else{
		printf("%s LSEEK FAIL arr_in=%s &arr_out[3]=%s\n",CORE_TYPE,
				arr_in, (char *)(&arr_out[3]));
		FAIL=1;
	}
	trg_hostSync(0x50);
OUT:
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
    return 0;
	
}
