/*
     trg_stdio test
		int fputc(int c, FILE *stream);
		int fputs(const char *s, FILE *stream);
		int putc(int c, FILE *stream);
*/

#include <stddef.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include <trg_common.h>

int main ()
{
	int FAIL=0;
	int st=345;
	FILE *fd_1 = NULL;
	FILE *fd_2 = NULL;
	char mode_1[8];
	char mode_2[8];
	char arr_in[32], arr_out[32];
	
	strcpy(mode_1,"w+");
	strcpy(mode_2,"w+b");

	trg_hostSync(0x10);
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode_1);
	fd_1=fopen("F_1",mode_1);
	if(fd_1 == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d \n",CORE_TYPE,mode_1,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode_1);
	}
	printf("%s STDIO fopen START mode=%s\n",CORE_TYPE,mode_2);
	fd_2=fopen("F_2",mode_2);
	if(fd_2 == NULL){
		printf("%s STDIO fopen ERROR  mode=%s errno=%d \n",CORE_TYPE,mode_2,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fopen mode=%s PASS \n",CORE_TYPE,mode_2);
	}

	trg_hostSync( 0x20);
	
	printf("%s STDIO FPUTS START\n",CORE_TYPE);
//		int fputc(int c, FILE *stream);
//		int fputs(const char *s, FILE *stream);
//		int putc(int c, FILE *stream);
	strcpy(arr_out,"***fputs***\n");
	printf("%s STDIO FPUTS to fd_1  arr_in=%s\n",CORE_TYPE,arr_out);
	st=fputs(arr_out,fd_1);
	if(st < 0){
		printf("%s STDIO FPUTS ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FPUTS PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO FPUTC to fd_1  r\n",CORE_TYPE);
	st=fputc('r',fd_1);
	if(st != 'r'){
		printf("%s STDIO FPUTC ERROR  st=0x%x  errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FPUTC PASS st=%c errno=%d\n",CORE_TYPE,st,errno);
	}
	trg_hostSync(0x30);
	printf("%s STDIO FPUTS to fd_2  arr_in=%s\n",CORE_TYPE,arr_out);
	st=fputs(arr_out,fd_2);
	if(st < 0){
		printf("%s STDIO FPUTS ERROR st=%d errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO FPUTS PASS st=%d errno=%d\n",CORE_TYPE,st,errno);
	}
	printf("%s STDIO PUTC to fd_2 r\n",CORE_TYPE);
	st=putc('r',fd_2);
	if(st != 'r'){
		printf("%s STDIO PUTC ERROR  st=0x%x  errno=%d \n",CORE_TYPE,st,errno);
		FAIL=1;
	}else{
		printf("%s STDIO PUTC PASS st=%c errno=%d\n",CORE_TYPE,st,errno);
	}
	trg_hostSync(0x40);
	printf("%s STDIO fclose(fd_1) START\n",CORE_TYPE);
	if((st=fclose(fd_1)) != 0){
		printf("%s STDIO fclose(fd_1) ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd_1) PASS \n",CORE_TYPE);
	}
	printf("%s STDIO fclose(fd_2) START\n",CORE_TYPE);
	if((st=fclose(fd_2)) != 0){
		printf("%s STDIO fclose(fd_2) ERROR  errno=%d \n",CORE_TYPE,errno);
		FAIL=1;
	}else{
		printf("%s STDIO fclose(fd_2) PASS \n",CORE_TYPE);
	}

	trg_hostSync(0x5);
	if(FAIL) printf("%s STDIO TEST FAIL\n",CORE_TYPE);
	else printf("%s STDIO TEST PASS\n",CORE_TYPE);
	
    return 0;
}
