//////////////////////////////////////////////////////////////////
//								//
//		io_service library.  Linux  version		//
//	Tool for NM and ARM programs to access host devices	//
//	Description the user interface of host-part		//
//								//
//////////////////////////////////////////////////////////////////

#ifndef __IO_HOST_LIN_H__
#define __IO_HOST_LIN_H__

#include <iostream>

#if 1

#ifndef O_BINARY
#define O_BINARY	0x10000
#endif

#ifndef O_TEXT
#define O_TEXT		0x20000
#endif

#endif

#define SEMIHOST_MAX_FILE	200
///////////////////////////////////////////////////////////
#define IO_SERV_DBG	0
#define STDIO_DBG	0
#define STDIO_TRACE 0
//////////////////////////////////////////////////////////////
typedef struct {
	int fd;
	int TextMode;
} SemihostFile_t;

typedef struct {
	int function;
	int err;
} io_service_fail_t;

struct IO_Service {
	PL_Access	*a;

	PL_Addr		datSecAddr;
	PL_Addr		bssSecAddr;
	PL_Addr		datSecSize;
	PL_Addr		bssSecSize;

	PL_Word		RPC_busy;
	PL_Word		*bsStatus;
	PL_Word		*bsBuf;

	void		*ll_ops;

	void		readStatus();
	void		writeBackStatus();

	int		mutexLock();
	int		mutexUnlock();
	bool		isMutexLocked();

	pthread_t	io_thread;
	int		io_return;	//????????????????????

	volatile bool	letsShutDown;
	//	volatile bool	valid;					// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	volatile bool dispatch_start;
	volatile bool dispatch_end;
	volatile bool IOService_finish_start;
	volatile bool IOService_finish_end;

	bool		nmc_core;	// false - arm,  true - nmc core (Sparse char)
	int		bINw;		// Integer Size

	std::ostream	*trg_cout;
	FILE		*trg_file;

	int dispatch(); // Thread function
public:
	io_service_fail_t io_service_fail;
	int destructor_force;
	DWORD destructor_time; // default - 10 seconds

	SemihostFile_t	*SemihostFile_table;
	int		SemihostFile_index;

	IO_Service (
		PL_Access *access,	// of the core
		FILE *_file = NULL,	// out print file
		void *_llops = NULL,// bsp interface
		int *error_occur = NULL,// error that occurred
		std::ostream* _cout = &std::cout,
		std::ostream* _cerr = &std::cerr,
		std::istream* _cin = &std::cin
	);
	~IO_Service();

	friend int  IOService_finish(void*v_nms);
	friend void *IOServiceDispatcher(void *v_trg);
};

#endif // __IO_HOST_LIN_H__

