#ifndef __IO_HOST_H__
#define __IO_HOST_H__

#include <stdio.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct IO_Service	IO_Service;

// call IO_Service constructor
IO_Service *IO_ServiceStart(
	PL_Access *access,
	FILE *file,
	void *ops,
	int *err);
	
// call IO_Service destructor
int IO_ServiceStop(
	IO_Service **service,
	int *err);

extern int print_mutex_lock(void);
extern int print_mutex_unlock(void);

// Set attributes of IO_Service destructor
//Attributes
enum Dastruct_Attributes {
	Att_Forse_Destruct = 1, // 0 - finish with error, if running target program
	                        // >0 - ignore running target program
	Att_Time_Destruct =  2, // in milliseconds (default: 10000)
};

int Set_IO_Serv_attribute(
	IO_Service *service,
	DWORD number_attribute,
	DWORD value_attribute
);
// return attribute value or -1 if failed arguments
int Get_IO_Serv_attribute(
	IO_Service *service,
	DWORD number_attribute,
	DWORD *value_attribute
);
// Read error result of ~IO_Service or BSP functions

//typedef struct { // error result
//	int function; // marker of BSP function 
//	int err = 0; // error value
//} io_service_fail_t;
// BSP function
enum BSP_function {
	IO_service_err,
	IO_destruct_err,
	BSP_read,
	BSP_write,
	BSP_status,
	BSP_access,
	BSP_ERROR = 2000
};
// Error result  of funcions IO_ServiceStart and IO_ServiceStop
enum IO_SERV_FAIL {
 IO_SERV_PROG_RUN =1, // destructor is called when target program is still running
 IO_SERV_SIGSEGV =2, // IO_Service function found  Segmentation fault SIGSEGV (Linux)
 IO_SERV_NOT_FINISHED =3, // io_service thread is not finished during set Time_Destruct
 IO_SERV_NO_PROG = 4, // IO_Service: no target-prog has been loaded
 IO_SERV_SECOND = 5, // Second IO_Service with the same core
 IO_SERV_NO_METHOD = 6, // No method to work with board
 IO_SERV_ERROR = 7, // Other errors in IO_Service
 IO_SERV_BSP = 100, // error occurred in BSP read/write functions
};
// return function_error of IO_Service running 
int Get_IO_Serv_Error(
	IO_Service *service,
	DWORD *function,
	DWORD *function_error
);

#ifdef __cplusplus
}; // extern "C"
#endif

#endif // __IO_HOST_H__

