#ifndef __NMC_PRINTF_H__
#define __NMC_PRINTF_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef printf
#undef printf
#endif

#define printf(format, ...)	nmc_printf(format, ##__VA_ARGS__)

int nmc_printf(const char *format, ...);

static inline unsigned int trg_irqDisable_io(void)
{
	unsigned int state;

	asm (
		"delayed callrel 2;\n"
		"pswr clear 0x11E0;\n"
		"nul 32;\n"
		"%0 = [ar7 - 1];\n"
		"ar7 = ar7 - 2;\n"
		:"=r"(state)::
	);

	return state;
}

static inline unsigned int trg_irqSetState_io(unsigned int new_state)
{
	unsigned int old_state;

	asm("%0 = pswr;\n":"=r"(old_state)::);
	asm("pswr = %0;\n"::"r"(new_state):);

	return old_state;
}

#define TRG_ATOMIC_BLOCK_IO() \
	for(unsigned int state = trg_irqDisable_io(), flag = 1; \
		flag; \
		trg_irqSetState_io(state), flag = 0)

#ifdef __cplusplus
};
#endif

#endif // __NMC_PRINTF_H__

