#include "init_code.h"
#include "libload_def.h"
#include "nm6408load_arm.h"

#ifdef __cplusplus
extern "C" {
#endif

void _exit(int result)
{
	struct libload_top *ll_top = (void *)LIBLOAD_DATA_ADDR;
	void (*wait)(int cid, struct libload_top *ll_top);
	volatile struct libload_format *ll_format;
	int cid;

	cid = acl_getClusterID();

	if (cid == NM6408_CCPU)
		ll_format = &ll_top->arm;
	else
		ll_format = &ll_top->cluster[cid].arm;

	ll_format->result = result;
	asm("DMB":::"memory");
	wait = (void *)ll_format->wait_loop;

	wait(cid, ll_top);

	while (1) { asm("WFE"); };
}

#ifdef __cplusplus
};
#endif
