#include "init_code.h"
#include "libload_def.h"
#include "nm6408load_arm.h"

#ifdef __cplusplus
extern "C" {
#endif

int acl_hostSyncArray(int value, void *outArray, unsigned int outLen,
		      void **inArray, unsigned int *inLen)
{
	struct libload_top		*ll_top = (void *)LIBLOAD_DATA_ADDR;
	volatile struct libload_format	*ll_format;
	int				ret_val, tmp;
	int				cid;

	cid = acl_getClusterID();

	if (cid == NM6408_CCPU)
		ll_format = &ll_top->arm;
	else
		ll_format = &ll_top->cluster[cid].arm;

	ll_format->sync[SYNC_TO_PC + SYNC_ADDR] = (unsigned int)outArray;
	ll_format->sync[SYNC_TO_PC + SYNC_LEN] = outLen;
	ll_format->sync[SYNC_TO_PC + SYNC_VAL] = value;

	asm("DMB":::"memory");

	ll_format->sync[SYNC_TO_PC + SYNC_FLAG] = 1;
	asm("DMB":::"memory");

	while (1) {
		tmp = ll_format->sync[SYNC_FROM_PC + SYNC_FLAG];
		if (tmp)
			break;
	}

	asm("":::"memory");

	if (inArray)
		*inArray = (void *)ll_format->sync[SYNC_FROM_PC + SYNC_ADDR];

	if (inLen)
		*inLen = ll_format->sync[SYNC_FROM_PC + SYNC_LEN];

	ret_val = ll_format->sync[SYNC_FROM_PC + SYNC_VAL];

	asm("DMB":::"memory");

	ll_format->sync[SYNC_FROM_PC + SYNC_FLAG] = 0;
	asm("DMB":::"memory");

	while (1) {
		tmp = ll_format->sync[SYNC_TO_PC + SYNC_FLAG];
		if (!tmp)
			break;
	}

	return ret_val;
}

int acl_hostSync(int value) {
	return acl_hostSyncArray(value, (void *)0, 0, (void **)0, (void *)0);
}

#ifdef __cplusplus
};
#endif

