#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

extern void (*__fini_array_start[]) (void) __attribute__((weak));
extern void (*__fini_array_end[]) (void) __attribute__((weak));
extern void _fini(void) asm("_fini");

static void acl_fini_array(void)
{
	size_t count;
	size_t i;

	count = __fini_array_end - __fini_array_start;
	for (i = count; i > 0; i--)
		if (__fini_array_start[i-1])
 			__fini_array_start[i-1]();
		else
			break;

	_fini();
}

extern void (*__preinit_array_start[]) (void) __attribute__((weak));
extern void (*__preinit_array_end[]) (void) __attribute__((weak));
extern void (*__init_array_start[]) (void) __attribute__((weak));
extern void (*__init_array_end[]) (void) __attribute__((weak));
extern void _init(void) asm("_init");

static void acl_init_array(void)
{
	size_t count;
	size_t i;

	count = __preinit_array_end - __preinit_array_start;
	for (i = 0; i < count; i++)
		if (__preinit_array_start[i])
			__preinit_array_start[i]();
		else
			break;

	_init();

	count = __init_array_end - __init_array_start;
	for (i = 0; i < count; i++)
		if (__init_array_start[i])
			__init_array_start[i]();
		else
			break;
}

extern int __real_main(int argc, char *argv[]) __attribute__((weak));

int __wrap_main(int argc, char *argv[])
{
	acl_init_array();

	return __real_main(argc, argv);
}

extern void _exit(int result);

void __wrap_exit(int result)
{
	acl_fini_array();

	_exit(result);
}

#ifdef __cplusplus
};
#endif
