// Settings for libelf and liblib libraries

#ifndef __ELF_SET__H__
#define __ELF_SET__H__

//------------------------------------------------------------------------------
// Host machine data encoding

// Little-endian:
// Intel x32 ("_X86"; "__i386__" - defined in gcc; "_M_IX86" - defined in MSVC)
// Intel x64 ("__x86_64"; "__amd64"; "__x86_64__"; "__amd64__" - defined in gcc)
// ARM ("__arm__" - defined in gcc)
#if defined(_X86) || defined(__i386__) || defined(_M_IX86)\
 || defined(__x86_64) || defined(__amd64) || defined(__x86_64__) || defined (__amd64__)\
 || defined(__arm__) || defined(__e2k__) || defined(__AARCH64ELF__) || defined(__ARM_ARCH_8A)

static const unsigned char _HOST_ENCODING = ELFDATA2LSB;

#else // Little-endian list

// Big-endian:
// E90 ("_E90" - defined in Makefile)
// SPARC ("__sparc__" - defined in gcc)
#if defined(_E90) || defined(__sparc__) // || defined(__powerpc__)

static const unsigned char _HOST_ENCODING = ELFDATA2MSB;

#else // Big-endian list
#error "Needs change data encoding according with native host machine data encoding"
#endif // Big-endian list
#endif // Little-endian list

//------------------------------------------------------------------------------
// Target machine data encoding

#if defined(NM6403) || defined(NM6404) || defined(DSM) || defined(NM6405) || defined(NMC3)

static const unsigned char _TARG_ENCODING = ELFDATA2LSB;

#else
#error "Needs change data encoding according with target machine data encoding"
#endif

//------------------------------------------------------------------------------

#endif // __ELF_SET__H__
