#ifndef __LIBLOAD_H__
#define __LIBLOAD_H__

#include "libload_nm6408.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int		ll_mutex_index[NM6408_BRD_NUM];
extern int		ll_mutex_count;

#define LOCK_LL		pthread_mutex_lock(&ll_mutex)
#define UNLOCK_LL	pthread_mutex_unlock(&ll_mutex)

struct ll_operation {
	int (*get_version)(unsigned int*, unsigned int*);
	int (*get_board_count)(unsigned int*);
	int (*set_channel_EDCL)(const unsigned char[], const unsigned char[]);
	int (*get_board_desc)(unsigned int, PL_Board**);
	int (*close_board_desc)(PL_Board*);
	int (*get_serial_number)(PL_Board*, unsigned long*);
	int (*get_firmware_version)(PL_Board*, unsigned int*, unsigned int*);
	int (*reset_board)(PL_Board*);
	int (*load_init_code)(PL_Board*);
	int (*get_access)(PL_Board*, PL_CoreNo*, PL_Access**);
	int (*type_access)(PL_Access*, DWORD*);
	int (*close_access)(PL_Access*);
	int (*set_program_args)(PL_Access*, const char*);
	int (*load_program)(PL_Access*, const void*, unsigned int);
	int (*load_program_file)(PL_Access*, const char*);
	int (*read_mem_block)(PL_Access*, PL_Word*, PL_Addr, DWORD);
	int (*write_mem_block)(PL_Access*, PL_Word*, PL_Addr, DWORD);
	int (*read_register)(PL_Access*, PL_Word*, PL_Addr);
	int (*write_register)(PL_Access*, PL_Word, PL_Addr);
	int (*sync)(PL_Access*, PL_Word, PL_Word*);
	int (*sync_array)(PL_Access*, PL_Word, PL_Addr, DWORD, PL_Word*, PL_Addr*, DWORD*);
	int (*set_timeout)(DWORD);
	int (*get_region_RPC)(PL_Access*, PL_Addr*, PL_Addr*);
	int (*get_status)(PL_Access*, PL_Word*);
	int (*get_result)(PL_Access*, PL_Word*);
}; // __attribute__((packed, aligned(8)));

#ifdef __cplusplus
} // extern "C"
#endif

#endif // __LIBLOAD_H__
