#ifndef __LIBLOAD_DEF_H__
#define __LIBLOAD_DEF_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "nm6408_map.h"
#include "nm6408_ioctl.h"

#define INTR_VECTORS_AXI_ADDR	0x0
#define INTR_VECTORS_AXI_SIZE	0x800

#define ACCESS_ENTRY_LIMIT	0xFFFFFFFC
#define ACCESS_NO_ENTRY		(~0)

#define PROGRAM_NO_LOAD		0x0
#define PROGRAM_STARTED		0x1
#define PROGRAM_STOPPED		0x2
#define PROGRAM_ABORTED		0x4
#define PROGRAM_IS_RESET	0x8

enum ll_command {
	SW_RESET_BOARD,
	GET_POST_STATUS,
	GET_SERIAL_NMB_LO,
	GET_SERIAL_NMB_HI,
	GET_VERSION_MAJOR,
	GET_VERSION_MINOR,
	GET_LOADER_STATUS,
	SET_LOADER_STATUS,
	GET_ENTRY_POINT,
	SET_ENTRY_POINT,
	SET_RPC_REGION,
	CLR_RPC_REGION,
	GET_RPC_REGION,
	SET_LOADER_COMMAND,
	GET_PROGRAM_RESULT,
	SET_PROCESSOR_BUSY,
	GET_PROCESSOR_BUSY,
	READ_ARM_REGISTER,
	WRITE_ARM_REGISTER,
	READ_MEM_AS_REG,
	WRITE_MEM_AS_REG,
	SET_SYNC_FLAG_TO_PC,
	GET_SYNC_FLAG_TO_PC,
	GET_SYNC_ARRAY_TO_PC,
	SET_SYNC_FLAG_FROM_PC,
	GET_SYNC_FLAG_FROM_PC,
	SET_SYNC_ARRAY_FROM_PC,
	LOAD_INIT_CODE,
	SW_START_CORE,
	SW_GEN_NMI
};

#define LIBLOAD_MAP_ADDR	NM6408_INTERNEL_ADDR
#define LIBLOAD_DATA_ADDR	(CCPU_INBOUND_AXI_BASE | LIBLOAD_MAP_ADDR)
#define LIBLOAD_MAP_SIZE	NM6408_INTERNEL_SIZE

#define LIBLOAD_DATA_READY	(NM6408_INTERNEL_ADDR + 0xF000)

#define SYNC_TO_PC		0
#define SYNC_FROM_PC		4

#define SYNC_FLAG		0
#define SYNC_VAL		1
#define SYNC_ADDR		2
#define SYNC_LEN		3

#define LIBLOAD_NONE_COMMAND	0x0
#define LIBLOAD_RUN_PROGRAM	0x3

#ifdef __cplusplus
} // extern "C"
#endif

#endif // __LIBLOAD_DEF_H__
