#ifndef __LIBLOAD_EDCL_H__
#define __LIBLOAD_EDCL_H__

#include <stdlib.h>
#include <stdbool.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define EDCL_MAC_ADDR_LEN	6

enum CHIP_ENDIANNESS {
	ENDIAN_LITTLE=0,
	ENDIAN_BIG,
};

struct edcl_chip_config {
	int			maxpayload;
	unsigned short		local_port;
	unsigned short		remote_port;
	unsigned char		local_mac[EDCL_MAC_ADDR_LEN];
	unsigned char		remote_mac[EDCL_MAC_ADDR_LEN];

	enum CHIP_ENDIANNESS	endian;
	bool			need_swap;
};

typedef struct edcl_chip_config	libload_edcl_t;

struct EdclPacket {
	unsigned short	offset;
	unsigned int	control;
	unsigned int	address;
} __attribute__((packed));


#define min(a,b) ((a) > (b) ? (b) : (a))

int edcl_test_init(char* ifname, libload_edcl_t* chip_conf, unsigned int *seqnum);
int edcl_get_seqnum(int s_fd, libload_edcl_t* chip_conf, unsigned int *seqnum);

int edcl_read(int s_fd, libload_edcl_t* chip_conf, unsigned int *seqnum,
	      unsigned int address, void* buffer, size_t len);
int edcl_write(int s_fd, libload_edcl_t* chip_conf, unsigned int *seqnum,
	       unsigned int address, void* buffer, size_t len);

#ifdef __cplusplus
} // extern "C"
#endif

#endif // __LIBLOAD_EDCL_H__
