#ifndef __LIBLOAD_NM6408_H__
#define __LIBLOAD_NM6408_H__

#include "nm6408load.h"
#include "libload_def.h"
#include "libload_mutex.h"
#include "libload_edcl.h"

#undef LIBLOAD_DEBUG

#ifdef LIBLOAD_DEBUG
#define	PL_DBG(fmt, ...)	printf("%s:%d:%s: " fmt "\n", __FILE__, \
				__LINE__, __FUNCTION__, ##__VA_ARGS__)
#else
#define PL_DBG(fmt, ...)
#endif

struct PL_Board {
	int		is_used_edcl;

	char		ifname[IFNAMSIZ];
	int		Socket_desc;
	libload_edcl_t  b_config;

	int		File_desc;
	int		b_index;

	libload_mutex_t	*b_mutex_map;

	unsigned int	Count_PL_Access;
	unsigned int	Count_In_Progress;

	unsigned int	Magic_code;
	char		Check_byte;

	unsigned int	reset_count;
	unsigned int	seqnc_count;
	unsigned int	llwind_size;

	PL_Board(int indx);
	~PL_Board();

	int Command(
		    PL_CoreNo *coreNo,
		    DWORD cmd,
		    DWORD *prms
	);
};

#define MAIN_ARGS_MAX	0x100
#define MAIN_ARGS_BUF	0x1000
#define MAIN_ARGS_MGC	0xAABBCCDD

struct PL_Access {
	PL_Board	*board;
	PL_CoreNo	coreNo;

	QWORD		entry_point;
	unsigned int	Count_In_Progress;

	char		*MainARGS;
	char		*MainARGV[MAIN_ARGS_MAX + 1]; 
	int		MainARGC;

	unsigned int	Magic_code;
	char		Check_byte;

	PL_Access(PL_CoreNo *core, PL_Board *brd);
	~PL_Access();

	int Xfer(
		 DWORD *buf,
		 QWORD addr,
		 QWORD load_size,
		 QWORD check_size,
		 int RWX
	);
};

int Check_board(PL_Board *board);
int Check_access(PL_Access *access);

#endif // __LIBLOAD_NM6408_H__
