#include "init_code.h"
#include "libload_def.h"
#include "nm6408load_nmc.h"

#ifdef __cplusplus
extern "C" {
#endif

const char * const BoardName = "MC127.05";

const char *ncl_getBoardName(void)
{
	return BoardName;
}

int ncl_getCoreID(void)
{
	unsigned int	nid;

	nid = *((volatile unsigned int *)0x00020000);
	nid = (nid >> 24) & 0x03;

	return nid;
}

int ncl_getClusterID(void)
{
	unsigned int	cid;

	cid = *((volatile unsigned int *)0x00020000);
	cid = (cid >> 26) & 0x03;

	return cid;
}

void ncl_getProcessorNo(struct ncl_ProcessorNo *ProcessorNo)
{
	if (!ProcessorNo)
		return;

	ProcessorNo->cluster_id = ncl_getClusterID();
	ProcessorNo->core_id = ncl_getCoreID();

	return;
}

void nmc_abort_handler(int id, void *args)
{
	struct libload_top		*ll_top = (void *)(LIBLOAD_DATA_ADDR >> 2);
	volatile struct libload_format	*ll_format;
	unsigned int			tmp;
	int				cid, nid;

	id = (id & 0x00FFFFFF) >> 3;

	if (id >= 4) {
		tmp = id - 4;

		*((volatile unsigned int *)0x0002040C) = (1 << tmp);
		*((volatile unsigned int *)0x0002041C) = (1 << tmp);
		*((volatile unsigned int *)0x00020404) = (1 << tmp);
	}

	cid = ncl_getClusterID();
	nid = ncl_getCoreID();

	ll_format = &ll_top->cluster[cid].nmc[nid];
	if (ll_format->status == PROGRAM_ABORTED)
		return;

	ll_format->result = ((int)args & 0x00FFFFFF) | ((id & 0xFF) << 24);
	tmp = ll_format->result; // barrier

	asm("":::"memory");

	ll_format->status = PROGRAM_ABORTED;
	tmp = ll_format->status; // barrier

	asm("":::"memory");

	return;
}

#ifdef __cplusplus
};
#endif
