.extern _nmc_abort_handler

.extern __main
.extern __bss_table_start
.extern _exit

.global reset

.global hw_init_hook
.set hw_init_hook, reset_handler

.global _nmc_vector_table

.weak __executable_start
.weak start

.weak __reset_stub_begin
.weak __reset_stub_limit

.section .init.stub_start,"ax",@progbits
.align 3
.weak _init
.weak ctor
L1I:	.long L2I
_init:
	[ar7++] = ar6,gr6;
	[ar7++] = ar5,gr5;
	[ar7++] = ar4,gr4;
	[ar7++] = ar3,gr3;
	[ar7++] = ar2,gr2;
	[ar7++] = ar1,gr1;
	[ar7++] = ar0,gr0;
	gr7 = [L1I];

.section .init.stub_end,"ax",@progbits
.align 3
L2I:
	ar0,gr0 = [--ar7];
	ar1,gr1 = [--ar7];
	ar2,gr2 = [--ar7];
	ar3,gr3 = [--ar7];
	ar4,gr4 = [--ar7];
	ar5,gr5 = [--ar7];
	ar6,gr6 = [--ar7];
	return;

.section .fini.stub_start,"ax",@progbits
.align 3
.weak _fini
.weak dtor
L1F:	.long L2F
_fini:
	[ar7++] = ar6,gr6;
	[ar7++] = ar5,gr5;
	[ar7++] = ar4,gr4;
	[ar7++] = ar3,gr3;
	[ar7++] = ar2,gr2;
	[ar7++] = ar1,gr1;
	[ar7++] = ar0,gr0;
	gr7 = [L1F];

.section .fini.stub_end,"ax",@progbits
.align 3
L2F:
	ar0,gr0 = [--ar7];
	ar1,gr1 = [--ar7];
	ar2,gr2 = [--ar7];
	ar3,gr3 = [--ar7];
	ar4,gr4 = [--ar7];
	ar5,gr5 = [--ar7];
	ar6,gr6 = [--ar7];
	return;
	
.section .text.reset_stub,"ax",@progbits
.align 3
__reset_stub_begin:
reset:
	intr clear 0x03C0;
	pswr clear 0x11E0;
	delayed goto start;
	nul 32;

.rept 31
	push ar0, gr0;
	push ar1, gr1;
	nul 32;
	delayed callrel halt_code;
	nul 32;
.endr

.align 3
halt_code:
	ar0,gr0 = [ar7 + -2];
	ar0 = ar0 - 8;
	
	ar1,gr1 = [ar7 + -8];

	[ar7 + -1] = ar0;
	[ar7 + -2] = ar1;

	gr1 = 0x11E0;
	delayed call _nmc_abort_handler with gr0 = gr0 and not gr1;
	ar0 = err_loop;

	[ar7 + -8] = ar0,gr0;

	ar7 = ar7 - 2;
	pop ar1, gr1;
	pop ar0, gr0;

	pswr clear 0x11E0;
	ireturn;
__reset_stub_limit:

.section .text.init_stub,"ax",@progbits
.align 3
start:
reset_handler:
	pswr set 0x1000;
	gr0 = 0x10;
	[0x21000] = gr0;
	gr1 = 0x8;

wait_set:
	gr0 = [0x21000] with gr0 and gr1;
	if =0 skip wait_set;

	gr4 = 0xFFFFFFFF;
	[_nmc_vector_table] = gr4;

	gr0 = [init_origin_start];
	gr1 = [init_vector_begin];
	gr2 = [init_vector_limit];
	gr3 = [init_execut_start];

	with gr4 = gr1 - gr2;
	if =0 goto skip_vectors;

	with gr4 = gr1 - gr3;
	if =0 goto copy_vectors;

	with gr4 = gr0 - gr3;
	if <>0 goto copy_vectors; 

	with gr3;
	if =0 goto err_loop; 

copy_vectors:
	gr4 = 0x00000000;
	[_nmc_vector_table] = gr4;

	ar1 = gr1;
	ar2 = ar1 + 8;
	ar3 = ar1;
#if 0

.rept 4
	ar4,gr4 = [ar2++];
	[ar3++] = ar4,gr4;
.endr

	ar4,gr4 = [ar1 + 4];
	ar3 = gr4;
	ar3 = ar3 + 8;
	gr4 = ar3;
	[ar1 + 4] = ar4,gr4;

#endif
	with gr1;
	if =0 delayed goto skip_vectors;
	gr3 = gr2 - gr1;
	gr3 = gr3 >> 1;

	ar2 = 0x00000000;
	with gr3--;

do_copy:
	if <>0 delayed skip do_copy with gr3--;
	ar4,gr4 = [ar1++];
	[ar2++] = ar4,gr4;

skip_vectors:
	gr4 = [_nmc_vector_table];
	with gr4;
	if <>0 goto call_main;

	[0x2040E] = gr3;

	gr3 = 0x0FFFFFFF;
	[0x2041C] = gr3;
	[0x20404] = gr3;
	
	intr clear 0x3C0;

	gr3 = 0x000003E1;
	[0x2040A] = gr3;

	pswr set 0x0C0;

call_main:
	gr3 = reset_handler;
	with gr4 = gr3 - gr0;
	if <>0 goto init_exit;

	ar0 = __bss_table_start with gr0 -= gr0;

bss_table_loop:
	ar1,gr1 = [ar0++];
	gr2 = ar1;

	with gr2;
	if =0 goto bss_loop_done with gr1 >>= 2;

zero_fill_loop:
	if =0 goto bss_table_loop;
	[ar1++] = gr0 with gr1--;
	goto zero_fill_loop;

bss_loop_done:
	gr0 = 0xAABBCCDD;
	ar7,gr7 = [STACK];

	ar0 = 0 with gr7 = gr7 - gr0;
	if =0 delayed skip stack_ready with gr0 -= gr0;
	[STACK] = ar0, gr0;

	ar7 = STACK + 2;
	gr7 = 0;

stack_ready:
	call __main;
	push ar7,gr7;
	call _exit;

	goto err_loop;

init_exit:
	return;

.align 3
err_loop:
	delayed halt;
	pswr set 0x10C0;
	delayed skip err_loop;
	gr0 = gr0 noflags;
	gr0 = gr0 noflags;

init_origin_start: .long start
init_execut_start: .long __executable_start

init_vector_begin: .long __reset_stub_begin
init_vector_limit: .long __reset_stub_limit

_nmc_vector_table: .long 0xFFFFFFFF

.section .stack,"wa",@nobits
.align 3
STACK: #.skip 0x1000<<2
.weak STACK

