#include "init_code.h"
#include "libload_def.h"
#include "nm6408load_nmc.h"

#ifdef __cplusplus
extern "C" {
#endif

int ncl_hostSyncArray(int value, void *outArray, unsigned int outLen,
		      void **inArray, unsigned int *inLen)
{
	struct libload_top		*ll_top = (void *)(LIBLOAD_DATA_ADDR >> 2);
	volatile struct libload_format	*ll_format;
	int				ret_val, tmp;
	int				cid, nid;

	cid = ncl_getClusterID();
	nid = ncl_getCoreID();

	ll_format = &ll_top->cluster[cid].nmc[nid];

	ll_format->sync[SYNC_TO_PC + SYNC_ADDR] = (unsigned int)outArray;
	ll_format->sync[SYNC_TO_PC + SYNC_LEN] = outLen;
	ll_format->sync[SYNC_TO_PC + SYNC_VAL] = value;
	tmp = ll_format->sync[SYNC_TO_PC + SYNC_VAL]; // barrier

	asm("":::"memory");

	ll_format->sync[SYNC_TO_PC + SYNC_FLAG] = 1;
	tmp = ll_format->sync[SYNC_TO_PC + SYNC_FLAG]; // barrier

	asm("":::"memory");

	while (1) {
		tmp = ll_format->sync[SYNC_FROM_PC + SYNC_FLAG];
		if (tmp)
			break;
	}

	asm("":::"memory");

	if (inArray)
		*inArray = (void *)ll_format->sync[SYNC_FROM_PC + SYNC_ADDR];

	if (inLen)
		*inLen = ll_format->sync[SYNC_FROM_PC + SYNC_LEN];

	ret_val = ll_format->sync[SYNC_FROM_PC + SYNC_VAL];

	asm(
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;\n"
		"nul;":::"memory"
	); // barrier

	ll_format->sync[SYNC_FROM_PC + SYNC_FLAG] = 0;
	tmp = ll_format->sync[SYNC_FROM_PC + SYNC_FLAG]; // barrier

	asm("":::"memory");

	while (1) {
		tmp = ll_format->sync[SYNC_TO_PC + SYNC_FLAG];
		if (!tmp)
			break;
	}

	return ret_val;
}

int ncl_hostSync(int value) {
	return ncl_hostSyncArray(value, (void *)0, 0, (void **)0, (void *)0);
}

#ifdef __cplusplus
};
#endif

