#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

extern void (*_fini_array_start[]) (void) __attribute__((weak));
extern void (*_fini_array_end[]) (void) __attribute__((weak));
extern void fini(void);

static void ncl_fini_array(void)
{
	size_t count;
	size_t i;

	count = _fini_array_end - _fini_array_start;
	for (i = count; i > 0; i--)
		if (_fini_array_start[i-1])
 			_fini_array_start[i-1]();
		else
			break;

	fini();
}

extern void (*_preinit_array_start[]) (void) __attribute__((weak));
extern void (*_preinit_array_end[]) (void) __attribute__((weak));
extern void (*_init_array_start[]) (void) __attribute__((weak));
extern void (*_init_array_end[]) (void) __attribute__((weak));
extern void init(void);

static void ncl_init_array(void)
{
	size_t count;
	size_t i;

	count = _preinit_array_end - _preinit_array_start;
	for (i = 0; i < count; i++)
		if (_preinit_array_start[i])
			_preinit_array_start[i]();
		else
			break;

	init();

	count = _init_array_end - _init_array_start;
	for (i = 0; i < count; i++)
		if (_init_array_start[i])
			_init_array_start[i]();
		else
			break;
}

extern int _real___main(int argc, char *argv[]) __attribute__((weak));

int _wrap___main(int argc, char *argv[])
{
	ncl_init_array();

	return _real___main(argc, argv);
}

extern void __attribute__((noreturn)) stop(void) asm("stop");

void _exit(int result) __attribute__((weak, optimize("O0")));
void _exit(int result)
{
	register int gr7 asm("gr7");

	gr7 = result;

	stop();
}

void _wrap__exit(int result)
{
	ncl_fini_array();

	_exit(result);
}

#ifdef __cplusplus
};
#endif

