// Loader for NM6408 based board
// Settings

#if defined(MC12705)

#include "mc12705load.h"

#define DEVICE_NAME "mc12705"
#define DEVICE_NAME_STR "MC127.05"

#elif defined(NM_CARD)

#include "nm_card_load.h"

#define DEVICE_NAME "nm_card_"
#define DEVICE_NAME_STR "NM_Card"

#elif defined(NM_MEZZO)

#include "nm_mezzo_load.h"

#define DEVICE_NAME "nm_mezzo_"
#define DEVICE_NAME_STR "NM_Mezzo"

#elif defined(NM_QUAD)

#include "nm_quad_load.h"

#define DEVICE_NAME "nm_quad_"
#define DEVICE_NAME_STR "NM_Quad"

#elif defined(NEURO_MEZZANINE)

#include "neuro_mezzanine_load.h"

#define DEVICE_NAME "neuro_mezzanine_"
#define DEVICE_NAME_STR "NeuroMezzanine"

#else

#error "Unknow device!"

#endif

#include "io_host.h"

#define COPYRIGHT_STR "(C) 2023 RC Module Inc"

#define HOST_MAC_ADDRESS_DEFAULT { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
#define CHIP_MAC_ADDRESS_DEFAULT { 0xEC, 0x17, 0x66, 0x64, 0x08, 0x00 }

const PL_CoreNo Access_core_default = {-1, -1};

const PL_Addr Dump_memory_begin_default = 0x00000000; // Address in processor memory
const DWORD Dump_memory_size_default = 0x4000; // In 32 bit words

const unsigned int MAX_TIMEOUT = 1000000000; // (mS)

void Display_version(int argc, char **argv);
void Parse_command_line(int argc, char **argv);
int Dump_shared_memory(const char *ext);
int Receive_binary_dump_from_board();
int Send_binary_file_to_board();
int Get_sect_prm(const char *Sect_name, PL_Addr *Sect_addr, PL_Addr *Sect_size);

#ifdef __cplusplus
extern "C" {
#endif

extern int PL_SetProgramArgs(PL_Access *access, const char *mainargs);

#ifdef __cplusplus
};
#endif

