#!/bin/bash +e

CUR_DIR=`pwd`
BSP_DIR=`dirname $(readlink -f $0)`

if [[ "$1" != "mc12705" ]] && [[ "$1" != "nm_card" ]] && [[ "$1" != "nm_mezzo" ]] \
&& [[ "$1" != "NeuroMezzanine" ]] && [[ "$1" != "nm_quad" ]]; then
	echo "ERROR: Unknown board!"
	exit -1
fi

(/usr/sbin/dkms --version 1>/dev/null 2>&1) || { echo "ERROR: Need install DKMS";  exit -1; }
cd "$BSP_DIR/board-${1}"

if [ -f "VERSION.txt" ]
then
	export VERSION_MAJOR=$(sed -e "s/\./\ /g" VERSION.txt | awk '{print $1}')
	export VERSION_MINOR=$(sed -e "s/\./\ /g" VERSION.txt | awk '{print $2}')

	export CUR_DATE=$(sed -e "s/\./\ /g" VERSION.txt | awk '{print $3}')
	export GIT_REVD=$(sed -e "s/\./\ /g" VERSION.txt | awk '{print $4}')
else
	export VERSION_MAJOR=$(grep -e "MAJOR" .gitkeep | awk '{print $2}')
	export VERSION_MINOR=$(grep -e "MINOR" .gitkeep | awk '{print $2}')
fi

EXIT_CODE=0
cd ..
(/usr/sbin/dkms status | grep -i ${1} 1>/dev/null 2>&1) && { ./driver/dkms.sh remove ${1} || EXIT_CODE=$?; }
if [ $EXIT_CODE -ne 0 ]
then
	echo "ERROR: while remove driver"
	cd "$CUR_DIR"
	exit -1
fi

EXIT_CODE=0
(/sbin/lsmod | grep -i ${1} 1>/dev/null 2>&1) && { /sbin/rmmod ${1} || EXIT_CODE=$?; }
if [ $EXIT_CODE -ne 0 ]
then
	echo "ERROR: while unload driver"
	cd "$CUR_DIR"
	exit -1
fi

#pushd libload/${1}
#EXIT_CODE=0
#make uninstall || EXIT_CODE=$?
#popd

#if [ $EXIT_CODE -ne 0 ]
#then
#	echo "ERROR: Can't delete libload"
#	cd "$CUR_DIR"
#	exit -1
#fi
rm -rf /usr/local/rc_module/temperature_monitor/
rm -rf "/usr/local/rc_module/board-${1}"
rmdir "/usr/local/rc_module" 1>/dev/null 2>&1
rm -f /etc/profile.d/$1-2.1.sh
rm -f /usr/include/$1_load.h
rm -f /usr/lib/lib$1_load*
udevadm control --reload-rules && udevadm trigger
cd "$CUR_DIR"

exit 0

